"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AppContext = AppContext;
exports.useAppContext = useAppContext;
exports.useTranslate = useTranslate;
exports.useLinkComponent = useLinkComponent;
exports.useGeolocation = useGeolocation;
exports.AppContextContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _HeadingGroup = require("../HeadingGroup");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var AppContextContext = /*#__PURE__*/(0, _react.createContext)(null);
exports.AppContextContext = AppContextContext;

function AppContext(_ref) {
  var children = _ref.children,
      linkComponent = _ref.linkComponent,
      geolocation = _ref.geolocation,
      translate = _ref.translate;
  var context = (0, _react.useMemo)(function () {
    return {
      translate: translate,
      linkComponent: linkComponent,
      geolocation: geolocation
    };
  }, [translate, linkComponent, geolocation]);
  return /*#__PURE__*/_react["default"].createElement(AppContextContext.Provider, {
    value: context
  }, /*#__PURE__*/_react["default"].createElement(_HeadingGroup.HeadingGroup, null, children));
}

function useAppContext() {
  var context = (0, _react.useContext)(AppContextContext);

  if (context == null) {
    throw new Error('No app context available');
  }

  return context;
}

function useTranslate() {
  return useAppContext().translate;
}

function useLinkComponent() {
  return useAppContext().linkComponent;
}

function useGeolocation() {
  return useAppContext().geolocation;
}