"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Breadcrumbs = Breadcrumbs;
exports.Marker = Marker;

var _react = _interopRequireDefault(require("react"));

var _Icon = require("../Icon");

var _Text = require("../Text");

var _Theme = require("../Theme");

var _ = require("..");

var _Breadcrumbs = _interopRequireDefault(require("./Breadcrumbs.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* eslint-disable jsx-a11y/no-redundant-roles */
var NUMBER_STYLE_MAP = {
  none: function none() {
    return null;
  },
  decimal: function decimal(index) {
    return /*#__PURE__*/_react["default"].createElement(Marker, null, index.toString());
  },
  decimalLeadingZero: function decimalLeadingZero(index) {
    return /*#__PURE__*/_react["default"].createElement(Marker, null, index.toString().padStart(2, '0'));
  }
};

function Breadcrumbs(_ref) {
  var active = _ref.active,
      breadcrumbs = _ref.breadcrumbs;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.buyerJourney,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.numberStyle,
      numberStyle = _useThemeConfiguratio3 === void 0 ? 'none' : _useThemeConfiguratio3,
      _useThemeConfiguratio4 = _useThemeConfiguratio2.chevronIconSeparator,
      chevronIconSeparator = _useThemeConfiguratio4 === void 0 ? true : _useThemeConfiguratio4,
      typographyStyle = _useThemeConfiguratio2.typographyStyle;

  return (
    /*#__PURE__*/
    // eslint-disable-next-line @shopify/jsx-no-hardcoded-content
    _react["default"].createElement("nav", {
      "aria-label": "Breadcrumbs"
    }, /*#__PURE__*/_react["default"].createElement("ol", {
      className: _Breadcrumbs["default"].Breadcrumbs,
      role: "list"
    }, breadcrumbs.map(function (_ref2, index) {
      var id = _ref2.id,
          to = _ref2.to,
          disabled = _ref2.disabled,
          content = _ref2.content;
      var showSeparator = breadcrumbs.length !== index + 1;
      var isActive = active === id;
      var isClickable = !isActive && !disabled;
      var ariaCurrent = isActive ? 'step' : false;
      var marker = NUMBER_STYLE_MAP[numberStyle](index + 1);
      var breadcrumbContent = isClickable ? /*#__PURE__*/_react["default"].createElement(_Text.Text, {
        size: "small",
        style: typographyStyle
      }, /*#__PURE__*/_react["default"].createElement(_.Link, {
        to: to
      }, marker, content)) : /*#__PURE__*/_react["default"].createElement(_Text.Text, {
        emphasized: isActive,
        subdued: !isActive,
        size: "small",
        style: typographyStyle
      }, marker, content);
      return /*#__PURE__*/_react["default"].createElement("li", {
        className: _Breadcrumbs["default"].Item,
        key: id,
        "aria-current": ariaCurrent
      }, breadcrumbContent, showSeparator && /*#__PURE__*/_react["default"].createElement("span", {
        className: _Breadcrumbs["default"].Separator
      }, chevronIconSeparator && /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
        source: "chevronRight",
        size: "small",
        appearance: "subdued"
      })));
    })))
  );
}

function Marker(_ref3) {
  var children = _ref3.children;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: _Breadcrumbs["default"].Marker
  }, children);
}