"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = void 0;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _forms = require("../../utilities/forms");

var _AppContext = require("../AppContext");

var _transition = require("../../utilities/transition");

var _Spinner = require("../Spinner");

var _Link = require("../Link");

var _legacy = require("../../utilities/legacy");

var _mediaQuery = require("../../utilities/media-query");

var _Connected = require("../Connected");

var _Theme = require("../Theme");

var _responsive = require("../../utilities/responsive");

var _typographyStyles = _interopRequireDefault(require("../../utilities/typography-styles.css"));

var _Button = _interopRequireDefault(require("./Button.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Button = /*#__PURE__*/(0, _react.forwardRef)(function Button(_ref, ref) {
  var children = _ref.children,
      _ref$kind = _ref.kind,
      kind = _ref$kind === void 0 ? 'primary' : _ref$kind,
      _ref$submit = _ref.submit,
      submit = _ref$submit === void 0 ? false : _ref$submit,
      disabled = _ref.disabled,
      onPress = _ref.onPress,
      to = _ref.to,
      _ref$loading = _ref.loading,
      loading = _ref$loading === void 0 ? false : _ref$loading,
      loadingLabel = _ref.loadingLabel,
      accessibilityLabel = _ref.accessibilityLabel,
      _ref$fill = _ref.fill,
      fill = _ref$fill === void 0 ? false : _ref$fill,
      appearance = _ref.appearance,
      onMouseEnter = _ref.onMouseEnter,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'base' : _ref$size;
  var href = disabled ? undefined : to;
  var onClick = disabled ? undefined : function () {
    return onPress === null || onPress === void 0 ? void 0 : onPress();
  };
  var refsSetter = (0, _react.useCallback)(function (instance) {
    if (typeof ref === 'function') {
      ref(instance);
    } else if (ref) {
      ref.current = instance;
    }
  }, [ref]);
  var translate = (0, _AppContext.useTranslate)();
  var prefersReducedMotion = (0, _mediaQuery.usePrefersReducedMotion)();
  var transition = (0, _transition.useTransition)(loading, {
    enter: 'slow'
  });
  var connected = (0, _Connected.useConnected)();
  var responsiveSizes = (0, _responsive.useResponsive)({
    size: size
  });

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.primaryButton,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.style,
      primaryStyle = _useThemeConfiguratio3 === void 0 ? 'fill' : _useThemeConfiguratio3,
      _useThemeConfiguratio4 = _useThemeConfiguratio2.border,
      primaryBorder = _useThemeConfiguratio4 === void 0 ? 'none' : _useThemeConfiguratio4,
      primaryTypographyStyle = _useThemeConfiguratio2.typographyStyle,
      _useThemeConfiguratio5 = _useThemeConfiguratio2.loadingStyle,
      primaryLoading = _useThemeConfiguratio5 === void 0 ? 'spinner' : _useThemeConfiguratio5,
      _useThemeConfiguratio6 = _useThemeConfiguratio.secondaryButton,
      _useThemeConfiguratio7 = _useThemeConfiguratio6.style,
      secondaryStyle = _useThemeConfiguratio7 === void 0 ? 'inverse' : _useThemeConfiguratio7,
      _useThemeConfiguratio8 = _useThemeConfiguratio6.border,
      secondaryBorder = _useThemeConfiguratio8 === void 0 ? 'full' : _useThemeConfiguratio8,
      secondaryTypographyStyle = _useThemeConfiguratio6.typographyStyle,
      _useThemeConfiguratio9 = _useThemeConfiguratio6.loadingStyle,
      secondaryLoading = _useThemeConfiguratio9 === void 0 ? 'spinner' : _useThemeConfiguratio9,
      _useThemeConfiguratio10 = _useThemeConfiguratio.link,
      plainColorHovered = _useThemeConfiguratio10.colorHovered,
      linkTypographyStyle = _useThemeConfiguratio10.typographyStyle;

  var form = (0, _forms.useContainingForm)();
  var isSecondary = kind === 'secondary';
  var style = isSecondary ? secondaryStyle : primaryStyle;
  var border = isSecondary ? secondaryBorder : primaryBorder;
  var typographyStyle = isSecondary ? secondaryTypographyStyle : primaryTypographyStyle;
  var loadingStyle = isSecondary ? secondaryLoading : primaryLoading;
  var isPlain = kind === 'plain' || style === 'plain';
  var classes = (0, _cssUtilities.classNames)(_Button["default"].Button, kind && !isPlain && _Button["default"][(0, _cssUtilities.variationName)('kind', kind)], responsiveSizes && !isPlain && responsiveSizes.map(function (className) {
    return _Button["default"][className];
  }), border && !isPlain && _Button["default"][(0, _cssUtilities.variationName)('border', border)], style && !isPlain && _Button["default"][(0, _cssUtilities.variationName)('style', style)], appearance && _Button["default"][(0, _cssUtilities.variationName)('appearance', appearance)], isPlain && _Button["default"].stylePlain, isPlain && plainColorHovered && _Button["default"][(0, _cssUtilities.variationName)('stylePlainColorHovered', plainColorHovered)], fill && _Button["default"].fill, disabled && _Button["default"].disabled, loading && _Button["default"][(0, _cssUtilities.variationName)('loading', loadingStyle)], loading && loadingStyle === 'spinner' && _Button["default"][(0, _cssUtilities.variationName)('loading-transition', transition)], !isPlain && typographyStyle && _typographyStyles["default"][typographyStyle], isPlain && linkTypographyStyle && _typographyStyles["default"][linkTypographyStyle], connected && _Button["default"].connected,
  /* Basic theming for older browsers that do not support CSS Custom Properties: */
  _legacy.button, kind === 'primary' && _legacy.buttonPrimary, kind === 'secondary' && _legacy.buttonSecondary, appearance === 'critical' && _legacy.buttonCritical, kind === 'plain' && appearance === 'critical' && _legacy.colorCriticalAccent);
  var normalizedLoadingLabel = loadingLabel ? loadingLabel : translate('processing');
  var contentClassNames = (0, _cssUtilities.classNames)(_Button["default"].Content);

  var content = /*#__PURE__*/_react["default"].createElement("span", {
    className: contentClassNames
  }, loading && loadingStyle === 'progressBar' && prefersReducedMotion ? normalizedLoadingLabel : children);

  var type = submit ? 'submit' : 'button';
  var loadingMarkup = loadingStyle === 'spinner' ? /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _cssUtilities.classNames)(_Button["default"].LoadingContent, !prefersReducedMotion && _Button["default"].Spinner)
  }, /*#__PURE__*/_react["default"].createElement(_Spinner.Spinner, {
    size: "small",
    color: "inherit",
    accessibilityLabel: normalizedLoadingLabel
  })) : /*#__PURE__*/_react["default"].createElement("span", {
    className: _Button["default"].ProgressBar
  });

  if (href) {
    return /*#__PURE__*/_react["default"].createElement(_Link.UnstyledLink, {
      to: href,
      className: classes,
      onPress: onPress,
      ariaBusy: loading,
      ariaLive: loading ? 'assertive' : 'polite',
      ariaLabel: accessibilityLabel
    }, content, loading && loadingMarkup);
  }

  return /*#__PURE__*/_react["default"].createElement("button", {
    type: type,
    form: submit && (form === null || form === void 0 ? void 0 : form.nested) ? form.id : undefined,
    className: classes,
    disabled: disabled || loading,
    onClick: onClick,
    "aria-busy": loading || undefined,
    "aria-live": loading ? 'assertive' : undefined,
    "aria-label": accessibilityLabel,
    ref: refsSetter,
    onMouseEnter: onMouseEnter
  }, content, loading && loadingMarkup);
});
exports.Button = Button;