"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AllButtons = exports.ButtonStory = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _ButtonGroup = require("../ButtonGroup");

var _Heading = require("../Heading");

var _BlockStack = require("../BlockStack");

var _TextBlock = require("../TextBlock");

var _TextContainer = require("../TextContainer");

var _Divider = require("../Divider");

var _Banner = require("../Banner");

var _InlineStack = require("../InlineStack");

var _View = require("../View");

var _Button = require("./Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _Button.Button,
  title: 'checkout-web-ui/Button',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('primaryButton', 'secondaryButton')],
  argTypes: {
    kind: {
      control: {
        type: 'select',
        options: [undefined, 'primary', 'secondary', 'plain']
      }
    },
    appearance: {
      control: {
        type: 'select',
        options: [undefined, 'monochrome', 'critical']
      }
    },
    size: {
      control: {
        type: 'select',
        options: [undefined, 'base', 'large']
      }
    }
  }
};
var _default = meta;
exports["default"] = _default;

var ButtonStory = function ButtonStory(args) {
  return /*#__PURE__*/_react["default"].createElement(_Button.Button, args, "Button");
};

exports.ButtonStory = ButtonStory;
ButtonStory.args = {
  kind: 'primary',
  size: 'base',
  appearance: undefined,
  to: 'javascript:;',
  fill: false,
  loading: false,
  loadingLabel: 'Processing…',
  accessibilityLabel: '',
  disabled: false
};
ButtonStory.story = {
  name: 'Button'
};
var content = 'Pay now';

var AllButtons = function AllButtons() {
  return /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, "Type"), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, {
    subdued: true
  }, "primary - secondary - plain")), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "primary"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain"
  }, content)), /*#__PURE__*/_react["default"].createElement(_Divider.Divider, null), /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, "Size"), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, {
    subdued: true
  }, "base - large - extraLarge")), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, null, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    size: "large"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    size: "extraLarge"
  }, content)), /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, "Responsive size"), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, {
    subdued: true
  }, "Default: ", /*#__PURE__*/_react["default"].createElement("code", null, "extraLarge"), /*#__PURE__*/_react["default"].createElement("br", null), " Media small: ", /*#__PURE__*/_react["default"].createElement("code", null, "large"), /*#__PURE__*/_react["default"].createElement("br", null), " Media medium: ", /*#__PURE__*/_react["default"].createElement("code", null, "base"), /*#__PURE__*/_react["default"].createElement("br", null), " Media large: ", /*#__PURE__*/_react["default"].createElement("code", null, "base"))), /*#__PURE__*/_react["default"].createElement(_View.View, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    size: {
      base: 'extraLarge',
      small: 'large',
      medium: 'base',
      large: 'base'
    }
  }, content)), /*#__PURE__*/_react["default"].createElement(_Divider.Divider, null), /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, "Appearance"), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, {
    subdued: true
  }, "monochrome - critical")), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content)), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    appearance: "critical"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    appearance: "critical"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    appearance: "critical"
  }, content)), /*#__PURE__*/_react["default"].createElement(_Divider.Divider, null), /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, "Disabled"), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    disabled: true
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    disabled: true
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    disabled: true
  }, content)), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    disabled: true,
    appearance: "monochrome"
  }, content)), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    disabled: true,
    appearance: "critical"
  }, content)), /*#__PURE__*/_react["default"].createElement(_Divider.Divider, null), /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, "Loading"), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    disabled: true
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    kind: "secondary",
    disabled: true
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    kind: "plain",
    disabled: true
  }, content)), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    kind: "secondary",
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    kind: "plain",
    disabled: true,
    appearance: "monochrome"
  }, content)), /*#__PURE__*/_react["default"].createElement(_ButtonGroup.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    kind: "secondary",
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    loading: true,
    kind: "plain",
    disabled: true,
    appearance: "critical"
  }, content)), /*#__PURE__*/_react["default"].createElement(_Divider.Divider, null), /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, "Appearance"), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, {
    subdued: true
  }, "monochrome inside Banner")), /*#__PURE__*/_react["default"].createElement(_Banner.Banner, {
    status: "info",
    title: "This is a title"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))), /*#__PURE__*/_react["default"].createElement(_Banner.Banner, {
    status: "warning",
    title: "This is a title"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))), /*#__PURE__*/_react["default"].createElement(_Banner.Banner, {
    status: "critical",
    title: "This is a title"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))), /*#__PURE__*/_react["default"].createElement(_Banner.Banner, {
    status: "success",
    title: "This is a title"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))));
};

exports.AllButtons = AllButtons;