"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChoiceList = ChoiceList;
exports.Choice = Choice;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Checkbox = require("../Checkbox");

var _RadioControl = require("../RadioControl");

var _ChoiceList = _interopRequireDefault(require("./ChoiceList.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var ChoiceListContext = /*#__PURE__*/(0, _react.createContext)(null);

function useChoiceList() {
  var context = (0, _react.useContext)(ChoiceListContext);

  if (context == null) {
    throw new Error('No `ChoiceList` found in context');
  }

  return context;
}

// TODO: consider adding error prop
function ChoiceList(_ref) {
  var name = _ref.name,
      value = _ref.value,
      onChange = _ref.onChange,
      children = _ref.children;

  var onChangeHandler = function onChangeHandler(id, checked) {
    onChange(getNewValue(value, checked, id));
  };

  return /*#__PURE__*/_react["default"].createElement(ChoiceListContext.Provider, {
    value: {
      name: name,
      value: value,
      onChangeHandler: onChangeHandler
    }
  }, children);
}

function Choice(_ref2) {
  var id = _ref2.id,
      disabled = _ref2.disabled,
      accessibilityLabel = _ref2.accessibilityLabel,
      children = _ref2.children;

  var _useChoiceList = useChoiceList(),
      name = _useChoiceList.name,
      onChangeHandler = _useChoiceList.onChangeHandler,
      value = _useChoiceList.value;

  var Control = isString(value) ? _RadioControl.RadioControl : _Checkbox.CheckboxControl;
  var checked = isString(value) ? value === id : value.includes(id);
  var className = (0, _cssUtilities.classNames)(_ChoiceList["default"].Label, disabled && _ChoiceList["default"]['Label-isDisabled']);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _ChoiceList["default"].Wrapper
  }, /*#__PURE__*/_react["default"].createElement(Control, {
    id: id,
    name: name,
    disabled: disabled,
    checked: checked,
    onChange: function onChange(value) {
      onChangeHandler(id, value);
    }
  }), /*#__PURE__*/_react["default"].createElement("label", {
    htmlFor: id,
    className: className,
    "aria-label": accessibilityLabel ? accessibilityLabel : undefined
  }, children));
}

function getNewValue(value, checked, id) {
  if (checked === true) {
    return isString(value) ? id : [].concat(_toConsumableArray(value), [id]);
  }

  return isString(value) ? '' : value.filter(function (el) {
    return el !== id;
  });
}

function isString(value) {
  return typeof value === 'string';
}