"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Inline = exports.WithAccessibilityLabel = exports.Disabled = exports.MultipleValues = exports.SingleValue = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _BlockStack = require("../BlockStack");

var _InlineStack = require("../InlineStack");

var _ChoiceList = require("./ChoiceList");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _ChoiceList.ChoiceList,
  subcomponents: {
    Choice: _ChoiceList.Choice
  },
  title: 'checkout-web-ui/ChoiceList',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)()],
  args: {
    name: 'Choice',
    value: 'first'
  }
};
var _default = meta;
exports["default"] = _default;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_ChoiceList.ChoiceList, args);
};

var SingleValue = Template.bind({});
exports.SingleValue = SingleValue;
SingleValue.args = {
  children: /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "first"
  }, "First choice"), /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "second"
  }, "Second choice"))
};
var MultipleValues = Template.bind({});
exports.MultipleValues = MultipleValues;
MultipleValues.args = {
  children: /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "first"
  }, "First choice"), /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "second"
  }, "Second choice")),
  value: ['first']
};
var Disabled = Template.bind({});
exports.Disabled = Disabled;
Disabled.args = {
  children: /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "first",
    disabled: true
  }, "First choice"), /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "second"
  }, "Second choice"))
};
var WithAccessibilityLabel = Template.bind({});
exports.WithAccessibilityLabel = WithAccessibilityLabel;
WithAccessibilityLabel.args = {
  children: /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "first",
    accessibilityLabel: "This is a description for screen readers"
  }, "First choice"), /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "second"
  }, "Second choice"))
};
var Inline = Template.bind({});
exports.Inline = Inline;
Inline.args = {
  children: /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "first"
  }, "First choice"), /*#__PURE__*/_react["default"].createElement(_ChoiceList.Choice, {
    id: "second"
  }, "Second choice"))
};