"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Collapsible = Collapsible;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _transition = require("../../utilities/transition");

var _Collapsible = _interopRequireDefault(require("./Collapsible.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function Collapsible(_ref) {
  var id = _ref.id,
      open = _ref.open,
      _ref$minSize = _ref.minSize,
      minSize = _ref$minSize === void 0 ? 0 : _ref$minSize,
      fade = _ref.fade,
      children = _ref.children;
  var transition = (0, _transition.useTransition)(open, 'slow');
  var div = (0, _react.useRef)(null);
  var lazyCssHeight = new Map([['enter', function () {
    return {
      height: minSize
    };
  }], ['entering', function () {
    var _div$current;

    return {
      height: div === null || div === void 0 ? void 0 : (_div$current = div.current) === null || _div$current === void 0 ? void 0 : _div$current.clientHeight
    };
  }], ['entered', function () {
    return {
      height: 'auto'
    };
  }], ['exit', function () {
    var _div$current2;

    return {
      height: div === null || div === void 0 ? void 0 : (_div$current2 = div.current) === null || _div$current2 === void 0 ? void 0 : _div$current2.clientHeight
    };
  }], ['exiting', function () {
    return {
      height: minSize
    };
  }], ['exited', function () {
    return {
      height: minSize
    };
  }]]);
  var showFade = !open && fade;
  return /*#__PURE__*/_react["default"].createElement("div", {
    id: id,
    style: _objectSpread({}, lazyCssHeight.get(transition)()),
    className: (0, _cssUtilities.classNames)(_Collapsible["default"].Collapsible, showFade && _Collapsible["default"].fade),
    "aria-expanded": open,
    hidden: transition === 'exited' && minSize === 0
  }, /*#__PURE__*/_react["default"].createElement("div", {
    ref: div
  }, children));
}