"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.accordion = exports.basicCollapsible = exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _testUtilities = require("../../test-utilities");

var _storybookUtilities = require("../../storybook-utilities");

var _BlockSpacer = require("../BlockSpacer");

var _Button = require("../Button");

var _Text = require("../Text");

var _View = require("../View");

var _Collapsible = require("./Collapsible");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// eslint-disable-next-line import/no-anonymous-default-export
var _default = {
  title: 'checkout-web-ui/Collapsible',
  component: _Collapsible.Collapsible,
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)()]
};
exports["default"] = _default;

var basicCollapsible = function basicCollapsible(args) {
  return /*#__PURE__*/_react["default"].createElement(Story, args);
};

exports.basicCollapsible = basicCollapsible;
basicCollapsible.args = {
  id: 'basic-collapsible',
  minSize: 0,
  fade: false
};
basicCollapsible.story = {
  name: 'Collapsible'
};

var content = _testUtilities.faker.lorem.paragraphs(3);

function Story(_ref) {
  var id = _ref.id,
      _ref$minSize = _ref.minSize,
      minSize = _ref$minSize === void 0 ? 0 : _ref$minSize,
      fade = _ref.fade;

  var _useState = (0, _react.useState)(true),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var handleToggle = (0, _react.useCallback)(function () {
    return setOpen(function (open) {
      return !open;
    });
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    onPress: handleToggle,
    "aria-expanded": open,
    "aria-controls": id
  }, "Toggle"), /*#__PURE__*/_react["default"].createElement(_BlockSpacer.BlockSpacer, null), /*#__PURE__*/_react["default"].createElement(_Collapsible.Collapsible, {
    open: open,
    id: id,
    minSize: minSize,
    fade: fade
  }, /*#__PURE__*/_react["default"].createElement(_View.View, {
    border: "base",
    padding: "base"
  }, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, content))));
}

var accordion = function accordion() {
  return /*#__PURE__*/_react["default"].createElement(Accordion, null);
};

exports.accordion = accordion;

function Accordion() {
  var _useState3 = (0, _react.useState)(-1),
      _useState4 = _slicedToArray(_useState3, 2),
      openId = _useState4[0],
      setOpenId = _useState4[1];

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    onPress: function onPress() {
      setOpenId(0);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 0,
    "aria-controls": "collapsible0"
  }, "Panel 1"), /*#__PURE__*/_react["default"].createElement(_Collapsible.Collapsible, {
    open: openId === 0,
    id: "collapsible0"
  }, /*#__PURE__*/_react["default"].createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, content))), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    onPress: function onPress() {
      setOpenId(1);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 1,
    "aria-controls": "collapsible1"
  }, "Panel 2"), /*#__PURE__*/_react["default"].createElement(_Collapsible.Collapsible, {
    open: openId === 1,
    id: "collapsible1"
  }, /*#__PURE__*/_react["default"].createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, content))), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    onPress: function onPress() {
      setOpenId(2);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 2,
    "aria-controls": "collapsible2"
  }, "Panel 3"), /*#__PURE__*/_react["default"].createElement(_Collapsible.Collapsible, {
    open: openId === 2,
    id: "collapsible2"
  }, /*#__PURE__*/_react["default"].createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, content))));
}