"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatePicker = DatePicker;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _AppContext = require("../AppContext");

var _dates = require("../../utilities/dates");

var _Text = require("../Text");

var _Icon = require("../Icon");

var _DatePicker = _interopRequireDefault(require("./DatePicker.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function DatePicker(_ref) {
  var month = _ref.month,
      year = _ref.year,
      onMonthChange = _ref.onMonthChange;
  var translate = (0, _AppContext.useTranslate)();
  var geolocation = (0, _AppContext.useGeolocation)();
  var weekStartDay = (0, _react.useMemo)(function () {
    return (0, _dates.getWeekStartDay)(geolocation === null || geolocation === void 0 ? void 0 : geolocation.countryCode);
  }, [geolocation === null || geolocation === void 0 ? void 0 : geolocation.countryCode]);
  var now = new Date();
  var currentMonth = now.getMonth() === month && now.getFullYear() === year;
  var weekdaysMarkup = (0, _dates.getOrderedWeekdays)(weekStartDay).map(function (weekday) {
    return /*#__PURE__*/_react["default"].createElement(WeekdayUI, {
      key: weekday,
      day: _dates.Weekday[weekday],
      current: currentMonth && new Date().getDay() === weekday
    });
  });
  var weeks = (0, _react.useMemo)(function () {
    return (0, _dates.getWeeksForMonth)(month, year, weekStartDay);
  }, [month, year, weekStartDay]);
  var weeksMarkup = weeks.map(function (week) {
    var index = week.map(function (date) {
      return date === null || date === void 0 ? void 0 : date.getDate();
    }).join('');
    return /*#__PURE__*/_react["default"].createElement("tr", {
      className: _DatePicker["default"].Week,
      key: index
    }, week.map(function (date) {
      return /*#__PURE__*/_react["default"].createElement(Day, {
        date: date,
        key: date === null || date === void 0 ? void 0 : date.getDate()
      });
    }));
  });
  var previousYear = (0, _dates.getPreviousDisplayYear)(month, year);
  var previousMonth = (0, _dates.getPreviousDisplayMonth)(month);
  var showPreviousMonthLabel = translate('showPreviousMonth', {
    month: translate(_dates.Month[previousMonth].toLowerCase()),
    year: "".concat(previousYear)
  });
  var nextYear = (0, _dates.getNextDisplayYear)(month, year);
  var nextMonth = (0, _dates.getNextDisplayMonth)(month);
  var showNextMonthLabel = translate('showNextMonth', {
    month: translate(_dates.Month[nextMonth].toLowerCase()),
    year: "".concat(nextYear)
  });
  var handleMonthChange = (0, _react.useCallback)(function (month, year) {
    if (!onMonthChange) {
      return;
    }

    onMonthChange(month, year);
  }, [onMonthChange]);
  var monthLabelClassName = (0, _cssUtilities.classNames)(_DatePicker["default"].MonthLabel, currentMonth && _DatePicker["default"]['MonthLabel-current']);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _DatePicker["default"].DatePicker
  }, onMonthChange && /*#__PURE__*/_react["default"].createElement("div", {
    className: _DatePicker["default"].Controls
  }, /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    onClick: function onClick() {
      return handleMonthChange(previousMonth, previousYear);
    },
    className: _DatePicker["default"].ControlsPrevious,
    "aria-label": showPreviousMonthLabel
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "arrowLeft",
    size: "base"
  })), /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    onClick: function onClick() {
      return handleMonthChange(nextMonth, nextYear);
    },
    className: _DatePicker["default"].ControlsNext,
    "aria-label": showNextMonthLabel
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "arrowRight",
    size: "base"
  }))), /*#__PURE__*/_react["default"].createElement("table", {
    role: "grid",
    className: _DatePicker["default"].Month
  }, /*#__PURE__*/_react["default"].createElement("caption", {
    className: monthLabelClassName,
    "aria-live": "polite"
  }, translate(_dates.Month[month].toLowerCase()), " ", year), /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", {
    className: _DatePicker["default"].WeekDays
  }, weekdaysMarkup)), /*#__PURE__*/_react["default"].createElement("tbody", null, weeksMarkup)));
}

var WeekdayUI = /*#__PURE__*/(0, _react.memo)(function Weekday(_ref2) {
  var day = _ref2.day,
      current = _ref2.current;
  var translate = (0, _AppContext.useTranslate)();
  var className = (0, _cssUtilities.classNames)(_DatePicker["default"].Weekday);
  return /*#__PURE__*/_react["default"].createElement("th", {
    scope: "col",
    className: className
  }, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    role: {
      type: 'abbreviation',
      "for": translate(day.toLowerCase())
    },
    subdued: !current,
    emphasized: current,
    size: "small"
  }, translate("".concat(day.toLowerCase(), "Abbreviation"))));
});

function Day(_ref3) {
  var date = _ref3.date,
      disabled = _ref3.disabled,
      selected = _ref3.selected,
      inRange = _ref3.inRange;

  if (!date) {
    return /*#__PURE__*/_react["default"].createElement("td", null);
  }

  var label = date.getDate();
  var today = (0, _dates.isToday)(date);
  var className = (0, _cssUtilities.classNames)(_DatePicker["default"].Day, today && _DatePicker["default"]['Day-today'], disabled && _DatePicker["default"]['Day-disabled'], selected && _DatePicker["default"]['Day-selected'], inRange && _DatePicker["default"]['Day-inRange']);
  return /*#__PURE__*/_react["default"].createElement("td", {
    className: _DatePicker["default"].DayCell
  }, disabled ? /*#__PURE__*/_react["default"].createElement("span", {
    className: className
  }, label) : /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    tabIndex: -1,
    className: className
  }, label));
}