"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FocusTrap = void 0;

var _react = _interopRequireWildcard(require("react"));

var _focus = require("../../utilities/focus");

var _FocusTrap = _interopRequireDefault(require("./FocusTrap.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var FocusTrap = function FocusTrap(_ref) {
  var children = _ref.children,
      onContainerFocus = _ref.onContainerFocus;
  var firstBumperRef = (0, _react.useRef)(null);
  var lastBumperRef = (0, _react.useRef)(null);
  var contentRef = (0, _react.useRef)(null);
  (0, _react.useLayoutEffect)(function () {
    var _contentRef$current;

    (_contentRef$current = contentRef.current) === null || _contentRef$current === void 0 ? void 0 : _contentRef$current.focus({
      preventScroll: true
    });
  }, []);

  var moveFocus = function moveFocus(forward) {
    var content = contentRef.current;

    if (content) {
      var focusableNode = forward ? (0, _focus.findFirstFocusableNode)(content) : (0, _focus.findLastFocusableNode)(content);
      focusableNode ? focusableNode.focus() : content.focus();
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("button", {
    className: _FocusTrap["default"].Bumper,
    ref: firstBumperRef,
    "aria-hidden": "true",
    onFocus: function onFocus() {
      return moveFocus(false);
    }
  }), /*#__PURE__*/_react["default"].cloneElement(children, {
    tabIndex: -1,
    ref: contentRef,
    onFocus: onContainerFocus
  }), /*#__PURE__*/_react["default"].createElement("button", {
    className: _FocusTrap["default"].Bumper,
    ref: lastBumperRef,
    "aria-hidden": "true",
    onFocus: function onFocus() {
      return moveFocus(true);
    }
  }));
};

exports.FocusTrap = FocusTrap;