"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormLayout = FormLayout;
exports.FormLayoutGroup = FormLayoutGroup;

var _react = _interopRequireDefault(require("react"));

var _BlockStack = require("../BlockStack");

var _Layout = require("../Layout");

var _Theme = require("../Theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function FormLayout(_ref) {
  var children = _ref.children;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      spacing = _useThemeConfiguratio.formLayout.spacing;

  var normalizedSpacing = spacing === 'base' ? undefined : spacing;
  return /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, {
    spacing: normalizedSpacing
  }, children);
}

function FormLayoutGroup(_ref2) {
  var children = _ref2.children;

  var _useThemeConfiguratio2 = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio3 = _useThemeConfiguratio2.formLayout.spacing,
      spacing = _useThemeConfiguratio3 === void 0 ? 'base' : _useThemeConfiguratio3;

  var normalizedSpacing = spacing === 'none' ? undefined : spacing;
  return /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: {
      base: [1, 1, 1],
      small: ['fill', 'fill', 'fill']
    },
    spacing: normalizedSpacing
  }, children);
}