"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormattedText = FormattedText;

var _react = _interopRequireDefault(require("react"));

var _FormattedText = _interopRequireDefault(require("./FormattedText.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * FormattedText replaces new line characters with HTML line breaks (`<br />`).
 * Use this component when you want to render text created by an editor or a `<textarea>`.
 * For more complex use cases involving basic HTML tags, format the content as a React component
 * and pass it in as a child. The component will recieve customized styling based on the supported tags.
 */
function FormattedText(_ref) {
  var children = _ref.children;

  if (typeof children === 'string') {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children.split('\n').filter(Boolean).map(function (content, index) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, index > 0 && /*#__PURE__*/_react["default"].createElement("br", null), content);
    }));
  } else {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _FormattedText["default"].FormattedText
    }, children);
  }
}