"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Heading = Heading;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Theme = require("../Theme");

var _autoHeadings = require("../../utilities/auto-headings");

var _legacy = require("../../utilities/legacy");

var _typographyStyles = _interopRequireDefault(require("../../utilities/typography-styles.css"));

var _Heading = _interopRequireDefault(require("./Heading.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Heading(_ref) {
  var _ref2;

  var id = _ref.id,
      children = _ref.children,
      role = _ref.role,
      explicitLevel = _ref.level;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      headingLevel1 = _useThemeConfiguratio.headingLevel1,
      headingLevel2 = _useThemeConfiguratio.headingLevel2,
      headingLevel3 = _useThemeConfiguratio.headingLevel3;

  var semanticLevel = (0, _autoHeadings.useAutoHeadingLevel)();
  var visualLevel = (_ref2 = explicitLevel !== null && explicitLevel !== void 0 ? explicitLevel : semanticLevel) !== null && _ref2 !== void 0 ? _ref2 : 0;
  var Element = role === 'presentation' || semanticLevel == null ? 'p' : "h".concat(semanticLevel);
  var className = (0, _cssUtilities.classNames)(_Heading["default"].Heading, visualLevel && _Heading["default"][(0, _cssUtilities.variationName)('h', visualLevel)], visualLevel >= 2 && _legacy.utilityDefaultTextColorEmphasized, visualLevel === 1 && headingLevel1.typographyStyle && _typographyStyles["default"][headingLevel1.typographyStyle], visualLevel === 2 && headingLevel2.typographyStyle && _typographyStyles["default"][headingLevel2.typographyStyle], visualLevel === 3 && headingLevel3.typographyStyle && _typographyStyles["default"][headingLevel3.typographyStyle]);
  return /*#__PURE__*/_react["default"].createElement(Element, {
    id: id,
    tabIndex: id ? -1 : undefined,
    className: className
  }, children);
}