"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.aspectRatio = exports.responsive = exports.contain = exports.cover = exports.lazyLoading = exports.basicImage = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _testUtilities = require("../../test-utilities");

var _TextContainer = require("../TextContainer");

var _View = require("../View");

var _Image = require("./Image");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _Image.Image,
  title: 'checkout-web-ui/Image',
  argTypes: {
    source: {
      name: 'source',
      type: {
        name: 'string',
        required: true
      },
      defaultValue: 'https://via.placeholder.com/320x180/eee',
      control: {
        type: 'text'
      }
    },
    description: {
      name: 'description',
      type: {
        name: 'string',
        required: false
      },
      defaultValue: 'placeholder.com',
      control: {
        type: 'text'
      }
    },
    loading: {
      name: 'loading',
      control: {
        type: 'select',
        options: ['eager', 'lazy'],
        required: false
      }
    },
    fit: {
      name: 'fit',
      control: {
        type: 'select',
        options: ['cover', 'contain'],
        required: false
      }
    }
  }
};
var _default = meta;
exports["default"] = _default;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_Image.Image, args);
};

var basicImage = Template.bind({});
exports.basicImage = basicImage;
var lazyLoading = Template.bind({});
exports.lazyLoading = lazyLoading;
lazyLoading.args = {
  loading: 'lazy'
};
var cover = Template.bind({});
exports.cover = cover;
cover.args = {
  sources: {
    base: [{
      source: 'https://via.placeholder.com/320x180/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 2
    }]
  },
  aspectRatio: 1,
  fit: 'cover'
};
cover.decorators = [function (Story) {
  return /*#__PURE__*/_react["default"].createElement(_View.View, {
    maxInlineSize: 256,
    border: "base"
  }, /*#__PURE__*/_react["default"].createElement(Story, null));
}];
var contain = Template.bind({});
exports.contain = contain;
contain.args = {
  sources: {
    base: [{
      source: 'https://via.placeholder.com/320x180/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 2
    }]
  },
  aspectRatio: 1,
  fit: 'contain'
};
contain.decorators = [function (Story) {
  return /*#__PURE__*/_react["default"].createElement(_View.View, {
    maxInlineSize: 256,
    border: "base"
  }, /*#__PURE__*/_react["default"].createElement(Story, null));
}];
var responsive = Template.bind({});
exports.responsive = responsive;
responsive.args = {
  sources: {
    small: [{
      source: 'https://via.placeholder.com/320x180/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 2
    }],
    medium: [{
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/1280x720/eee',
      resolution: 2
    }],
    large: [{
      source: 'https://via.placeholder.com/1280x720/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/2560x1440/eee',
      resolution: 2
    }]
  }
};

var aspectRatio = function aspectRatio(args) {
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: 320
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, null, /*#__PURE__*/_react["default"].createElement(_Image.Image, args), /*#__PURE__*/_react["default"].createElement("p", null, _testUtilities.faker.lorem.paragraphs(3))));
};

exports.aspectRatio = aspectRatio;
aspectRatio.args = {
  source: 'https://via.placeholder.com/640x360',
  aspectRatio: 3
};