"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.nested = exports.spacing = exports.commonLayouts = exports.media = exports.defaultMaxInlineSize = exports.defaultSizes = exports.blockAlignment = exports.inlineAlignment = exports.defaultState = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _View = require("../View");

var _Text = require("../Text");

var _BlockStack = require("../BlockStack");

var _Spinner = require("../Spinner");

var _Layout = require("./Layout");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _Layout.Layout,
  title: 'checkout-web-ui/Layout'
};
var _default = meta;
exports["default"] = _default;

function ExampleContent() {
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: 'lightgrey',
      border: '1px #000 solid',
      padding: '1em'
    }
  }, "Content block Lorem, ipsum dolor sit amet consectetur adipisicing elit. Distinctio nemo in ex illo debitis necessitatibus sunt molestiae earum nesciunt alias praesentium, explicabo hic eveniet corporis harum nihil quidem vero eius.");
}

function ExampleSmallContent() {
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: 'lightgrey',
      border: '1px #000 solid',
      padding: '1em',
      width: '100%'
    }
  }, "Content block");
}

function ExampleBox(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: '500px',
      border: '1px grey dotted'
    }
  }, children);
}

var defaultState = function defaultState() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Default with small content"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, null, /*#__PURE__*/_react["default"].createElement(_View.View, null, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_View.View, null, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null))), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Default with large content"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, null, /*#__PURE__*/_react["default"].createElement(_View.View, null, /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_View.View, null, /*#__PURE__*/_react["default"].createElement(ExampleContent, null))));
};

exports.defaultState = defaultState;

var inlineAlignment = function inlineAlignment() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Default (center)"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, null, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Leading"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    inlineAlignment: "leading"
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Trailing"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    inlineAlignment: "trailing"
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)));
};

exports.inlineAlignment = inlineAlignment;

var blockAlignment = function blockAlignment() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Default (leading)"), /*#__PURE__*/_react["default"].createElement(ExampleBox, null, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, null, /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null))), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Center"), /*#__PURE__*/_react["default"].createElement(ExampleBox, null, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    blockAlignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null))), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Trailing"), /*#__PURE__*/_react["default"].createElement(ExampleBox, null, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    blockAlignment: "trailing"
  }, /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null))));
};

exports.blockAlignment = blockAlignment;

var defaultSizes = function defaultSizes() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.75, 0.25]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.75, 0.25]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[500, 300]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [500, 300]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "0.5, 200]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.5, 200]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns that would overflow - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.75, 0.5]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.75, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns that would overflow - ", /*#__PURE__*/_react["default"].createElement("code", null, "[1000, 2000]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [1000, 2000]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "3 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[auto, auto, auto]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: ['auto', 'auto', 'auto']
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "3 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, 0.25, 0.25]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.5, 0.25, 0.25]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "3 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, auto, auto]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.5, 'auto', 'auto']
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "3 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[500, auto, fill]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [500, 'auto', 'fill']
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "3 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[auto, auto, fill]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: ['auto', 'auto', 'fill']
  }, /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "3 rows - ", /*#__PURE__*/_react["default"].createElement("code", null, "[1, 1, 1]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [1, 1, 1]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "3 columns/rows mix - ", /*#__PURE__*/_react["default"].createElement("code", null, "[1, auto, fill]")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [1, 'auto', 'fill']
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)));
};

exports.defaultSizes = defaultSizes;

var defaultMaxInlineSize = function defaultMaxInlineSize() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, 0.5]"), " maxInlineSize ", /*#__PURE__*/_react["default"].createElement("code", null, "default")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, 0.5]"), " maxInlineSize ", /*#__PURE__*/_react["default"].createElement("code", null, "800px")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    maxInlineSize: 800,
    sizes: [0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, 0.5]"), " maxInlineSize ", /*#__PURE__*/_react["default"].createElement("code", null, "75%")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    maxInlineSize: 0.75,
    sizes: [0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, 0.5]"), " maxInlineSize ", /*#__PURE__*/_react["default"].createElement("code", null, "800px"), ' ', "inlineAlignment ", /*#__PURE__*/_react["default"].createElement("code", null, "leading")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    maxInlineSize: 800,
    sizes: [0.5, 0.5],
    inlineAlignment: "leading"
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, 0.5]"), " maxInlineSize ", /*#__PURE__*/_react["default"].createElement("code", null, "75%"), ' ', "inlineAlignment ", /*#__PURE__*/_react["default"].createElement("code", null, "trailing")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    maxInlineSize: 0.75,
    sizes: [0.5, 0.5],
    inlineAlignment: "trailing"
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)));
};

exports.defaultMaxInlineSize = defaultMaxInlineSize;

var media = function media() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Default 2 columns - ", /*#__PURE__*/_react["default"].createElement("code", null, "[1, 1]"), /*#__PURE__*/_react["default"].createElement("br", null), " Media above small 2 rows - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.75, 0.25]"), " maxInlineSize: ", /*#__PURE__*/_react["default"].createElement("code", null, "95%"), " spacing: ", /*#__PURE__*/_react["default"].createElement("code", null, "extraTight"), /*#__PURE__*/_react["default"].createElement("br", null), " Media above medium 2 rows - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.5, 0.5]"), " maxInlineSize: ", /*#__PURE__*/_react["default"].createElement("code", null, "85%"), " spacing: ", /*#__PURE__*/_react["default"].createElement("code", null, "base"), /*#__PURE__*/_react["default"].createElement("br", null), " Media above large 2 rows - ", /*#__PURE__*/_react["default"].createElement("code", null, "[0.25, 0.75]"), " maxInlineSize: ", /*#__PURE__*/_react["default"].createElement("code", null, "75%"), " spacing: ", /*#__PURE__*/_react["default"].createElement("code", null, "extraLoose")), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: {
      base: [1, 1],
      small: [0.75, 0.25],
      medium: [0.5, 0.5],
      large: [0.25, 0.75]
    },
    maxInlineSize: {
      small: 0.95,
      medium: 0.85,
      large: 0.75
    },
    spacing: {
      small: 'extraTight',
      medium: 'base',
      large: 'extraLoose'
    }
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleContent, null)));
};

exports.media = media;

var commonLayouts = function commonLayouts() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Checkout"), /*#__PURE__*/_react["default"].createElement(ExampleBox, null, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    maxInlineSize: 500,
    inlineAlignment: "trailing"
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null))), /*#__PURE__*/_react["default"].createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    maxInlineSize: 500,
    inlineAlignment: "leading"
  }, /*#__PURE__*/_react["default"].createElement(ExampleContent, null))))), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Siberia"), /*#__PURE__*/_react["default"].createElement(ExampleBox, null, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.5, 0.5],
    maxInlineSize: 925,
    blockAlignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_View.View, {
    padding: "base"
  }, "Main"), /*#__PURE__*/_react["default"].createElement(_View.View, {
    padding: "base"
  }, "Sidebar"))), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Centered"), /*#__PURE__*/_react["default"].createElement(ExampleBox, null, /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    blockAlignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, {
    alignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_Spinner.Spinner, null), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Lorem ipsum dolor sit amet consectetur adipisicing elit.")))));
};

exports.commonLayouts = commonLayouts;

var spacing = function spacing() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "ExtraTight"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    spacing: "extraTight",
    sizes: [1, 0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Tight"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    spacing: "tight",
    sizes: [1, 0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Base"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    spacing: "base",
    sizes: [1, 0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Loose"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    spacing: "loose",
    sizes: [1, 0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "ExtraLoose"), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    spacing: "extraLoose",
    sizes: [1, 0.5, 0.5]
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)));
};

exports.spacing = spacing;

var nested = function nested() {
  return /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [1, 1, 1],
    spacing: "base"
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(_Layout.Layout, {
    sizes: [0.25, 0.75],
    spacing: "base"
  }, /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null)), /*#__PURE__*/_react["default"].createElement(ExampleSmallContent, null));
};

exports.nested = nested;