"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Link = Link;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Button = require("../Button");

var _Theme = require("../Theme");

var _typographyStyles = _interopRequireDefault(require("../../utilities/typography-styles.css"));

var _components = require("./components");

var _Link = _interopRequireDefault(require("./Link.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Link is used to navigate the buyer to another page or section within the same page.
 */
function Link(_ref) {
  var children = _ref.children,
      to = _ref.to,
      language = _ref.language,
      onPress = _ref.onPress,
      appearance = _ref.appearance,
      accessibilityLabel = _ref.accessibilityLabel,
      rest = _objectWithoutProperties(_ref, ["children", "to", "language", "onPress", "appearance", "accessibilityLabel"]);

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.link,
      colorHovered = _useThemeConfiguratio2.colorHovered,
      typographyStyle = _useThemeConfiguratio2.typographyStyle;

  if (!to) {
    return /*#__PURE__*/_react["default"].createElement(_Button.Button, Object.assign({
      onPress: onPress,
      kind: "plain",
      appearance: appearance
    }, rest), children);
  }

  return /*#__PURE__*/_react["default"].createElement(_components.UnstyledLink, Object.assign({
    className: (0, _cssUtilities.classNames)(_Link["default"].Link, appearance && appearance === 'monochrome' ? _Link["default"].appearanceMonochrome : _Link["default"].appearanceDefault, colorHovered && _Link["default"][(0, _cssUtilities.variationName)('colorHovered', colorHovered)], typographyStyle && _typographyStyles["default"][typographyStyle]),
    to: to,
    onPress: onPress,
    language: language,
    accessibilityLabel: accessibilityLabel
  }, rest), children);
}