"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.all = exports.LinkComponent = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _TextBlock = require("../TextBlock");

var _Link = require("./Link");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _Link.Link,
  title: 'checkout-web-ui/Link',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('link')]
};
var _default = meta;
exports["default"] = _default;

var LinkComponent = function LinkComponent(args) {
  return /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, null, "Learn more about our ", /*#__PURE__*/_react["default"].createElement(_Link.Link, args, "shipping policies"));
};

exports.LinkComponent = LinkComponent;
LinkComponent.args = {
  to: 'https://shopify.com',
  external: false,
  underline: false,
  appearance: undefined
};
LinkComponent.argTypes = {
  appearance: {
    control: {
      type: 'select',
      options: [undefined, 'monochrome']
    }
  }
};

var all = function all() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Link.Link, {
    to: "https://shopify.com",
    external: false
  }, "Internal link"), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_Link.Link, {
    to: "https://shopify.com",
    external: true
  }, "External link"), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_Link.Link, {
    to: undefined
  }, "Link without `to` (rendered as a Button)"), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, null, "Learn more about our", ' ', /*#__PURE__*/_react["default"].createElement(_Link.Link, {
    to: "https://shopify.com",
    appearance: "monochrome"
  }, "shipping policies"), ' ', "(`monochrome`)"), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_Link.Link, {
    to: "https://shopify.com",
    accessibilityLabel: "Visit shopify.com"
  }, "Visit (with accessible label)"));
};

exports.all = all;