"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.List = List;
exports.ListItem = ListItem;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _List = _interopRequireDefault(require("./List.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function List(_ref) {
  var _ref$spacing = _ref.spacing,
      spacing = _ref$spacing === void 0 ? 'base' : _ref$spacing,
      _ref$marker = _ref.marker,
      marker = _ref$marker === void 0 ? 'bullet' : _ref$marker,
      children = _ref.children;
  var className = (0, _cssUtilities.classNames)(_List["default"].List, spacing && _List["default"][(0, _cssUtilities.variationName)('spacing', spacing)], marker && _List["default"][(0, _cssUtilities.variationName)('marker', marker)]);
  var isOrderedList = marker === 'number';
  /*
  VoiceOver and Safari (Webkit) (macOS and iOS) remove list element
  semantics when list-style: none is used.
  https://www.scottohara.me/blog/2019/01/12/lists-and-safari.html
  */

  var role = marker === 'none' ? 'list' : undefined;
  var Element = isOrderedList ? 'ol' : 'ul';
  return (
    /*#__PURE__*/

    /* Needed to properly reset margins on ul / ol elements and not interfere
     * with layout components that use `*` selector to create gaps between children. */

    /* eslint-disable-next-line @shopify/jsx-prefer-fragment-wrappers */
    _react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(Element, {
      className: className,
      role: role
    }, children))
  );
}

function ListItem(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/_react["default"].createElement("li", {
    className: _List["default"].ListItem
  }, children);
}