"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Modal = Modal;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _responsiveValue = require("../../utilities/responsiveValue");

var _AppContext = require("../AppContext");

var _FocusTrap = require("../FocusTrap");

var _Portal = require("../Portal");

var _Heading = require("../Heading");

var _Icon = require("../Icon");

var _units = require("../../utilities/units");

var _transition = require("../../utilities/transition");

var _id = require("../../utilities/id");

var _Modal = _interopRequireDefault(require("./Modal.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var createId = (0, _id.createIdCreator)('ModalHeading');
var IFRAME_HEIGHT_NOT_ACCESSIBLE = -1;

function Modal(_ref) {
  var maxInlineSize = _ref.maxInlineSize,
      blockSize = _ref.blockSize,
      open = _ref.open,
      title = _ref.title,
      titleHidden = _ref.titleHidden,
      source = _ref.source,
      _ref$noMountTransitio = _ref.noMountTransition,
      noMountTransition = _ref$noMountTransitio === void 0 ? false : _ref$noMountTransitio,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["maxInlineSize", "blockSize", "open", "title", "titleHidden", "source", "noMountTransition", "children"]);

  var blocking = rest.blocking;
  var onClose = rest.blocking ? undefined : rest.onClose;
  var translate = (0, _AppContext.useTranslate)();

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      iframeHeight = _useState2[0],
      setIframeHeight = _useState2[1];

  var activatorRef = (0, _react.useRef)(null);
  var modalRef = (0, _react.useRef)(null);
  var modalHeadingId = (0, _id.useId)(undefined, createId);
  var transition = (0, _transition.useTransition)(open, 'fast', !noMountTransition);

  var transitionClassName = _Modal["default"][(0, _cssUtilities.variationName)('transition', transition)];

  var isMobile = (0, _responsiveValue.useResponsiveValue)({
    base: true,
    medium: false
  });
  (0, _react.useEffect)(function () {
    if (transition === 'enter') {
      document.body.style.overflow = 'hidden';
      activatorRef.current = document.activeElement;
    }

    if (transition === 'exited') {
      document.body.style.overflow = 'auto';
      if ((activatorRef === null || activatorRef === void 0 ? void 0 : activatorRef.current) instanceof HTMLElement) activatorRef.current.focus();
      setIframeHeight(undefined);
    }
  }, [transition]);

  var handleDialogFocus = function handleDialogFocus() {
    // workaround for browsers that don't support `preventScroll` for `focus`
    setTimeout(function () {
      var modal = modalRef.current;
      modal && modal.scrollTo(0, 0);
    }, 0);
  };

  (0, _react.useEffect)(function () {
    var handleKeyDown = function handleKeyDown(event) {
      if ((event.key === 'Escape' || event.key === 'Esc') && !blocking) {
        onClose && onClose();
      }
    };

    document.addEventListener('keydown', handleKeyDown, false);
    return function () {
      document.removeEventListener('keydown', handleKeyDown, false);
    };
  }, [blocking, onClose]);
  var handleIFrameLoad = (0, _react.useCallback)(function (evt) {
    var iframe = evt.target;

    if (iframe && iframe.contentWindow) {
      try {
        setIframeHeight(iframe.contentWindow.document.body.scrollHeight);
      } catch (_unused) {
        setIframeHeight(IFRAME_HEIGHT_NOT_ACCESSIBLE);
      }
    }
  }, []);

  function handleBackdropClick() {
    onClose && onClose();
  }

  if (transition === 'exited') return null;
  var ariaLabelOrLabelledby = titleHidden ? {
    'aria-label': title
  } : {
    'aria-labelledby': modalHeadingId
  };
  var titleMarkup = titleHidden ?
  /*#__PURE__*/
  // `null` breaks close button's right alignment
  _react["default"].createElement("span", null) : /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 1,
    id: modalHeadingId
  }, title);

  var header = (!titleHidden || !blocking) && /*#__PURE__*/_react["default"].createElement("header", {
    className: _Modal["default"].Header
  }, titleMarkup, !blocking && /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    className: _Modal["default"].CloseButton,
    onClick: onClose,
    "aria-label": translate('close') || 'Close'
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "close",
    size: "large"
  })));

  var content = source ? /*#__PURE__*/_react["default"].createElement("iframe", Object.assign({
    src: source,
    title: title,
    className: _Modal["default"].IFrame
  }, iframeHeight && iframeHeight > 0 && {
    style: {
      height: iframeHeight
    }
  }, !blockSize && {
    onLoad: handleIFrameLoad
  })) : /*#__PURE__*/_react["default"].createElement("div", Object.assign({
    className: _Modal["default"].Content
  }, (blockSize || isMobile) && {
    tabIndex: 0
  }), children);
  return /*#__PURE__*/_react["default"].createElement(_Portal.Portal, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: _Modal["default"].Modal,
    ref: modalRef
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_Modal["default"].Backdrop, transitionClassName),
    onClick: handleBackdropClick
  }), /*#__PURE__*/_react["default"].createElement(_FocusTrap.FocusTrap, {
    onContainerFocus: handleDialogFocus
  }, /*#__PURE__*/_react["default"].createElement("div", Object.assign({
    className: (0, _cssUtilities.classNames)(_Modal["default"].Dialog, transitionClassName, _defineProperty({}, _Modal["default"]['Dialog-blockSizeFill'], blockSize === 'fill' || iframeHeight === -1)),
    role: "dialog",
    "aria-modal": true,
    style: _objectSpread({}, maxInlineSize && {
      maxWidth: (0, _units.pixelOrPercent)(maxInlineSize === 'fill' ? 1 : maxInlineSize)
    })
  }, ariaLabelOrLabelledby), header, content))));
}