"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.closed = exports.focusedInput = exports.focusTrap = exports.blockSize = exports.maxInlineSizeFraction = exports.maxInlineSize = exports.iframeWithTitle = exports.iframe = exports.blockingWithHiddenTitle = exports.blocking = exports.longTitle = exports.title = exports.longText = exports.text = exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _testUtilities = require("../../test-utilities");

var _storybookUtilities = require("../../storybook-utilities");

var _Text = require("../Text");

var _Button = require("../Button");

var _InlineStack = require("../InlineStack");

var _BlockStack = require("../BlockStack");

var _TextField = require("../TextField");

var _index = require("./index");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var meta = {
  component: _index.Modal,
  title: 'checkout-web-ui/Modal',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('headingLevel1')]
};
var _default = meta;
exports["default"] = _default;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, process.env.A11Y_TESTS && /*#__PURE__*/_react["default"].createElement(_storybookUtilities.MockPrefersReducedMotion, null), /*#__PURE__*/_react["default"].createElement(ModalContainer, Object.assign({}, args, {
    title: args.title || _testUtilities.faker.random.words(2)
  })));
};

var ModalContainer = function ModalContainer(_ref) {
  var title = _ref.title,
      openProp = _ref.open,
      children = _ref.children,
      blocking = _ref.blocking,
      rest = _objectWithoutProperties(_ref, ["title", "open", "children", "blocking"]);

  var _useState = (0, _react.useState)(openProp !== null && openProp !== void 0 ? openProp : true),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var handleClose = function handleClose() {
    return setOpen(false);
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    onPress: function onPress() {
      return setOpen(true);
    }
  }, "Show modal"), /*#__PURE__*/_react["default"].createElement(_index.Modal, Object.assign({}, rest, {
    title: title,
    open: open
  }, blocking ? {
    blocking: true
  } : {
    blocking: false,
    onClose: handleClose
  }), typeof children === 'function' ? children({
    onClose: handleClose
  }) : children));
};

var text = Template.bind({});
exports.text = text;
text.args = {
  children: /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};
var longText = Template.bind({});
exports.longText = longText;
longText.args = {
  titleHidden: true,
  children: /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(100))
};
var title = Template.bind({});
exports.title = title;
title.args = {
  children: /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};
var longTitle = Template.bind({});
exports.longTitle = longTitle;
longTitle.args = {
  title: _testUtilities.faker.random.words(8),
  children: /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};

var BlockingContent = function BlockingContent(_ref2) {
  var onClose = _ref2.onClose;
  return /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "No generic close button, neither ESC nor backdrop click close the modal. The only way to close it is manually created buttons like the one below."), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    onPress: onClose
  }, "Close Blocking Modal"));
};

var blocking = Template.bind({});
exports.blocking = blocking;
blocking.args = {
  blocking: true,
  children: function children(_ref3) {
    var onClose = _ref3.onClose;
    return /*#__PURE__*/_react["default"].createElement(BlockingContent, {
      onClose: onClose
    });
  }
};
var blockingWithHiddenTitle = Template.bind({});
exports.blockingWithHiddenTitle = blockingWithHiddenTitle;
blockingWithHiddenTitle.args = {
  blocking: true,
  titleHidden: true,
  children: function children(_ref4) {
    var onClose = _ref4.onClose;
    return /*#__PURE__*/_react["default"].createElement(BlockingContent, {
      onClose: onClose
    });
  }
};
var iframe = Template.bind({});
exports.iframe = iframe;
iframe.args = {
  source: 'http://www.example.com/',
  titleHidden: true
};
var iframeWithTitle = Template.bind({});
exports.iframeWithTitle = iframeWithTitle;
iframeWithTitle.args = {
  source: 'http://www.example.com/'
};
var maxInlineSize = Template.bind({});
exports.maxInlineSize = maxInlineSize;
maxInlineSize.args = {
  maxInlineSize: 320,
  titleHidden: true,
  children: /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(3))
};
var maxInlineSizeFraction = Template.bind({});
exports.maxInlineSizeFraction = maxInlineSizeFraction;
maxInlineSizeFraction.args = {
  maxInlineSize: 0.7,
  titleHidden: true,
  children: /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(3))
};
var blockSize = Template.bind({});
exports.blockSize = blockSize;
blockSize.args = {
  source: 'http://www.example.com/',
  blockSize: 'fill',
  titleHidden: true
};
var focusTrap = Template.bind({});
exports.focusTrap = focusTrap;
focusTrap.args = {
  children: /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1)), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, null, "You"), /*#__PURE__*/_react["default"].createElement(_Button.Button, null, "are"), /*#__PURE__*/_react["default"].createElement(_Button.Button, null, "trapped")))
};
var focusedInput = Template.bind({});
exports.focusedInput = focusedInput;
focusedInput.args = {
  children: /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, {
    spacing: "base"
  }, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    autofocus: true,
    label: "First Name"
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Last Name"
  }), /*#__PURE__*/_react["default"].createElement(_Button.Button, null, "Submit"))
};
var closed = Template.bind({});
exports.closed = closed;
closed.args = {
  open: false,
  children: /*#__PURE__*/_react["default"].createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};