"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.basic = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _Text = require("../Text");

var _storybookUtilities = require("../../storybook-utilities");

var _Icon = require("../Icon");

var _InlineStack = require("../InlineStack");

var _Tooltip = require("../Tooltip");

var _Divider = require("../Divider");

var _MoneyLines = require("./MoneyLines");

var _ = require(".");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('headingLevel1')],
  component: _MoneyLines.MoneyLines,
  subComponents: {
    MoneyLine: _.MoneyLine,
    MoneySummary: _.MoneySummary
  },
  title: 'checkout-web-ui/MoneyLines'
};
var _default = meta;
exports["default"] = _default;

var basic = function basic() {
  return /*#__PURE__*/_react["default"].createElement(_MoneyLines.MoneyLines, {
    title: "Cost summary"
  }, /*#__PURE__*/_react["default"].createElement(_.MoneyLine, {
    label: "Subtotal",
    value: "$3,300.00"
  }), /*#__PURE__*/_react["default"].createElement(_.MoneyLine, {
    label: "Shipping",
    value: "Calculated at next",
    subdued: true
  }), /*#__PURE__*/_react["default"].createElement(_.MoneyLine, null, /*#__PURE__*/_react["default"].createElement(_.MoneyLineHeader, null, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Taxes"))), /*#__PURE__*/_react["default"].createElement(_.MoneyLineContent, null, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    emphasized: true
  }, "$429.00"), /*#__PURE__*/_react["default"].createElement(_Tooltip.Tooltip, {
    content: "Tooltip"
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "questionFill",
    size: "large",
    appearance: "subdued",
    accessibilityLabel: "Tooltip"
  }))))), /*#__PURE__*/_react["default"].createElement(_.MoneyLine, null, /*#__PURE__*/_react["default"].createElement(_.MoneyLineHeader, null, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "Discount"), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center",
    spacing: "extraTight"
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "discount",
    size: "large"
  }), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "SPRINGSALE10")))), /*#__PURE__*/_react["default"].createElement(_.MoneyLineContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    emphasized: true
  }, "$10"))), /*#__PURE__*/_react["default"].createElement(_Divider.Divider, {
    blockSpacing: "loose"
  }), /*#__PURE__*/_react["default"].createElement(_.MoneySummary, {
    label: "Total",
    value: "$3,719.00",
    prefix: "CAD"
  }));
};

exports.basic = basic;