"use strict";

var _react = _interopRequireDefault(require("react"));

var _testUtilities = require("../../test-utilities");

var _Heading = require("../Heading");

var _View = require("../View");

var _components = require("./components");

var _MoneyLines = require("./MoneyLines");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('<MoneyLines />', function () {
  it('renders the children', function () {
    var moneyLines = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react["default"].createElement(_MoneyLines.MoneyLines, {
      title: "title"
    }, /*#__PURE__*/_react["default"].createElement(_components.MoneyLine, null), /*#__PURE__*/_react["default"].createElement(_components.MoneySummary, null)));
    expect(moneyLines).toContainReactComponent(_components.MoneyLine);
    expect(moneyLines).toContainReactComponent(_components.MoneySummary);
  });
  it('renders the title', function () {
    var title = _testUtilities.faker.random.word();

    var moneyLines = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react["default"].createElement(_MoneyLines.MoneyLines, {
      title: title
    }));
    expect(moneyLines).toContainReactComponent(_Heading.Heading, {
      children: title
    });
  });
  it('renders a visually hidden title', function () {
    var title = _testUtilities.faker.random.word();

    var moneyLines = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react["default"].createElement(_MoneyLines.MoneyLines, {
      title: title,
      titleHidden: true
    }));
    expect(moneyLines.find(_View.View)).toContainReactComponent(_Heading.Heading, {
      children: title
    });
  });
});