"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MoneyLine = MoneyLine;
exports.MoneyLineHeader = MoneyLineHeader;
exports.MoneyLineContent = MoneyLineContent;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Text = require("../../../Text");

var _Theme = require("../../../Theme");

var _MoneyLine = _interopRequireDefault(require("./MoneyLine.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function hasChildren(props) {
  return props.children !== undefined;
}

function MoneyLine(props) {
  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.moneyLines,
      background = _useThemeConfiguratio2.background,
      blockPadding = _useThemeConfiguratio2.blockPadding,
      inlinePadding = _useThemeConfiguratio2.inlinePadding,
      inlineAlignment = _useThemeConfiguratio2.inlineAlignment,
      labelTypographyStyle = _useThemeConfiguratio2.labelTypographyStyle,
      valueTypographyStyle = _useThemeConfiguratio2.valueTypographyStyle;

  var className = (0, _cssUtilities.classNames)(_MoneyLine["default"].MoneyLine, background && _MoneyLine["default"][(0, _cssUtilities.variationName)('background', background)], blockPadding && _MoneyLine["default"][(0, _cssUtilities.variationName)('blockPadding', blockPadding)], inlineAlignment && _MoneyLine["default"][(0, _cssUtilities.variationName)('inlineAlignment', inlineAlignment)], inlinePadding && _MoneyLine["default"][(0, _cssUtilities.variationName)('inlinePadding', inlinePadding)]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    role: "row"
  }, hasChildren(props) ? props.children : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(MoneyLineHeader, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    style: labelTypographyStyle
  }, props.label)), /*#__PURE__*/_react["default"].createElement(MoneyLineContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    subdued: props.subdued,
    emphasized: !props.subdued,
    size: props.subdued ? 'small' : undefined,
    style: valueTypographyStyle
  }, props.value))));
}

function MoneyLineHeader(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _MoneyLine["default"].Header,
    role: "rowheader"
  }, children);
}

function MoneyLineContent(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _MoneyLine["default"].Content,
    role: "cell"
  }, children);
}