"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MoneySummary = MoneySummary;
exports.MoneySummaryHeader = MoneySummaryHeader;
exports.MoneySummaryContent = MoneySummaryContent;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _InlineStack = require("../../../InlineStack");

var _Text = require("../../../Text");

var _Divider = require("../../../Divider");

var _Theme = require("../../../Theme");

var _MoneySummary = _interopRequireDefault(require("./MoneySummary.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function hasChildren(props) {
  return props.children !== undefined;
}

function MoneySummary(props) {
  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.moneyLines,
      divided = _useThemeConfiguratio2.divided,
      dividerSpacing = _useThemeConfiguratio2.dividerSpacing,
      inlineAlignment = _useThemeConfiguratio2.inlineAlignment,
      _useThemeConfiguratio3 = _useThemeConfiguratio.moneySummary,
      background = _useThemeConfiguratio3.background,
      blockPadding = _useThemeConfiguratio3.blockPadding,
      _useThemeConfiguratio4 = _useThemeConfiguratio3.currencyCode,
      currencyCode = _useThemeConfiguratio4 === void 0 ? true : _useThemeConfiguratio4,
      currencyTypographyStyle = _useThemeConfiguratio3.currencyTypographyStyle,
      inlinePadding = _useThemeConfiguratio3.inlinePadding,
      labelTypographyStyle = _useThemeConfiguratio3.labelTypographyStyle,
      valueTypographyStyle = _useThemeConfiguratio3.valueTypographyStyle;

  var className = (0, _cssUtilities.classNames)(_MoneySummary["default"].MoneySummary, background && _MoneySummary["default"][(0, _cssUtilities.variationName)('background', background)], blockPadding && _MoneySummary["default"][(0, _cssUtilities.variationName)('blockPadding', blockPadding)], inlineAlignment && _MoneySummary["default"][(0, _cssUtilities.variationName)('inlineAlignment', inlineAlignment)], inlinePadding && _MoneySummary["default"][(0, _cssUtilities.variationName)('inlinePadding', inlinePadding)]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, divided && /*#__PURE__*/_react["default"].createElement(_Divider.Divider, {
    blockSpacing: dividerSpacing
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    role: "row"
  }, hasChildren(props) ? props.children : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(MoneySummaryHeader, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    emphasized: true,
    size: "medium",
    style: labelTypographyStyle
  }, props.label)), /*#__PURE__*/_react["default"].createElement(MoneySummaryContent, null, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "baseline",
    spacing: "tight"
  }, currencyCode && /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    role: {
      type: 'abbreviation'
    },
    size: "small",
    subdued: true,
    style: currencyTypographyStyle
  }, props.prefix), /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    emphasized: true,
    size: "extraLarge",
    style: valueTypographyStyle
  }, props.value))))));
}

function MoneySummaryHeader(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _MoneySummary["default"].Header,
    role: "rowheader"
  }, children);
}

function MoneySummaryContent(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _MoneySummary["default"].Content,
    role: "cell"
  }, children);
}