"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptionDetails = OptionDetails;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _hooks = require("../../hooks");

var _Collapsible = require("../../../Collapsible");

var _OptionList = _interopRequireDefault(require("../../OptionList.css"));

var _Theme = require("../../../Theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function OptionDetails(_ref) {
  var controlledBy = _ref.controlledBy,
      children = _ref.children;

  var _useOptionList = (0, _hooks.useOptionList)(),
      selectedItems = _useOptionList.selectedItems,
      optionListId = _useOptionList.id;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      detailsBackground = _useThemeConfiguratio.optionList.detailsBackground;

  var isSelected = selectedItems.includes(controlledBy);

  if (!children) {
    return null;
  }

  return /*#__PURE__*/_react["default"].createElement(_Collapsible.Collapsible, {
    open: isSelected,
    id: "".concat(optionListId, "-").concat(controlledBy, "-collapsible")
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_OptionList["default"].Details, detailsBackground && _OptionList["default"][(0, _cssUtilities.variationName)('Details-background', detailsBackground)])
  }, children));
}