"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReviewItem = ReviewItem;
exports.ReviewBlock = ReviewBlock;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _id = require("../../utilities/id");

var _legacy = require("../../utilities/legacy");

var _Theme = require("../Theme");

var _HeadingGroup = require("../HeadingGroup");

var _ = require("..");

var _ReviewItem = _interopRequireDefault(require("./ReviewItem.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var createId = (0, _id.createIdCreator)('ReviewBlock');

function ReviewItem(_ref) {
  var children = _ref.children,
      label = _ref.label,
      to = _ref.to,
      linkLabel = _ref.linkLabel,
      linkAccessibilityLabel = _ref.linkAccessibilityLabel,
      noWrap = _ref.noWrap;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.reviewBlock,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.spacing,
      spacing = _useThemeConfiguratio3 === void 0 ? 'none' : _useThemeConfiguratio3,
      divider = _useThemeConfiguratio2.divider;

  var className = (0, _cssUtilities.classNames)(_ReviewItem["default"].ReviewItem, spacing !== 'none' && _ReviewItem["default"].isContainer, _legacy.utilityDefaultBorderColor, divider === 'toContainerEdge' && _ReviewItem["default"].dividerToEdge);
  return /*#__PURE__*/_react["default"].createElement("div", {
    role: "row",
    className: className,
    key: label
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_ReviewItem["default"].Wrapper, noWrap && _ReviewItem["default"]['Wrapper-noWrap'])
  }, /*#__PURE__*/_react["default"].createElement("div", {
    role: "rowheader",
    className: _ReviewItem["default"].Label
  }, /*#__PURE__*/_react["default"].createElement(_.Text, {
    subdued: true
  }, label)), /*#__PURE__*/_react["default"].createElement("div", {
    role: "cell",
    className: _ReviewItem["default"].Content
  }, children)), to ? /*#__PURE__*/_react["default"].createElement("div", {
    role: "cell"
  }, /*#__PURE__*/_react["default"].createElement(_.Link, {
    to: to,
    accessibilityLabel: linkAccessibilityLabel
  }, /*#__PURE__*/_react["default"].createElement(_.Text, {
    size: "small"
  }, linkLabel))) : null);
}

function ReviewBlock(_ref2) {
  var children = _ref2.children,
      title = _ref2.title,
      titleHidden = _ref2.titleHidden;
  var id = (0, _id.useId)(undefined, createId);

  var _useThemeConfiguratio4 = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio5 = _useThemeConfiguratio4.reviewBlock,
      _useThemeConfiguratio6 = _useThemeConfiguratio5.background,
      background = _useThemeConfiguratio6 === void 0 ? 'transparent' : _useThemeConfiguratio6,
      _useThemeConfiguratio7 = _useThemeConfiguratio5.spacing,
      spacing = _useThemeConfiguratio7 === void 0 ? 'none' : _useThemeConfiguratio7;

  var className = (0, _cssUtilities.classNames)(_ReviewItem["default"].ReviewBlock, background && _ReviewItem["default"][(0, _cssUtilities.variationName)('ReviewBlock-background', background)], spacing === 'none' && _ReviewItem["default"].isContainer, _legacy.utilityDefaultBorderColor);

  var titleMarkup = /*#__PURE__*/_react["default"].createElement(_.Heading, {
    id: id
  }, title);

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, titleHidden ? /*#__PURE__*/_react["default"].createElement(_.View, {
    visibility: "hidden"
  }, titleMarkup) : titleMarkup, /*#__PURE__*/_react["default"].createElement(_HeadingGroup.HeadingGroup, null, /*#__PURE__*/_react["default"].createElement("div", {
    "aria-labelledby": id,
    role: "table",
    className: className
  }, children)));
}