"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Section = Section;
exports.SectionContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _HeadingGroup = require("../HeadingGroup");

var _View = require("../View");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SectionContext = /*#__PURE__*/(0, _react.createContext)(undefined);
exports.SectionContext = SectionContext;

function useSection() {
  return (0, _react.useContext)(SectionContext);
}

function Section(_ref) {
  var _context$level;

  var accessibilityLabel = _ref.accessibilityLabel,
      background = _ref.background,
      border = _ref.border,
      borderColor = _ref.borderColor,
      borderRadius = _ref.borderRadius,
      borderWidth = _ref.borderWidth,
      padding = _ref.padding,
      children = _ref.children;
  var context = useSection();
  var level = ((_context$level = context === null || context === void 0 ? void 0 : context.level) !== null && _context$level !== void 0 ? _context$level : 0) + 1;
  return /*#__PURE__*/_react["default"].createElement(SectionContext.Provider, {
    value: {
      level: level
    }
  }, /*#__PURE__*/_react["default"].createElement(_View.View, {
    accessibilityLabel: accessibilityLabel,
    background: background,
    border: border,
    borderColor: borderColor,
    borderRadius: borderRadius,
    borderWidth: borderWidth,
    padding: padding,
    role: "region"
  }, level > 1 ? /*#__PURE__*/_react["default"].createElement(_HeadingGroup.HeadingGroup, null, children) : children));
}