"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Shell = Shell;
exports.ShellSubheader = ShellSubheader;
exports.ShellSection = ShellSection;
exports.ShellSectionContent = ShellSectionContent;
exports.ShellFooter = ShellFooter;
exports.ShellDisclosure = ShellDisclosure;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Collapsible = require("../Collapsible");

var _InlineStack = require("../InlineStack");

var _HeadingGroup = require("../HeadingGroup");

var _Icon = require("../Icon");

var _Text = require("../Text");

var _legacy = require("../../utilities/legacy");

var _Shell = _interopRequireDefault(require("./Shell.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function Shell(_ref) {
  var children = _ref.children,
      headerPosition = _ref.headerPosition,
      subheaderPosition = _ref.subheaderPosition,
      footerPosition = _ref.footerPosition,
      subheaderHidden = _ref.subheaderHidden;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_Shell["default"].Shell, headerPosition && _Shell["default"][(0, _cssUtilities.variationName)('headerPosition', headerPosition)], subheaderPosition && _Shell["default"][(0, _cssUtilities.variationName)('subheaderPosition', subheaderPosition)], footerPosition && _Shell["default"][(0, _cssUtilities.variationName)('footerPosition', footerPosition)], subheaderHidden && _Shell["default"].subheaderHidden)
  }, children);
}

function ShellSubheader(_ref2) {
  var children = _ref2.children,
      alignment = _ref2.alignment;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_Shell["default"].Subheader, _Shell["default"][(0, _cssUtilities.variationName)('Subheader-alignment', alignment)])
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _Shell["default"].SubheaderInner
  }, children));
}

function ShellSection(_ref3) {
  var bordered = _ref3.bordered,
      background = _ref3.background,
      inlineSize = _ref3.inlineSize,
      blockSize = _ref3.blockSize,
      children = _ref3.children,
      secondary = _ref3.secondary,
      backgroundImage = _ref3.backgroundImage;
  var Element = secondary ? 'aside' : 'div';
  var style = backgroundImage ? {
    backgroundImage: "url(".concat(JSON.stringify(backgroundImage), ")")
  } : undefined;
  return /*#__PURE__*/_react["default"].createElement(_HeadingGroup.HeadingGroup, null, /*#__PURE__*/_react["default"].createElement(Element, {
    className: (0, _cssUtilities.classNames)(_Shell["default"].Section, bordered && _Shell["default"]['Section-bordered'], background && backgroundToLegacyClassName(background), background && _Shell["default"][(0, _cssUtilities.variationName)('Section-background', background)], inlineSize && _Shell["default"][(0, _cssUtilities.variationName)('Section-inlineSize', inlineSize)], blockSize && _Shell["default"][(0, _cssUtilities.variationName)('Section-blockSize', blockSize)], secondary && _Shell["default"]['Section-secondary']),
    style: inlineSize === 'toContainerEdge' ? style : undefined
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _Shell["default"].SectionInner,
    style: inlineSize === 'contentSize' ? style : undefined
  }, children)));
}

function ShellSectionContent(_ref4) {
  var children = _ref4.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _Shell["default"].SectionContent
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _Shell["default"].SectionContentInner
  }, children));
}

function ShellFooter(_ref5) {
  var children = _ref5.children;
  return /*#__PURE__*/_react["default"].createElement(_HeadingGroup.HeadingGroup, null, /*#__PURE__*/_react["default"].createElement("footer", {
    role: "contentinfo",
    className: _Shell["default"].Footer
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _Shell["default"].FooterInner
  }, children)));
}

// TODO: a11y
function ShellDisclosure(_ref6) {
  var children = _ref6.children,
      detail = _ref6.detail,
      labels = _ref6.labels,
      icon = _ref6.icon,
      bordered = _ref6.bordered,
      background = _ref6.background;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var _ref7 = open ? {
    text: labels.closed,
    icon: /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
      source: "chevronUp",
      size: "small",
      appearance: "interactive"
    })
  } : {
    text: labels.open,
    icon: /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
      source: "chevronDown",
      size: "small",
      appearance: "interactive"
    })
  },
      text = _ref7.text,
      disclosureIcon = _ref7.icon;

  var contentId = 'disclosure_content';
  return /*#__PURE__*/_react["default"].createElement("aside", {
    className: (0, _cssUtilities.classNames)(_Shell["default"].Disclosure, bordered && _Shell["default"]['Disclosure-bordered'], background && backgroundToLegacyClassName(background), background && _Shell["default"][(0, _cssUtilities.variationName)('Disclosure-background', background)])
  }, /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    className: (0, _cssUtilities.classNames)(_Shell["default"].DisclosureButton, _legacy.utilityDefaultBorderColor),
    onClick: function onClick() {
      return setOpen(function (open) {
        return !open;
      });
    },
    "aria-pressed": open,
    "aria-controls": contentId,
    "aria-expanded": open
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: _Shell["default"].DisclosureLayout
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    spacing: "tight",
    alignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: icon,
    size: "large",
    appearance: "interactive"
  }), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, text), disclosureIcon), detail)), /*#__PURE__*/_react["default"].createElement(_Collapsible.Collapsible, {
    open: open,
    id: contentId
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_Shell["default"].DisclosureContent, _legacy.utilityDefaultBorderColor)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _Shell["default"].DisclosureContentInner
  }, children))));
}

function backgroundToLegacyClassName(background) {
  switch (background) {
    case 'surfacePrimary':
      return _legacy.colorSurfacePrimary;

    case 'surfaceSecondary':
      return _legacy.colorSurfaceSecondary;

    case 'surfaceTertiary':
      return _legacy.colorSurfaceTertiary;
  }
}