"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withControls = exports.readonly = exports.disabled = exports.error = exports.minMaxAndStep = exports.step = exports.minAndMax = exports.max = exports.min = exports.defaultState = exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _BlockStack = require("../BlockStack");

var _InlineStack = require("../InlineStack");

var _Text = require("../Text");

var _Divider = require("../Divider");

var _Stepper = require("./Stepper");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var meta = {
  component: _Stepper.Stepper,
  title: 'checkout-web-ui/Stepper',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('stepper', 'textFields', 'primaryButton'), function (story) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        padding: '1em'
      }
    }, story());
  }]
};
var _default = meta;
exports["default"] = _default;
var defaultProps = {
  label: 'Quantity'
};

var defaultState = function defaultState() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, defaultProps);
};

exports.defaultState = defaultState;

var min = function min() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    min: 3
  }));
};

exports.min = min;

var max = function max() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    max: 5
  }));
};

exports.max = max;

var minAndMax = function minAndMax() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    min: 1,
    max: 5
  }));
};

exports.minAndMax = minAndMax;

var step = function step() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    step: 0.5
  }));
};

exports.step = step;

var minMaxAndStep = function minMaxAndStep() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    step: 2,
    min: 0,
    max: 5
  }));
};

exports.minMaxAndStep = minMaxAndStep;

var error = function error() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    error: "Limit reached"
  }));
};

exports.error = error;

var disabled = function disabled() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    disabled: true
  }));
};

exports.disabled = disabled;

var readonly = function readonly() {
  return /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    value: 10,
    readonly: true
  }));
};

exports.readonly = readonly;

function StepperWithState(props) {
  var _useState = (0, _react.useState)(1),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = _slicedToArray(_useState3, 2),
      value1 = _useState4[0],
      setValue1 = _useState4[1];

  var _useState5 = (0, _react.useState)(undefined),
      _useState6 = _slicedToArray(_useState5, 2),
      error = _useState6[0],
      setError = _useState6[1];

  var max = 10;

  var handleChange = function handleChange(val) {
    setValue(Number(val));
  };

  var handleMaxValueChange = function handleMaxValueChange(value) {
    var numVal = Number(value);

    if (max && numVal > max) {
      setError('Value exceeds max');
      return;
    }

    if (numVal < 0) {
      setError('Value less than min');
      return;
    }

    setValue1(numVal);
    setError(undefined);
  };

  return /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, props, {
    value: value,
    onChange: handleChange
  })), /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, {
    spacing: "extraTight"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "onChange value: "), /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    subdued: true
  }, value))), /*#__PURE__*/_react["default"].createElement(_Divider.Divider, null), /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "With error when max of 10 exceeded"), /*#__PURE__*/_react["default"].createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    max: max,
    value: value1,
    onChange: handleMaxValueChange,
    error: error
  })), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, null, "onChange value: "), /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    subdued: true
  }, value1)));
}

var withControls = function withControls(props) {
  return /*#__PURE__*/_react["default"].createElement(StepperWithState, props);
};

exports.withControls = withControls;
withControls.args = {
  accessibilityDescription: 'Number of sprockets',
  disabled: false,
  error: '',
  label: 'Quantity',
  min: undefined,
  max: undefined,
  readonly: false,
  spinner: true,
  step: undefined
};