"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tag = Tag;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Icon = require("../Icon");

var _Truncate = require("../Truncate");

var _Tag = _interopRequireDefault(require("./Tag.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Tag(_ref) {
  var children = _ref.children,
      icon = _ref.icon,
      onRemove = _ref.onRemove,
      removeControlAccessibilityLabel = _ref.removeControlAccessibilityLabel;
  var tagClassNames = (0, _cssUtilities.classNames)(_Tag["default"].Tag);
  var labelClassNames = (0, _cssUtilities.classNames)(_Tag["default"].Label, Boolean(onRemove) && _Tag["default"].removable);
  var iconClassNames = (0, _cssUtilities.classNames)(_Tag["default"].Icon);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: tagClassNames
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: labelClassNames
  }, icon && /*#__PURE__*/_react["default"].createElement("span", {
    className: iconClassNames
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: icon,
    size: "large"
  })), /*#__PURE__*/_react["default"].createElement(_Truncate.Truncate, null, children)), Boolean(onRemove) && /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    className: _Tag["default"].Button,
    onClick: onRemove,
    "aria-label": removeControlAccessibilityLabel
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "close",
    size: "base"
  })));
}