"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemovableTags = exports.TagStory = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _InlineStack = require("../InlineStack");

var _Text = require("../Text");

var _Icon = require("../Icon");

var _storybookUtilities = require("../../storybook-utilities");

var _Tag = require("./Tag");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var meta = {
  component: _Tag.Tag,
  title: 'checkout-web-ui/Tag',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('tag')],
  argTypes: {
    icon: {
      control: {
        type: 'select',
        options: [undefined].concat(_toConsumableArray(_Icon.AVAILABLE_ICONS))
      }
    }
  }
};
var _default = meta;
exports["default"] = _default;

var Content = function Content() {
  return /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    emphasized: true
  }, "Hello, world");
};

var TagStory = function TagStory(props) {
  return /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, Array(3).fill('Hello, world').map(function (text, i) {
    return /*#__PURE__*/_react["default"].createElement(_Tag.Tag, Object.assign({}, props, {
      key: text
    }), /*#__PURE__*/_react["default"].createElement(_Text.Text, {
      emphasized: true
    }, text, " ", i + 1, "!"));
  }));
};

exports.TagStory = TagStory;
TagStory.args = {
  onRemove: 'javascript:;',
  removeControlAccessibilityLabel: 'Remove tag',
  icon: undefined
};
TagStory.story = {
  name: 'Tag'
};

var RemovableTags = function RemovableTags() {
  return /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(_Tag.Tag, {
    removeControlAccessibilityLabel: "Remove tag",
    onRemove: function onRemove() {}
  }, /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement(_Tag.Tag, {
    icon: "discount",
    removeControlAccessibilityLabel: "Remove tag",
    onRemove: function onRemove() {}
  }, /*#__PURE__*/_react["default"].createElement(Content, null)));
};

exports.RemovableTags = RemovableTags;