"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Text = Text;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _legacy = require("../../utilities/legacy");

var _typographyStyles = _interopRequireDefault(require("../../utilities/typography-styles.css"));

var _Text = _interopRequireDefault(require("./Text.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function Text(_ref) {
  var children = _ref.children,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'base' : _ref$size,
      emphasized = _ref.emphasized,
      subdued = _ref.subdued,
      appearance = _ref.appearance,
      role = _ref.role,
      style = _ref.style,
      id = _ref.id;
  var className = (0, _cssUtilities.classNames)(_Text["default"].Text, emphasized && _Text["default"].emphasized, emphasized && _legacy.utilityDefaultTextColorEmphasized, subdued && _Text["default"].subdued, subdued && _legacy.utilityDefaultTextColorSubdued, size && _Text["default"][(0, _cssUtilities.variationName)('size', size)], appearance && _Text["default"][(0, _cssUtilities.variationName)('appearance', appearance)], appearance && appearance === 'accent' && _legacy.utilityDefaultColorAccent, style && _typographyStyles["default"][style]);
  var content = emphasized ? /*#__PURE__*/_react["default"].createElement("strong", null, children) : children;
  var defaultProps = {
    className: className,
    id: id
  };

  if (typeof role === 'string') {
    switch (role) {
      case 'address':
        return /*#__PURE__*/_react["default"].createElement("address", defaultProps, content);

      case 'deletion':
        return /*#__PURE__*/_react["default"].createElement("del", defaultProps, content);

      default:
        throw new Error('Invalid Text’s role');
    }
  }

  if (_typeof(role) === 'object') {
    switch (role.type) {
      case 'abbreviation':
        return /*#__PURE__*/_react["default"].createElement("abbr", Object.assign({
          defaultProps: defaultProps,
          className: (0, _cssUtilities.classNames)(className, _Text["default"].Abbr)
        }, {
          title: role["for"]
        }), content);

      case 'directional-override':
        return /*#__PURE__*/_react["default"].createElement("bdo", Object.assign({}, defaultProps, {
          dir: role.direction
        }), content);

      case 'datetime':
        return /*#__PURE__*/_react["default"].createElement("time", Object.assign({}, defaultProps, {
          dateTime: role.machineReadable
        }), content);

      default:
        throw new Error('Invalid Text’s role');
    }
  }

  var Component = emphasized ? 'strong' : 'span';
  return /*#__PURE__*/_react["default"].createElement(Component, defaultProps, children);
}