"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readonly = exports.disabled = exports.accessibilityDescription = exports.withTooltip = exports.withIcon = exports.withSuffix = exports.withPrefix = exports.multiline = exports.errorState = exports.prefilledContent = exports.inputTypeTelephone = exports.inputTypeEmail = exports.inputTypeNumber = exports.defaultState = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _FormLayout = require("../FormLayout");

var _InlineStack = require("../InlineStack");

var _Tooltip = require("../Tooltip");

var _Icon = require("../Icon");

var _TextField = require("./TextField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _TextField.TextField,
  title: 'checkout-web-ui/TextField',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('textFields')]
};
var _default = meta;
exports["default"] = _default;

var defaultState = function defaultState() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Name"
  });
};

exports.defaultState = defaultState;

var inputTypeNumber = function inputTypeNumber() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Quantity",
    type: "number"
  });
};

exports.inputTypeNumber = inputTypeNumber;

var inputTypeEmail = function inputTypeEmail() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Email",
    type: "email"
  });
};

exports.inputTypeEmail = inputTypeEmail;

var inputTypeTelephone = function inputTypeTelephone() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Phone number",
    type: "telephone"
  });
};

exports.inputTypeTelephone = inputTypeTelephone;

var prefilledContent = function prefilledContent() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Group",
    value: "Shopifolk"
  });
};

exports.prefilledContent = prefilledContent;

var errorState = function errorState() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Name",
    error: "Enter a name"
  });
};

exports.errorState = errorState;

var multiline = function multiline() {
  return /*#__PURE__*/_react["default"].createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Review",
    multiline: true
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Review",
    multiline: 2
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Review",
    multiline: 3
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Review",
    multiline: 4
  }));
};

exports.multiline = multiline;

var withPrefix = function withPrefix() {
  return /*#__PURE__*/_react["default"].createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Amount",
    prefix: "$"
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Amount",
    prefix: "USD"
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Amount (prefilled)",
    prefix: "$",
    value: "7"
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Amount (prefilled)",
    prefix: "USD",
    multiline: 5,
    value: "77"
  }));
};

exports.withPrefix = withPrefix;

var withSuffix = function withSuffix() {
  return /*#__PURE__*/_react["default"].createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Amount",
    suffix: "$"
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Amount",
    suffix: "CAD"
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Amount",
    suffix: "CAD",
    multiline: 5
  }));
};

exports.withSuffix = withSuffix;

var withIcon = function withIcon() {
  return /*#__PURE__*/_react["default"].createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Phone number",
    icon: "mobile"
  }), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Phone number",
    icon: "mobile",
    multiline: 5
  }));
};

exports.withIcon = withIcon;

var withTooltip = function withTooltip() {
  return /*#__PURE__*/_react["default"].createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Address"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center",
    spacing: "tight"
  }, /*#__PURE__*/_react["default"].createElement(_Tooltip.Tooltip, {
    content: "In case we need to contact you about your order"
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "questionFill",
    size: "large",
    appearance: "subdued",
    accessibilityLabel: "More information"
  })))), /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Notes",
    multiline: 5
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center",
    spacing: "tight"
  }, /*#__PURE__*/_react["default"].createElement(_Tooltip.Tooltip, {
    content: "In case we need to contact you about your order"
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: "questionFill",
    size: "large",
    appearance: "subdued",
    accessibilityLabel: "More information"
  })))));
};

exports.withTooltip = withTooltip;

var accessibilityDescription = function accessibilityDescription() {
  return /*#__PURE__*/_react["default"].createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Email",
    accessibilityDescription: "Contact information - Shop 1"
  }));
};

exports.accessibilityDescription = accessibilityDescription;

var disabled = function disabled() {
  return /*#__PURE__*/_react["default"].createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Order number",
    disabled: true
  }));
};

exports.disabled = disabled;

var readonly = function readonly() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, {
    label: "Order number",
    readonly: true
  });
};

exports.readonly = readonly;