"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToggleButton = ToggleButton;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _ToggleButtonGroup = _interopRequireDefault(require("./ToggleButtonGroup.css"));

var _hooks = require("./hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function ToggleButton(_ref) {
  var id = _ref.id,
      children = _ref.children;

  var _useToggleButtons = (0, _hooks.useToggleButtons)(),
      selectedItem = _useToggleButtons.selectedItem,
      onChange = _useToggleButtons.onChange;

  var selected = selectedItem === id;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_ToggleButtonGroup["default"].ToggleButton)
  }, /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    "aria-pressed": selected,
    onClick: function onClick() {
      onChange(id);
    },
    className: (0, _cssUtilities.classNames)(_ToggleButtonGroup["default"].Button, _defineProperty({}, _ToggleButtonGroup["default"]['Button-selected'], selected))
  }, children));
}