"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AutoHeadingGroup = AutoHeadingGroup;

var _react = _interopRequireDefault(require("react"));

var _context = require("./context");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function AutoHeadingGroup(_ref) {
  var children = _ref.children,
      explicitLevel = _ref.level;
  var currentLevel = (0, _context.useAutoHeadingLevel)();

  if (currentLevel != null && explicitLevel != null && explicitLevel > currentLevel) {
    throw new Error("You are trying to nest a heading group with level ".concat(explicitLevel, " inside a context where the current heading level is ").concat(currentLevel, ". This will create a broken document outline."));
  }

  var level = explicitLevel !== null && explicitLevel !== void 0 ? explicitLevel : (currentLevel !== null && currentLevel !== void 0 ? currentLevel : 0) + 1;
  return /*#__PURE__*/_react["default"].createElement(_context.AutoHeadingContext.Provider, {
    value: level
  }, children);
}