function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { Text } from '../Text';
import { Autocomplete, AutocompleteOptions, AutocompleteOption } from './Autocomplete';
var meta = {
  component: Autocomplete,
  title: 'checkout-web-ui/Autocomplete',
  decorators: [withKnobs, themeWithKnobs('textFields')]
};
export default meta;

function Basic() {
  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      options = _useState4[0],
      setOptions = _useState4[1];

  var handleInput = function handleInput(value) {
    setValue(value);

    if (value === '') {
      setOptions([]);
      return;
    }

    setOptions(_toConsumableArray(Array(50).keys()).map(function (i) {
      return "".concat(i + 1, " Saint Urbain Street, Montreal, QC, Canada");
    }).filter(function (option) {
      return option.startsWith(value);
    }).slice(0, 5));
  };

  var onSelectOption = function onSelectOption(value) {
    setValue(value);
    setOptions([]);
  };

  return /*#__PURE__*/React.createElement(Autocomplete, {
    id: "address",
    label: "Address",
    name: "address",
    onInput: handleInput,
    onSelectOption: onSelectOption,
    options: options,
    value: value,
    ariaLabel: "Close Predictions",
    title: "Suggestions"
  }, /*#__PURE__*/React.createElement(AutocompleteOptions, null, options && options.map(function (option) {
    return /*#__PURE__*/React.createElement(AutocompleteOption, {
      key: option
    }, /*#__PURE__*/React.createElement(Text, {
      emphasized: true
    }, /*#__PURE__*/React.createElement("strong", null, value)), option.slice(value.length));
  })));
}

export var basic = function basic() {
  return /*#__PURE__*/React.createElement(Basic, null);
};