import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { ButtonGroup } from '../ButtonGroup';
import { Heading } from '../Heading';
import { BlockStack } from '../BlockStack';
import { TextBlock } from '../TextBlock';
import { TextContainer } from '../TextContainer';
import { Divider } from '../Divider';
import { Banner } from '../Banner';
import { InlineStack } from '../InlineStack';
import { View } from '../View';
import { Button } from './Button';
var meta = {
  component: Button,
  title: 'checkout-web-ui/Button',
  decorators: [withKnobs, themeWithKnobs('primaryButton', 'secondaryButton')],
  argTypes: {
    kind: {
      control: {
        type: 'select',
        options: [undefined, 'primary', 'secondary', 'plain']
      }
    },
    appearance: {
      control: {
        type: 'select',
        options: [undefined, 'monochrome', 'critical']
      }
    },
    size: {
      control: {
        type: 'select',
        options: [undefined, 'base', 'large']
      }
    }
  }
};
export default meta;
export var ButtonStory = function ButtonStory(args) {
  return /*#__PURE__*/React.createElement(Button, args, "Button");
};
ButtonStory.args = {
  kind: 'primary',
  size: 'base',
  appearance: undefined,
  to: 'javascript:;',
  fill: false,
  loading: false,
  loadingLabel: 'Processing…',
  accessibilityLabel: '',
  disabled: false
};
ButtonStory.story = {
  name: 'Button'
};
var content = 'Pay now';
export var AllButtons = function AllButtons() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Type"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "primary - secondary - plain")), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    kind: "primary"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain"
  }, content)), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Size"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "base - large - extraLarge")), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, null, content), /*#__PURE__*/React.createElement(Button, {
    size: "large"
  }, content), /*#__PURE__*/React.createElement(Button, {
    size: "extraLarge"
  }, content)), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Responsive size"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "Default: ", /*#__PURE__*/React.createElement("code", null, "extraLarge"), /*#__PURE__*/React.createElement("br", null), " Media small: ", /*#__PURE__*/React.createElement("code", null, "large"), /*#__PURE__*/React.createElement("br", null), " Media medium: ", /*#__PURE__*/React.createElement("code", null, "base"), /*#__PURE__*/React.createElement("br", null), " Media large: ", /*#__PURE__*/React.createElement("code", null, "base"))), /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(Button, {
    size: {
      base: 'extraLarge',
      small: 'large',
      medium: 'base',
      large: 'base'
    }
  }, content)), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Appearance"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "monochrome - critical")), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content)), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    appearance: "critical"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    appearance: "critical"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    appearance: "critical"
  }, content)), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Disabled"), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    disabled: true
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    disabled: true
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    disabled: true
  }, content)), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    disabled: true,
    appearance: "monochrome"
  }, content)), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    disabled: true,
    appearance: "critical"
  }, content)), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Loading"), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    loading: true,
    disabled: true
  }, content), /*#__PURE__*/React.createElement(Button, {
    loading: true,
    kind: "secondary",
    disabled: true
  }, content), /*#__PURE__*/React.createElement(Button, {
    loading: true,
    kind: "plain",
    disabled: true
  }, content)), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    loading: true,
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    loading: true,
    kind: "secondary",
    disabled: true,
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    loading: true,
    kind: "plain",
    disabled: true,
    appearance: "monochrome"
  }, content)), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    loading: true,
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/React.createElement(Button, {
    loading: true,
    kind: "secondary",
    disabled: true,
    appearance: "critical"
  }, content), /*#__PURE__*/React.createElement(Button, {
    loading: true,
    kind: "plain",
    disabled: true,
    appearance: "critical"
  }, content)), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Appearance"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "monochrome inside Banner")), /*#__PURE__*/React.createElement(Banner, {
    status: "info",
    title: "This is a title"
  }, /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/React.createElement(Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))), /*#__PURE__*/React.createElement(Banner, {
    status: "warning",
    title: "This is a title"
  }, /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/React.createElement(Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))), /*#__PURE__*/React.createElement(Banner, {
    status: "critical",
    title: "This is a title"
  }, /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/React.createElement(Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))), /*#__PURE__*/React.createElement(Banner, {
    status: "success",
    title: "This is a title"
  }, /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/React.createElement(Button, {
    kind: "primary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "secondary",
    appearance: "monochrome"
  }, content), /*#__PURE__*/React.createElement(Button, {
    kind: "plain",
    appearance: "monochrome"
  }, content))));
};