import React from 'react';
import { mount } from '@quilted/react-testing/dom';
import { Icon } from '../Icon';
import { CalloutHeader } from './CalloutHeader';

function Child() {
  return /*#__PURE__*/React.createElement("div", null);
}

describe('<CalloutHeader />', function () {
  it('renders its children', function () {
    var calloutHeader = mount( /*#__PURE__*/React.createElement(CalloutHeader, {
      status: "success"
    }, /*#__PURE__*/React.createElement(Child, null), /*#__PURE__*/React.createElement(Child, null)));
    expect(calloutHeader).toContainReactComponentTimes(Child, 2);
  });
  it('renders a checkmark icon', function () {
    var calloutHeader = mount( /*#__PURE__*/React.createElement(CalloutHeader, {
      status: "success"
    }, /*#__PURE__*/React.createElement(Child, null)));
    expect(calloutHeader).toContainReactComponent(Icon, {
      source: 'checkmarkCircle'
    });
  });
  it('renders a cancelled icon', function () {
    var calloutHeader = mount( /*#__PURE__*/React.createElement(CalloutHeader, {
      status: "cancelled"
    }, /*#__PURE__*/React.createElement(Child, null)));
    expect(calloutHeader).toContainReactComponent(Icon, {
      source: 'cancelCircle'
    });
  });
});