function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useRef } from 'react';
import { classNames } from '@shopify/css-utilities';
import { useTransition } from '../../utilities/transition';
import styles from './Collapsible.css';
export function Collapsible(_ref) {
  var id = _ref.id,
      open = _ref.open,
      _ref$minSize = _ref.minSize,
      minSize = _ref$minSize === void 0 ? 0 : _ref$minSize,
      fade = _ref.fade,
      children = _ref.children;
  var transition = useTransition(open, 'slow');
  var div = useRef(null);
  var lazyCssHeight = new Map([['enter', function () {
    return {
      height: minSize
    };
  }], ['entering', function () {
    var _div$current;

    return {
      height: div === null || div === void 0 ? void 0 : (_div$current = div.current) === null || _div$current === void 0 ? void 0 : _div$current.clientHeight
    };
  }], ['entered', function () {
    return {
      height: 'auto'
    };
  }], ['exit', function () {
    var _div$current2;

    return {
      height: div === null || div === void 0 ? void 0 : (_div$current2 = div.current) === null || _div$current2 === void 0 ? void 0 : _div$current2.clientHeight
    };
  }], ['exiting', function () {
    return {
      height: minSize
    };
  }], ['exited', function () {
    return {
      height: minSize
    };
  }]]);
  var showFade = !open && fade;
  return /*#__PURE__*/React.createElement("div", {
    id: id,
    style: _objectSpread({}, lazyCssHeight.get(transition)()),
    className: classNames(styles.Collapsible, showFade && styles.fade),
    "aria-expanded": open,
    hidden: transition === 'exited' && minSize === 0
  }, /*#__PURE__*/React.createElement("div", {
    ref: div
  }, children));
}