function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useCallback } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { faker } from '../../test-utilities';
import { themeWithKnobs } from '../../storybook-utilities';
import { BlockSpacer } from '../BlockSpacer';
import { Button } from '../Button';
import { Text } from '../Text';
import { View } from '../View';
import { Collapsible } from './Collapsible'; // eslint-disable-next-line import/no-anonymous-default-export

export default {
  title: 'checkout-web-ui/Collapsible',
  component: Collapsible,
  decorators: [withKnobs, themeWithKnobs()]
};
export var basicCollapsible = function basicCollapsible(args) {
  return /*#__PURE__*/React.createElement(Story, args);
};
basicCollapsible.args = {
  id: 'basic-collapsible',
  minSize: 0,
  fade: false
};
basicCollapsible.story = {
  name: 'Collapsible'
};
var content = faker.lorem.paragraphs(3);

function Story(_ref) {
  var id = _ref.id,
      _ref$minSize = _ref.minSize,
      minSize = _ref$minSize === void 0 ? 0 : _ref$minSize,
      fade = _ref.fade;

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var handleToggle = useCallback(function () {
    return setOpen(function (open) {
      return !open;
    });
  }, []);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
    onPress: handleToggle,
    "aria-expanded": open,
    "aria-controls": id
  }, "Toggle"), /*#__PURE__*/React.createElement(BlockSpacer, null), /*#__PURE__*/React.createElement(Collapsible, {
    open: open,
    id: id,
    minSize: minSize,
    fade: fade
  }, /*#__PURE__*/React.createElement(View, {
    border: "base",
    padding: "base"
  }, /*#__PURE__*/React.createElement(Text, null, content))));
}

export var accordion = function accordion() {
  return /*#__PURE__*/React.createElement(Accordion, null);
};

function Accordion() {
  var _useState3 = useState(-1),
      _useState4 = _slicedToArray(_useState3, 2),
      openId = _useState4[0],
      setOpenId = _useState4[1];

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
    onPress: function onPress() {
      setOpenId(0);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 0,
    "aria-controls": "collapsible0"
  }, "Panel 1"), /*#__PURE__*/React.createElement(Collapsible, {
    open: openId === 0,
    id: "collapsible0"
  }, /*#__PURE__*/React.createElement(View, {
    padding: "base"
  }, /*#__PURE__*/React.createElement(Text, null, content))), /*#__PURE__*/React.createElement(Button, {
    onPress: function onPress() {
      setOpenId(1);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 1,
    "aria-controls": "collapsible1"
  }, "Panel 2"), /*#__PURE__*/React.createElement(Collapsible, {
    open: openId === 1,
    id: "collapsible1"
  }, /*#__PURE__*/React.createElement(View, {
    padding: "base"
  }, /*#__PURE__*/React.createElement(Text, null, content))), /*#__PURE__*/React.createElement(Button, {
    onPress: function onPress() {
      setOpenId(2);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 2,
    "aria-controls": "collapsible2"
  }, "Panel 3"), /*#__PURE__*/React.createElement(Collapsible, {
    open: openId === 2,
    id: "collapsible2"
  }, /*#__PURE__*/React.createElement(View, {
    padding: "base"
  }, /*#__PURE__*/React.createElement(Text, null, content))));
}