import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { useResponsive } from '../../utilities/responsive';
import { ConnectedContext } from './hook';
import styles from './Connected.css';

/**
 * Connected groups inputs inline and maintains a consistent height across
 * inputs. It is commonly used for displaying a single-line TextField or Select
 * inline with a Button.
 */
export function Connected(_ref) {
  var children = _ref.children,
      _ref$spacing = _ref.spacing,
      spacing = _ref$spacing === void 0 ? 'base' : _ref$spacing,
      leading = _ref.leading,
      trailing = _ref.trailing,
      _ref$stack = _ref.stack,
      stack = _ref$stack === void 0 ? false : _ref$stack;
  var responsiveClassNames = useResponsive({
    stack: stack
  });
  return /*#__PURE__*/React.createElement(ConnectedContext.Provider, {
    value: true
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.Connected, leading && styles[variationName('leading', leading)], trailing && styles[variationName('trailing', trailing)], styles[variationName('spacing', spacing)], responsiveClassNames.map(function (className) {
      return styles[className];
    }))
  }, children));
}