import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import styles from './Divider.css';
export function Divider(_ref) {
  var _ref$alignment = _ref.alignment,
      alignment = _ref$alignment === void 0 ? 'center' : _ref$alignment,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 'thin' : _ref$width,
      _ref$direction = _ref.direction,
      direction = _ref$direction === void 0 ? 'horizontal' : _ref$direction,
      blockSpacing = _ref.blockSpacing,
      children = _ref.children;
  var hasChildren = React.Children.count(children) > 0;
  return /*#__PURE__*/React.createElement("div", {
    role: "separator",
    className: classNames(styles.Divider, styles[variationName('direction', direction)], alignment && hasChildren && styles[variationName('alignment', alignment)], blockSpacing && styles[variationName('spacing', blockSpacing)], width && styles[variationName('borderWidth', width)])
  }, hasChildren && /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.DividerContent, styles[variationName('contentDirection', direction)], alignment && styles[variationName('contentAlignment', alignment)])
  }, children));
}