import React from 'react';
import { mount } from '@quilted/react-testing/dom';
import faker from 'faker';
import { Text } from '../Text';
import { Divider } from './Divider';
describe('<Divider />', function () {
  it('renders a single line by default', function () {
    var divider = mount( /*#__PURE__*/React.createElement(Divider, null));
    expect(divider).toContainReactComponent('div');
  });
  it('renders children', function () {
    var text = faker.lorem.words(2);
    var divider = mount( /*#__PURE__*/React.createElement(Divider, null, /*#__PURE__*/React.createElement(Text, null, text)));
    expect(divider).toContainReactComponent(Text, {
      children: text
    });
  });
});