import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import styles from './FlagIcon.css';
import { FLAG_ICON_BY_COUNTRY_CODE } from './images';
export function FlagIcon(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      countryCode = _ref.countryCode,
      size = _ref.size;
  var className = classNames(styles.FlagIcon, size && styles[variationName('size', size)]);
  return /*#__PURE__*/React.createElement("img", {
    alt: accessibilityLabel,
    className: className,
    src: FLAG_ICON_BY_COUNTRY_CODE[countryCode]
  });
}