import React from 'react';
import styles from './FormattedText.css';

/**
 * FormattedText replaces new line characters with HTML line breaks (`<br />`).
 * Use this component when you want to render text created by an editor or a `<textarea>`.
 * For more complex use cases involving basic HTML tags, format the content as a React component
 * and pass it in as a child. The component will recieve customized styling based on the supported tags.
 */
export function FormattedText(_ref) {
  var children = _ref.children;

  if (typeof children === 'string') {
    return /*#__PURE__*/React.createElement(React.Fragment, null, children.split('\n').filter(Boolean).map(function (content, index) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, index > 0 && /*#__PURE__*/React.createElement("br", null), content);
    }));
  } else {
    return /*#__PURE__*/React.createElement("div", {
      className: styles.FormattedText
    }, children);
  }
}