import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { utilityDefaultColorAccent, utilityDefaultTextColorSubdued } from '../../utilities/legacy';
import { arrowLeft, arrowRight, calendar, camera, cancelCircle, caretDown, cart, checkmark, checkmarkCircle, chevronDown, chevronUp, chevronRight, chevronLeft, close, critical, discount, delivered, delivery, disabled, errorFill, geolocation, info, list, locateMe, lock, map, marker, minus, mobile, plus, questionFill, reorder, spinner, spinnerSmall, store, success, truck, warning, warningCircle, warningFill, giftFill, external } from '../../icons';
import styles from './Icon.css';
var BUNDLED_ICONS = {
  arrowLeft: arrowLeft,
  arrowRight: arrowRight,
  calendar: calendar,
  camera: camera,
  cancelCircle: cancelCircle,
  caretDown: caretDown,
  cart: cart,
  checkmark: checkmark,
  checkmarkCircle: checkmarkCircle,
  chevronDown: chevronDown,
  chevronUp: chevronUp,
  chevronRight: chevronRight,
  chevronLeft: chevronLeft,
  close: close,
  critical: critical,
  discount: discount,
  delivered: delivered,
  delivery: delivery,
  disabled: disabled,
  errorFill: errorFill,
  geolocation: geolocation,
  info: info,
  list: list,
  locateMe: locateMe,
  lock: lock,
  map: map,
  marker: marker,
  minus: minus,
  mobile: mobile,
  plus: plus,
  questionFill: questionFill,
  reorder: reorder,
  spinner: spinner,
  spinnerSmall: spinnerSmall,
  store: store,
  success: success,
  truck: truck,
  warning: warning,
  warningCircle: warningCircle,
  warningFill: warningFill,
  giftFill: giftFill,
  external: external
};
export function Icon(_ref) {
  var source = _ref.source,
      appearance = _ref.appearance,
      size = _ref.size,
      accessibilityLabel = _ref.accessibilityLabel;
  var className = classNames(styles.Icon, appearance && styles[variationName('appearance', appearance)], appearance && appearance === 'accent' && utilityDefaultColorAccent, appearance && appearance === 'subdued' && utilityDefaultTextColorSubdued, size && styles[variationName('size', size)]);
  var SourceComponent = BUNDLED_ICONS[source];
  var contentMarkup = /*#__PURE__*/React.createElement(SourceComponent, {
    className: styles.Svg,
    focusable: "false",
    "aria-hidden": "true",
    role: "presentation"
  });
  return /*#__PURE__*/React.createElement("span", {
    className: className,
    "aria-label": accessibilityLabel
  }, contentMarkup);
}
export var AVAILABLE_ICONS = Object.keys(BUNDLED_ICONS);