import React from 'react';
import { faker } from '../../test-utilities';
import { TextContainer } from '../TextContainer';
import { View } from '../View';
import { Image } from './Image';
var meta = {
  component: Image,
  title: 'checkout-web-ui/Image',
  argTypes: {
    source: {
      name: 'source',
      type: {
        name: 'string',
        required: true
      },
      defaultValue: 'https://via.placeholder.com/320x180/eee',
      control: {
        type: 'text'
      }
    },
    description: {
      name: 'description',
      type: {
        name: 'string',
        required: false
      },
      defaultValue: 'placeholder.com',
      control: {
        type: 'text'
      }
    },
    loading: {
      name: 'loading',
      control: {
        type: 'select',
        options: ['eager', 'lazy'],
        required: false
      }
    },
    fit: {
      name: 'fit',
      control: {
        type: 'select',
        options: ['cover', 'contain'],
        required: false
      }
    }
  }
};
export default meta;

var Template = function Template(args) {
  return /*#__PURE__*/React.createElement(Image, args);
};

export var basicImage = Template.bind({});
export var lazyLoading = Template.bind({});
lazyLoading.args = {
  loading: 'lazy'
};
export var cover = Template.bind({});
cover.args = {
  sources: {
    base: [{
      source: 'https://via.placeholder.com/320x180/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 2
    }]
  },
  aspectRatio: 1,
  fit: 'cover'
};
cover.decorators = [function (Story) {
  return /*#__PURE__*/React.createElement(View, {
    maxInlineSize: 256,
    border: "base"
  }, /*#__PURE__*/React.createElement(Story, null));
}];
export var contain = Template.bind({});
contain.args = {
  sources: {
    base: [{
      source: 'https://via.placeholder.com/320x180/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 2
    }]
  },
  aspectRatio: 1,
  fit: 'contain'
};
contain.decorators = [function (Story) {
  return /*#__PURE__*/React.createElement(View, {
    maxInlineSize: 256,
    border: "base"
  }, /*#__PURE__*/React.createElement(Story, null));
}];
export var responsive = Template.bind({});
responsive.args = {
  sources: {
    small: [{
      source: 'https://via.placeholder.com/320x180/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 2
    }],
    medium: [{
      source: 'https://via.placeholder.com/640x360/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/1280x720/eee',
      resolution: 2
    }],
    large: [{
      source: 'https://via.placeholder.com/1280x720/eee',
      resolution: 1
    }, {
      source: 'https://via.placeholder.com/2560x1440/eee',
      resolution: 2
    }]
  }
};
export var aspectRatio = function aspectRatio(args) {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: 320
    }
  }, /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Image, args), /*#__PURE__*/React.createElement("p", null, faker.lorem.paragraphs(3))));
};
aspectRatio.args = {
  source: 'https://via.placeholder.com/640x360',
  aspectRatio: 3
};