function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useCallback, useEffect } from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { Text } from '../Text';
import { Truncate } from '../Truncate';
import { useThemeConfiguration } from '../Theme';
import { LabelledContext } from './context';
import styles from './Labelled.css';
export function Labelled(_ref) {
  var children = _ref.children,
      label = _ref.label,
      htmlFor = _ref.htmlFor,
      empty = _ref.empty,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'inside' : _ref$position,
      _ref$background = _ref.background,
      background = _ref$background === void 0 ? 'surfaceTertiary' : _ref$background,
      subdued = _ref.subdued,
      prefixed = _ref.prefixed,
      hasIcon = _ref.hasIcon;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      focused = _useState2[0],
      setFocused = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      wasNotEmpty = _useState4[0],
      setWasNotEmpty = _useState4[1];

  useEffect(function () {
    if (!empty) {
      setWasNotEmpty(true);
    } else if (!focused) {
      setWasNotEmpty(false);
    }
  }, [focused, empty]);
  var floating = (!empty || empty && wasNotEmpty) && position === 'inside';
  var handleFocus = useCallback(function () {
    setFocused(true);

    if (prefixed) {
      setWasNotEmpty(true);
    }
  }, [prefixed]);
  var handleBlur = useCallback(function () {
    return setFocused(false);
  }, []);

  var _useThemeConfiguratio = useThemeConfiguration(),
      typographyStyle = _useThemeConfiguratio.label.typographyStyle;

  return /*#__PURE__*/React.createElement(LabelledContext.Provider, {
    value: {
      onFocus: handleFocus,
      onBlur: handleBlur,
      focused: focused,
      floating: floating
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.Wrapper
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(_defineProperty({}, styles.floating, floating))
  }, /*#__PURE__*/React.createElement("label", {
    id: "".concat(htmlFor, "-label"),
    htmlFor: htmlFor,
    className: classNames(styles.Label, styles[variationName('Label-position', position)], subdued && styles['Label-subdued'], background && styles[variationName('Label-onBackground', background)], hasIcon && styles['Label-nextToIcon'])
  }, /*#__PURE__*/React.createElement(Text, {
    size: "small",
    subdued: true,
    style: typographyStyle
  }, /*#__PURE__*/React.createElement(Truncate, null, label))), children)));
}