function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { Button } from '../Button';
import { useThemeConfiguration } from '../Theme';
import typographyStyles from '../../utilities/typography-styles.css';
import { UnstyledLink } from './components';
import styles from './Link.css';

/**
 * Link is used to navigate the buyer to another page or section within the same page.
 */
export function Link(_ref) {
  var children = _ref.children,
      to = _ref.to,
      language = _ref.language,
      onPress = _ref.onPress,
      appearance = _ref.appearance,
      accessibilityLabel = _ref.accessibilityLabel,
      rest = _objectWithoutProperties(_ref, ["children", "to", "language", "onPress", "appearance", "accessibilityLabel"]);

  var _useThemeConfiguratio = useThemeConfiguration(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.link,
      colorHovered = _useThemeConfiguratio2.colorHovered,
      typographyStyle = _useThemeConfiguratio2.typographyStyle;

  if (!to) {
    return /*#__PURE__*/React.createElement(Button, Object.assign({
      onPress: onPress,
      kind: "plain",
      appearance: appearance
    }, rest), children);
  }

  return /*#__PURE__*/React.createElement(UnstyledLink, Object.assign({
    className: classNames(styles.Link, appearance && appearance === 'monochrome' ? styles.appearanceMonochrome : styles.appearanceDefault, colorHovered && styles[variationName('colorHovered', colorHovered)], typographyStyle && typographyStyles[typographyStyle]),
    to: to,
    onPress: onPress,
    language: language,
    accessibilityLabel: accessibilityLabel
  }, rest), children);
}