import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { TextBlock } from '../TextBlock';
import { Link } from './Link';
var meta = {
  component: Link,
  title: 'checkout-web-ui/Link',
  decorators: [withKnobs, themeWithKnobs('link')]
};
export default meta;
export var LinkComponent = function LinkComponent(args) {
  return /*#__PURE__*/React.createElement(TextBlock, null, "Learn more about our ", /*#__PURE__*/React.createElement(Link, args, "shipping policies"));
};
LinkComponent.args = {
  to: 'https://shopify.com',
  external: false,
  underline: false,
  appearance: undefined
};
LinkComponent.argTypes = {
  appearance: {
    control: {
      type: 'select',
      options: [undefined, 'monochrome']
    }
  }
};
export var all = function all() {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Link, {
    to: "https://shopify.com",
    external: false
  }, "Internal link"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Link, {
    to: "https://shopify.com",
    external: true
  }, "External link"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Link, {
    to: undefined
  }, "Link without `to` (rendered as a Button)"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(TextBlock, null, "Learn more about our", ' ', /*#__PURE__*/React.createElement(Link, {
    to: "https://shopify.com",
    appearance: "monochrome"
  }, "shipping policies"), ' ', "(`monochrome`)"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Link, {
    to: "https://shopify.com",
    accessibilityLabel: "Visit shopify.com"
  }, "Visit (with accessible label)"));
};