import React from 'react';
import faker from 'faker';
import { mountWithContext } from '../../test-utilities';
import { Link } from './Link';
import { UnstyledLink } from './components';
describe('<Link />', function () {
  it('renders an UnstyledLink if "to" is provided', function () {
    var props = {
      to: faker.internet.url()
    };
    var link = mountWithContext( /*#__PURE__*/React.createElement(Link, props));
    expect(link).toContainReactComponent(UnstyledLink, props);
  });
  it('renders a button if "to" is not provided', function () {
    var link = mountWithContext( /*#__PURE__*/React.createElement(Link, {
      onPress: function onPress() {
        return null;
      },
      to: undefined
    }));
    expect(link).toContainReactComponent('button');
  });
});