import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import styles from './List.css';
export function List(_ref) {
  var _ref$spacing = _ref.spacing,
      spacing = _ref$spacing === void 0 ? 'base' : _ref$spacing,
      _ref$marker = _ref.marker,
      marker = _ref$marker === void 0 ? 'bullet' : _ref$marker,
      children = _ref.children;
  var className = classNames(styles.List, spacing && styles[variationName('spacing', spacing)], marker && styles[variationName('marker', marker)]);
  var isOrderedList = marker === 'number';
  /*
  VoiceOver and Safari (Webkit) (macOS and iOS) remove list element
  semantics when list-style: none is used.
  https://www.scottohara.me/blog/2019/01/12/lists-and-safari.html
  */

  var role = marker === 'none' ? 'list' : undefined;
  var Element = isOrderedList ? 'ol' : 'ul';
  return (
    /*#__PURE__*/

    /* Needed to properly reset margins on ul / ol elements and not interfere
     * with layout components that use `*` selector to create gaps between children. */

    /* eslint-disable-next-line @shopify/jsx-prefer-fragment-wrappers */
    React.createElement("div", null, /*#__PURE__*/React.createElement(Element, {
      className: className,
      role: role
    }, children))
  );
}
export function ListItem(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React.createElement("li", {
    className: styles.ListItem
  }, children);
}