import React from 'react';
import { mountWithContext } from '../../test-utilities';
import { List, ListItem } from './List';
describe('<List />', function () {
  describe('children', function () {
    it('renders the children', function () {
      var content = 'Snowdevil';
      var list = mountWithContext( /*#__PURE__*/React.createElement(List, null, content));
      expect(list).toContainReactText(content);
    });
    it('renders a <ul> tag by default', function () {
      var content = 'Snowdevil';
      var list = mountWithContext( /*#__PURE__*/React.createElement(List, null, content));
      expect(list).toContainReactComponent('ul');
    });
  });
  describe('marker', function () {
    it('renders a <ol> tag when marker set to "number"', function () {
      var content = 'Snowdevil';
      var list = mountWithContext( /*#__PURE__*/React.createElement(List, {
        marker: "number"
      }, content));
      expect(list).toContainReactComponent('ol');
    });
    it('sets a role of "list" for accessibility when marker is "none"', function () {
      var content = 'Snowdevil';
      var list = mountWithContext( /*#__PURE__*/React.createElement(List, {
        marker: "none"
      }, content));
      expect(list).toContainReactComponent('ul', {
        role: 'list'
      });
    });
  });
});
describe('<ListItem />', function () {
  describe('children', function () {
    it('renders the children', function () {
      var content = 'Snowdevil';
      var list = mountWithContext( /*#__PURE__*/React.createElement(List, null, /*#__PURE__*/React.createElement(ListItem, null, content)));
      expect(list).toContainReactText(content);
    });
  });
});