function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useCallback, useEffect, useRef } from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { useResponsiveValue } from '../../utilities/responsiveValue';
import { useTranslate } from '../AppContext';
import { FocusTrap } from '../FocusTrap';
import { Portal } from '../Portal';
import { Heading } from '../Heading';
import { Icon } from '../Icon';
import { pixelOrPercent } from '../../utilities/units';
import { useTransition } from '../../utilities/transition';
import { createIdCreator, useId } from '../../utilities/id';
import styles from './Modal.css';
var createId = createIdCreator('ModalHeading');
var IFRAME_HEIGHT_NOT_ACCESSIBLE = -1;
export function Modal(_ref) {
  var maxInlineSize = _ref.maxInlineSize,
      blockSize = _ref.blockSize,
      open = _ref.open,
      title = _ref.title,
      titleHidden = _ref.titleHidden,
      source = _ref.source,
      _ref$noMountTransitio = _ref.noMountTransition,
      noMountTransition = _ref$noMountTransitio === void 0 ? false : _ref$noMountTransitio,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["maxInlineSize", "blockSize", "open", "title", "titleHidden", "source", "noMountTransition", "children"]);

  var blocking = rest.blocking;
  var onClose = rest.blocking ? undefined : rest.onClose;
  var translate = useTranslate();

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      iframeHeight = _useState2[0],
      setIframeHeight = _useState2[1];

  var activatorRef = useRef(null);
  var modalRef = useRef(null);
  var modalHeadingId = useId(undefined, createId);
  var transition = useTransition(open, 'fast', !noMountTransition);
  var transitionClassName = styles[variationName('transition', transition)];
  var isMobile = useResponsiveValue({
    base: true,
    medium: false
  });
  useEffect(function () {
    if (transition === 'enter') {
      document.body.style.overflow = 'hidden';
      activatorRef.current = document.activeElement;
    }

    if (transition === 'exited') {
      document.body.style.overflow = 'auto';
      if ((activatorRef === null || activatorRef === void 0 ? void 0 : activatorRef.current) instanceof HTMLElement) activatorRef.current.focus();
      setIframeHeight(undefined);
    }
  }, [transition]);

  var handleDialogFocus = function handleDialogFocus() {
    // workaround for browsers that don't support `preventScroll` for `focus`
    setTimeout(function () {
      var modal = modalRef.current;
      modal && modal.scrollTo(0, 0);
    }, 0);
  };

  useEffect(function () {
    var handleKeyDown = function handleKeyDown(event) {
      if ((event.key === 'Escape' || event.key === 'Esc') && !blocking) {
        onClose && onClose();
      }
    };

    document.addEventListener('keydown', handleKeyDown, false);
    return function () {
      document.removeEventListener('keydown', handleKeyDown, false);
    };
  }, [blocking, onClose]);
  var handleIFrameLoad = useCallback(function (evt) {
    var iframe = evt.target;

    if (iframe && iframe.contentWindow) {
      try {
        setIframeHeight(iframe.contentWindow.document.body.scrollHeight);
      } catch (_unused) {
        setIframeHeight(IFRAME_HEIGHT_NOT_ACCESSIBLE);
      }
    }
  }, []);

  function handleBackdropClick() {
    onClose && onClose();
  }

  if (transition === 'exited') return null;
  var ariaLabelOrLabelledby = titleHidden ? {
    'aria-label': title
  } : {
    'aria-labelledby': modalHeadingId
  };
  var titleMarkup = titleHidden ?
  /*#__PURE__*/
  // `null` breaks close button's right alignment
  React.createElement("span", null) : /*#__PURE__*/React.createElement(Heading, {
    level: 1,
    id: modalHeadingId
  }, title);
  var header = (!titleHidden || !blocking) && /*#__PURE__*/React.createElement("header", {
    className: styles.Header
  }, titleMarkup, !blocking && /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: styles.CloseButton,
    onClick: onClose,
    "aria-label": translate('close') || 'Close'
  }, /*#__PURE__*/React.createElement(Icon, {
    source: "close",
    size: "large"
  })));
  var content = source ? /*#__PURE__*/React.createElement("iframe", Object.assign({
    src: source,
    title: title,
    className: styles.IFrame
  }, iframeHeight && iframeHeight > 0 && {
    style: {
      height: iframeHeight
    }
  }, !blockSize && {
    onLoad: handleIFrameLoad
  })) : /*#__PURE__*/React.createElement("div", Object.assign({
    className: styles.Content
  }, (blockSize || isMobile) && {
    tabIndex: 0
  }), children);
  return /*#__PURE__*/React.createElement(Portal, null, /*#__PURE__*/React.createElement("div", {
    className: styles.Modal,
    ref: modalRef
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.Backdrop, transitionClassName),
    onClick: handleBackdropClick
  }), /*#__PURE__*/React.createElement(FocusTrap, {
    onContainerFocus: handleDialogFocus
  }, /*#__PURE__*/React.createElement("div", Object.assign({
    className: classNames(styles.Dialog, transitionClassName, _defineProperty({}, styles['Dialog-blockSizeFill'], blockSize === 'fill' || iframeHeight === -1)),
    role: "dialog",
    "aria-modal": true,
    style: _objectSpread({}, maxInlineSize && {
      maxWidth: pixelOrPercent(maxInlineSize === 'fill' ? 1 : maxInlineSize)
    })
  }, ariaLabelOrLabelledby), header, content))));
}