function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { faker } from '../../test-utilities';
import { themeWithKnobs, MockPrefersReducedMotion } from '../../storybook-utilities';
import { Text } from '../Text';
import { Button } from '../Button';
import { InlineStack } from '../InlineStack';
import { BlockStack } from '../BlockStack';
import { TextField } from '../TextField';
import { Modal } from './index';
var meta = {
  component: Modal,
  title: 'checkout-web-ui/Modal',
  decorators: [withKnobs, themeWithKnobs('headingLevel1')]
};
export default meta;

var Template = function Template(args) {
  return /*#__PURE__*/React.createElement(React.Fragment, null, process.env.A11Y_TESTS && /*#__PURE__*/React.createElement(MockPrefersReducedMotion, null), /*#__PURE__*/React.createElement(ModalContainer, Object.assign({}, args, {
    title: args.title || faker.random.words(2)
  })));
};

var ModalContainer = function ModalContainer(_ref) {
  var title = _ref.title,
      openProp = _ref.open,
      children = _ref.children,
      blocking = _ref.blocking,
      rest = _objectWithoutProperties(_ref, ["title", "open", "children", "blocking"]);

  var _useState = useState(openProp !== null && openProp !== void 0 ? openProp : true),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var handleClose = function handleClose() {
    return setOpen(false);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
    onPress: function onPress() {
      return setOpen(true);
    }
  }, "Show modal"), /*#__PURE__*/React.createElement(Modal, Object.assign({}, rest, {
    title: title,
    open: open
  }, blocking ? {
    blocking: true
  } : {
    blocking: false,
    onClose: handleClose
  }), typeof children === 'function' ? children({
    onClose: handleClose
  }) : children));
};

export var text = Template.bind({});
text.args = {
  children: /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1))
};
export var longText = Template.bind({});
longText.args = {
  titleHidden: true,
  children: /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(100))
};
export var title = Template.bind({});
title.args = {
  children: /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1))
};
export var longTitle = Template.bind({});
longTitle.args = {
  title: faker.random.words(8),
  children: /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1))
};

var BlockingContent = function BlockingContent(_ref2) {
  var onClose = _ref2.onClose;
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Text, null, "No generic close button, neither ESC nor backdrop click close the modal. The only way to close it is manually created buttons like the one below."), /*#__PURE__*/React.createElement(Button, {
    onPress: onClose
  }, "Close Blocking Modal"));
};

export var blocking = Template.bind({});
blocking.args = {
  blocking: true,
  children: function children(_ref3) {
    var onClose = _ref3.onClose;
    return /*#__PURE__*/React.createElement(BlockingContent, {
      onClose: onClose
    });
  }
};
export var blockingWithHiddenTitle = Template.bind({});
blockingWithHiddenTitle.args = {
  blocking: true,
  titleHidden: true,
  children: function children(_ref4) {
    var onClose = _ref4.onClose;
    return /*#__PURE__*/React.createElement(BlockingContent, {
      onClose: onClose
    });
  }
};
export var iframe = Template.bind({});
iframe.args = {
  source: 'http://www.example.com/',
  titleHidden: true
};
export var iframeWithTitle = Template.bind({});
iframeWithTitle.args = {
  source: 'http://www.example.com/'
};
export var maxInlineSize = Template.bind({});
maxInlineSize.args = {
  maxInlineSize: 320,
  titleHidden: true,
  children: /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(3))
};
export var maxInlineSizeFraction = Template.bind({});
maxInlineSizeFraction.args = {
  maxInlineSize: 0.7,
  titleHidden: true,
  children: /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(3))
};
export var blockSize = Template.bind({});
blockSize.args = {
  source: 'http://www.example.com/',
  blockSize: 'fill',
  titleHidden: true
};
export var focusTrap = Template.bind({});
focusTrap.args = {
  children: /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1)), /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Button, null, "You"), /*#__PURE__*/React.createElement(Button, null, "are"), /*#__PURE__*/React.createElement(Button, null, "trapped")))
};
export var focusedInput = Template.bind({});
focusedInput.args = {
  children: /*#__PURE__*/React.createElement(BlockStack, {
    spacing: "base"
  }, /*#__PURE__*/React.createElement(TextField, {
    autofocus: true,
    label: "First Name"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Last Name"
  }), /*#__PURE__*/React.createElement(Button, null, "Submit"))
};
export var closed = Template.bind({});
closed.args = {
  open: false,
  children: /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1))
};