import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import faker from 'faker';
import { mountWithContext } from '../../test-utilities';
import { Heading } from '../Heading';
import { Modal } from './Modal';

var Child = function Child() {
  return /*#__PURE__*/React.createElement("div", null);
};

describe('<Modal />', function () {
  var defaultProps = {
    title: faker.random.words(2),
    children: /*#__PURE__*/React.createElement(Child, null),
    open: true,
    onClose: function onClose() {}
  };

  var defaultPropsWithSource = _objectSpread(_objectSpread({}, defaultProps), {}, {
    children: undefined,
    source: faker.internet.url()
  });

  var defaultPropsWithBlocking = _objectSpread(_objectSpread({}, defaultProps), {}, {
    onClose: undefined
  });

  describe('open prop', function () {
    it('renders the modal when the open prop is true', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var modal;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, defaultProps));

            case 2:
              modal = _context.sent;
              expect(modal).toContainReactComponent(Child);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
    it("doesn't render the modal when the open prop is false", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      var modal;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultProps, {
                open: false
              })));

            case 2:
              modal = _context2.sent;
              expect(modal).not.toContainReactComponent(Child);

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    })));
  });
  it('renders an iframe is the src prop is passed', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    var modal;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return mountWithContext( /*#__PURE__*/React.createElement(Modal, defaultPropsWithSource));

          case 2:
            modal = _context3.sent;
            expect(modal).toContainReactComponent('iframe', {
              src: defaultPropsWithSource.source,
              title: defaultPropsWithSource.title
            });

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('renders its children if no src prop is passed', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
    var modal;
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return mountWithContext( /*#__PURE__*/React.createElement(Modal, defaultProps));

          case 2:
            modal = _context4.sent;
            expect(modal).not.toContainReactComponent('iframe');
            expect(modal).toContainReactComponent(Child);

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
  it('renders a header with Heading if the title prop is passed', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
    var modal;
    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return mountWithContext( /*#__PURE__*/React.createElement(Modal, defaultProps));

          case 2:
            modal = _context5.sent;
            expect(modal).toContainReactComponent('header');
            expect(modal).toContainReactComponent(Heading);
            expect(modal).toContainReactText(defaultProps.title);

          case 6:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  })));
  it('does not render a Heading if titleHidden', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
    var modal;
    return _regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultProps, {
              titleHidden: true
            })));

          case 2:
            modal = _context6.sent;
            expect(modal).not.toContainReactComponent(Heading);

          case 4:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  })));
  it('still renders a close button if titleHidden', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7() {
    var modal, header;
    return _regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultProps, {
              titleHidden: true
            })));

          case 2:
            modal = _context7.sent;
            header = modal.find('header');
            expect(header).toContainReactComponent('button');

          case 5:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  })));
  describe('when the escape key is pressed', function () {
    it('calls onClose callback', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8() {
      var onCloseSpy, modal, event;
      return _regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              onCloseSpy = jest.fn();
              _context8.next = 3;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultProps, {
                onClose: onCloseSpy
              })));

            case 3:
              modal = _context8.sent;
              event = new KeyboardEvent('keydown', {
                key: 'Escape'
              });
              modal.act(function () {
                return document.dispatchEvent(event);
              });
              expect(onCloseSpy).toHaveBeenCalledTimes(1);

            case 7:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    })));
  });
  describe('when the close button is clicked', function () {
    it('calls onClose callback', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee9() {
      var _header$find;

      var onCloseSpy, modal, header;
      return _regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              onCloseSpy = jest.fn();
              _context9.next = 3;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultProps, {
                onClose: onCloseSpy
              })));

            case 3:
              modal = _context9.sent;
              header = modal.find('header');
              header === null || header === void 0 ? void 0 : (_header$find = header.find('button')) === null || _header$find === void 0 ? void 0 : _header$find.trigger('onClick');
              expect(onCloseSpy).toHaveBeenCalledTimes(1);

            case 7:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }))); // Skipped until we figure out how to test async events
    // as the `iframeHeight` is reset on `transitionend`
    // eslint-disable-next-line jest/no-disabled-tests

    it.skip('resets the iFrameHeight', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee10() {
      var _modal$find, _modal$find2;

      var expectedHeight, fakeEvent, modal;
      return _regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              expectedHeight = 100;
              fakeEvent = {
                target: {
                  contentWindow: {
                    document: {
                      body: {
                        scrollHeight: expectedHeight
                      }
                    }
                  }
                }
              };
              _context10.next = 4;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, defaultPropsWithSource));

            case 4:
              modal = _context10.sent;
              (_modal$find = modal.find('iframe')) === null || _modal$find === void 0 ? void 0 : _modal$find.trigger('onLoad', fakeEvent);
              expect(modal.find('iframe').prop('style')).toMatchObject({
                height: expectedHeight
              });
              (_modal$find2 = modal.find('header button')) === null || _modal$find2 === void 0 ? void 0 : _modal$find2.trigger('onClick');
              modal.setProps({
                open: false
              });
              modal.setProps({
                open: true
              });
              expect(modal.find('iframe').prop('style')).toBeUndefined();

            case 11:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    })));
  });
  describe('when the backdrop is clicked', function () {
    it('calls onClose callback', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee11() {
      var onCloseSpy, modal, backdrop;
      return _regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              onCloseSpy = jest.fn();
              _context11.next = 3;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultProps, {
                onClose: onCloseSpy
              })));

            case 3:
              modal = _context11.sent;
              backdrop = modal.findWhere(function (node) {
                var _node$props$className;

                return node === null || node === void 0 ? void 0 : (_node$props$className = node.props.className) === null || _node$props$className === void 0 ? void 0 : _node$props$className.includes('Backdrop');
              });
              backdrop === null || backdrop === void 0 ? void 0 : backdrop.trigger('onClick');
              expect(onCloseSpy).toHaveBeenCalledTimes(1);

            case 7:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    })));
  });
  describe('blocking prop', function () {
    it("doesn't render the close button", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee12() {
      var modal;
      return _regeneratorRuntime.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              _context12.next = 2;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultPropsWithBlocking, {
                blocking: true
              })));

            case 2:
              modal = _context12.sent;
              expect(modal).not.toContainReactComponent('header button');

            case 4:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    })));
    it("doesn't close the modal when the escape key is pressed", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee13() {
      var modal, event;
      return _regeneratorRuntime.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              _context13.next = 2;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({}, defaultPropsWithBlocking, {
                blocking: true
              })));

            case 2:
              modal = _context13.sent;
              event = new KeyboardEvent('keydown', {
                key: 'Escape'
              });
              modal.act(function () {
                return document.dispatchEvent(event);
              });
              expect(modal).toContainReactComponent(Child);

            case 6:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13);
    })));
  });
  describe('blockSize prop', function () {
    it("doesn't add the onLoad prop when present", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee14() {
      var modal, iframe;
      return _regeneratorRuntime.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              _context14.next = 2;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({
                blockSize: "fill"
              }, defaultPropsWithSource)));

            case 2:
              modal = _context14.sent;
              iframe = modal.find('iframe');
              expect(iframe === null || iframe === void 0 ? void 0 : iframe.prop('onLoad')).toBeUndefined();

            case 5:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14);
    })));
    it('adds the onLoad prop when absent', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee15() {
      var modal, iframe;
      return _regeneratorRuntime.wrap(function _callee15$(_context15) {
        while (1) {
          switch (_context15.prev = _context15.next) {
            case 0:
              _context15.next = 2;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, defaultPropsWithSource));

            case 2:
              modal = _context15.sent;
              iframe = modal.find('iframe');
              expect(iframe === null || iframe === void 0 ? void 0 : iframe.prop('onLoad')).not.toBeUndefined();

            case 5:
            case "end":
              return _context15.stop();
          }
        }
      }, _callee15);
    })));
  });
  describe('maxInlineSize prop', function () {
    it('sets a max-width to the dialog', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee16() {
      var modal;
      return _regeneratorRuntime.wrap(function _callee16$(_context16) {
        while (1) {
          switch (_context16.prev = _context16.next) {
            case 0:
              _context16.next = 2;
              return mountWithContext( /*#__PURE__*/React.createElement(Modal, Object.assign({
                maxInlineSize: 0.9
              }, defaultProps)));

            case 2:
              modal = _context16.sent;
              expect(modal).toContainReactComponent('div', {
                style: {
                  maxWidth: '90%'
                }
              });

            case 4:
            case "end":
              return _context16.stop();
          }
        }
      }, _callee16);
    })));
  });
});