import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { Text } from '../Text';
import { themeWithKnobs } from '../../storybook-utilities';
import { Icon } from '../Icon';
import { InlineStack } from '../InlineStack';
import { Tooltip } from '../Tooltip';
import { Divider } from '../Divider';
import { MoneyLines } from './MoneyLines';
import { MoneyLine, MoneyLineContent, MoneyLineHeader, MoneySummary } from '.';
var meta = {
  decorators: [withKnobs, themeWithKnobs('headingLevel1')],
  component: MoneyLines,
  subComponents: {
    MoneyLine: MoneyLine,
    MoneySummary: MoneySummary
  },
  title: 'checkout-web-ui/MoneyLines'
};
export default meta;
export var basic = function basic() {
  return /*#__PURE__*/React.createElement(MoneyLines, {
    title: "Cost summary"
  }, /*#__PURE__*/React.createElement(MoneyLine, {
    label: "Subtotal",
    value: "$3,300.00"
  }), /*#__PURE__*/React.createElement(MoneyLine, {
    label: "Shipping",
    value: "Calculated at next",
    subdued: true
  }), /*#__PURE__*/React.createElement(MoneyLine, null, /*#__PURE__*/React.createElement(MoneyLineHeader, null, /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Text, null, "Taxes"))), /*#__PURE__*/React.createElement(MoneyLineContent, null, /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "$429.00"), /*#__PURE__*/React.createElement(Tooltip, {
    content: "Tooltip"
  }, /*#__PURE__*/React.createElement(Icon, {
    source: "questionFill",
    size: "large",
    appearance: "subdued",
    accessibilityLabel: "Tooltip"
  }))))), /*#__PURE__*/React.createElement(MoneyLine, null, /*#__PURE__*/React.createElement(MoneyLineHeader, null, /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Text, null, "Discount"), /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "center",
    spacing: "extraTight"
  }, /*#__PURE__*/React.createElement(Icon, {
    source: "discount",
    size: "large"
  }), /*#__PURE__*/React.createElement(Text, null, "SPRINGSALE10")))), /*#__PURE__*/React.createElement(MoneyLineContent, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "$10"))), /*#__PURE__*/React.createElement(Divider, {
    blockSpacing: "loose"
  }), /*#__PURE__*/React.createElement(MoneySummary, {
    label: "Total",
    value: "$3,719.00",
    prefix: "CAD"
  }));
};