import React from 'react';
import { faker, mountWithContext } from '../../test-utilities';
import { Heading } from '../Heading';
import { View } from '../View';
import { MoneyLine, MoneySummary } from './components';
import { MoneyLines } from './MoneyLines';
describe('<MoneyLines />', function () {
  it('renders the children', function () {
    var moneyLines = mountWithContext( /*#__PURE__*/React.createElement(MoneyLines, {
      title: "title"
    }, /*#__PURE__*/React.createElement(MoneyLine, null), /*#__PURE__*/React.createElement(MoneySummary, null)));
    expect(moneyLines).toContainReactComponent(MoneyLine);
    expect(moneyLines).toContainReactComponent(MoneySummary);
  });
  it('renders the title', function () {
    var title = faker.random.word();
    var moneyLines = mountWithContext( /*#__PURE__*/React.createElement(MoneyLines, {
      title: title
    }));
    expect(moneyLines).toContainReactComponent(Heading, {
      children: title
    });
  });
  it('renders a visually hidden title', function () {
    var title = faker.random.word();
    var moneyLines = mountWithContext( /*#__PURE__*/React.createElement(MoneyLines, {
      title: title,
      titleHidden: true
    }));
    expect(moneyLines.find(View)).toContainReactComponent(Heading, {
      children: title
    });
  });
});