import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { Text } from '../../../Text';
import { useThemeConfiguration } from '../../../Theme';
import styles from './MoneyLine.css';

function hasChildren(props) {
  return props.children !== undefined;
}

export function MoneyLine(props) {
  var _useThemeConfiguratio = useThemeConfiguration(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.moneyLines,
      background = _useThemeConfiguratio2.background,
      blockPadding = _useThemeConfiguratio2.blockPadding,
      inlinePadding = _useThemeConfiguratio2.inlinePadding,
      inlineAlignment = _useThemeConfiguratio2.inlineAlignment,
      labelTypographyStyle = _useThemeConfiguratio2.labelTypographyStyle,
      valueTypographyStyle = _useThemeConfiguratio2.valueTypographyStyle;

  var className = classNames(styles.MoneyLine, background && styles[variationName('background', background)], blockPadding && styles[variationName('blockPadding', blockPadding)], inlineAlignment && styles[variationName('inlineAlignment', inlineAlignment)], inlinePadding && styles[variationName('inlinePadding', inlinePadding)]);
  return /*#__PURE__*/React.createElement("div", {
    className: className,
    role: "row"
  }, hasChildren(props) ? props.children : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MoneyLineHeader, null, /*#__PURE__*/React.createElement(Text, {
    style: labelTypographyStyle
  }, props.label)), /*#__PURE__*/React.createElement(MoneyLineContent, null, /*#__PURE__*/React.createElement(Text, {
    subdued: props.subdued,
    emphasized: !props.subdued,
    size: props.subdued ? 'small' : undefined,
    style: valueTypographyStyle
  }, props.value))));
}
export function MoneyLineHeader(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.Header,
    role: "rowheader"
  }, children);
}
export function MoneyLineContent(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.Content,
    role: "cell"
  }, children);
}