import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { InlineStack } from '../../../InlineStack';
import { Text } from '../../../Text';
import { Divider } from '../../../Divider';
import { useThemeConfiguration } from '../../../Theme';
import styles from './MoneySummary.css';

function hasChildren(props) {
  return props.children !== undefined;
}

export function MoneySummary(props) {
  var _useThemeConfiguratio = useThemeConfiguration(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.moneyLines,
      divided = _useThemeConfiguratio2.divided,
      dividerSpacing = _useThemeConfiguratio2.dividerSpacing,
      inlineAlignment = _useThemeConfiguratio2.inlineAlignment,
      _useThemeConfiguratio3 = _useThemeConfiguratio.moneySummary,
      background = _useThemeConfiguratio3.background,
      blockPadding = _useThemeConfiguratio3.blockPadding,
      _useThemeConfiguratio4 = _useThemeConfiguratio3.currencyCode,
      currencyCode = _useThemeConfiguratio4 === void 0 ? true : _useThemeConfiguratio4,
      currencyTypographyStyle = _useThemeConfiguratio3.currencyTypographyStyle,
      inlinePadding = _useThemeConfiguratio3.inlinePadding,
      labelTypographyStyle = _useThemeConfiguratio3.labelTypographyStyle,
      valueTypographyStyle = _useThemeConfiguratio3.valueTypographyStyle;

  var className = classNames(styles.MoneySummary, background && styles[variationName('background', background)], blockPadding && styles[variationName('blockPadding', blockPadding)], inlineAlignment && styles[variationName('inlineAlignment', inlineAlignment)], inlinePadding && styles[variationName('inlinePadding', inlinePadding)]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, divided && /*#__PURE__*/React.createElement(Divider, {
    blockSpacing: dividerSpacing
  }), /*#__PURE__*/React.createElement("div", {
    className: className,
    role: "row"
  }, hasChildren(props) ? props.children : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MoneySummaryHeader, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: true,
    size: "medium",
    style: labelTypographyStyle
  }, props.label)), /*#__PURE__*/React.createElement(MoneySummaryContent, null, /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "baseline",
    spacing: "tight"
  }, currencyCode && /*#__PURE__*/React.createElement(Text, {
    role: {
      type: 'abbreviation'
    },
    size: "small",
    subdued: true,
    style: currencyTypographyStyle
  }, props.prefix), /*#__PURE__*/React.createElement(Text, {
    emphasized: true,
    size: "extraLarge",
    style: valueTypographyStyle
  }, props.value))))));
}
export function MoneySummaryHeader(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.Header,
    role: "rowheader"
  }, children);
}
export function MoneySummaryContent(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.Content,
    role: "cell"
  }, children);
}