function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { TextBlock } from '../TextBlock';
import { TextContainer } from '../TextContainer';
import { OptionList, Option, OptionDetails, OptionSecondaryContent, OptionPrimaryContent } from '.';
var meta = {
  component: OptionList,
  title: 'checkout-web-ui/OptionList',
  decorators: [withKnobs, themeWithKnobs('optionList')]
};
export default meta;

function Basic() {
  var _useState = useState(['item_1']),
      _useState2 = _slicedToArray(_useState, 2),
      selected = _useState2[0],
      setSelected = _useState2[1];

  return /*#__PURE__*/React.createElement(OptionList, {
    id: "basic",
    selectedItems: selected,
    onChange: setSelected
  }, /*#__PURE__*/React.createElement(Option, {
    id: "item_1",
    label: "Item 1",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_1"
    }, "First item")
  }), /*#__PURE__*/React.createElement(Option, {
    id: "item_2",
    label: "Item 2",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_2"
    }, "Second item")
  }), /*#__PURE__*/React.createElement(Option, {
    id: "item_3",
    label: "Item 3"
  }));
}

function WithTitle() {
  var _useState3 = useState(['item_1']),
      _useState4 = _slicedToArray(_useState3, 2),
      selected = _useState4[0],
      setSelected = _useState4[1];

  return /*#__PURE__*/React.createElement(OptionList, {
    id: "withTitle",
    title: "Choose a payment method",
    selectedItems: selected,
    onChange: setSelected
  }, /*#__PURE__*/React.createElement(Option, {
    id: "item_1",
    label: "Item 1",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_1"
    }, "First item")
  }), /*#__PURE__*/React.createElement(Option, {
    id: "item_2",
    label: "Item 2",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_2"
    }, "Second item")
  }));
}

function WithHiddenTitle() {
  var _useState5 = useState(['item_1']),
      _useState6 = _slicedToArray(_useState5, 2),
      selected = _useState6[0],
      setSelected = _useState6[1];

  return /*#__PURE__*/React.createElement(OptionList, {
    id: "withTitle",
    title: "Choose a payment method",
    titleHidden: true,
    selectedItems: selected,
    onChange: setSelected
  }, /*#__PURE__*/React.createElement(Option, {
    id: "item_1",
    label: "Item 1",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_1"
    }, "First item")
  }), /*#__PURE__*/React.createElement(Option, {
    id: "item_2",
    label: "Item 2",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_2"
    }, "Second item")
  }));
}

function WithPrimaryAndSecondaryContent() {
  var _useState7 = useState(['item_1']),
      _useState8 = _slicedToArray(_useState7, 2),
      selected = _useState8[0],
      setSelected = _useState8[1];

  return /*#__PURE__*/React.createElement(OptionList, {
    id: "withAccessory",
    selectedItems: selected,
    onChange: setSelected
  }, /*#__PURE__*/React.createElement(Option, {
    id: "item_1",
    label: "Free shipping. $0.00"
  }, /*#__PURE__*/React.createElement(OptionPrimaryContent, null, "Free shipping"), /*#__PURE__*/React.createElement(OptionSecondaryContent, null, /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "Free"))), /*#__PURE__*/React.createElement(Option, {
    id: "item_2",
    label: "Standard shipping. $19.00"
  }, /*#__PURE__*/React.createElement(OptionPrimaryContent, null, "Standard shipping"), /*#__PURE__*/React.createElement(OptionSecondaryContent, null, /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "$19.00"))), /*#__PURE__*/React.createElement(Option, {
    id: "item_3",
    label: "Paypal"
  }, /*#__PURE__*/React.createElement(OptionPrimaryContent, null, /*#__PURE__*/React.createElement("img", {
    src: "https://cdn.shopify.com/s/assets/checkout/offsite-gateway-logos/paypal@2x-768388b0667bef1aa9a7cf02fa1cc2184c2915a90d4cdd62dde223f74f2acbfc.png",
    alt: "",
    height: "24"
  })), /*#__PURE__*/React.createElement(OptionSecondaryContent, null, /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none",
    alignment: "trailing"
  }, /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "Free"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "Ready for pickup")))), /*#__PURE__*/React.createElement(Option, {
    id: "item_4",
    label: "Store name 1 accessible content"
  }, /*#__PURE__*/React.createElement(OptionPrimaryContent, null, /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "Store name 1"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "490 Rue De La Gaucheti\xE8re O, Montr\xE9al, QC")), /*#__PURE__*/React.createElement(OptionSecondaryContent, null, /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none",
    alignment: "trailing"
  }, /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "Free"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "Ready for pickup")))), /*#__PURE__*/React.createElement(Option, {
    id: "item_5",
    label: "Store Name 2 accessible content"
  }, /*#__PURE__*/React.createElement(OptionPrimaryContent, null, /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "Store name 2"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "150 Elgin St, Ottawa, ON"), /*#__PURE__*/React.createElement(TextBlock, null, "Lorem ipsum dolor sit amet consectetur adipisicing elit. Assumenda hic, repudiandae ipsam earum molestiae exercitationem sunt deleniti reprehenderit enim adipisci consequuntur explicabo tempora officia nemo consequatur ut sint voluptate sequi?"), /*#__PURE__*/React.createElement(TextBlock, null, "Lorem ipsum, dolor sit amet consectetur adipisicing elit. Ratione, tenetur autem ipsam itaque repellendus a maxime ex. Et reprehenderit aliquid odit blanditiis perferendis commodi molestias, itaque voluptates eaque reiciendis nam."))), /*#__PURE__*/React.createElement(OptionSecondaryContent, null, /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none",
    alignment: "trailing"
  }, /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "Free"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "Ready for pickup")))));
}

function WithMultipleSelection() {
  var _useState9 = useState([]),
      _useState10 = _slicedToArray(_useState9, 2),
      selected = _useState10[0],
      setSelected = _useState10[1];

  return /*#__PURE__*/React.createElement(OptionList, {
    allowMultiple: true,
    id: "withAccessory",
    selectedItems: selected,
    onChange: setSelected
  }, /*#__PURE__*/React.createElement(Option, {
    id: "item_1",
    label: "Item 1",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_1"
    }, "First item")
  }), /*#__PURE__*/React.createElement(Option, {
    id: "item_2",
    label: "Item 2",
    details: /*#__PURE__*/React.createElement(OptionDetails, {
      controlledBy: "item_2"
    }, "Second item")
  }));
}

export var basic = function basic() {
  return /*#__PURE__*/React.createElement(Basic, null);
};
export var withTitle = function withTitle() {
  return /*#__PURE__*/React.createElement(WithTitle, null);
};
export var withHiddenTitle = function withHiddenTitle() {
  return /*#__PURE__*/React.createElement(WithHiddenTitle, null);
};
export var withPrimaryAndSecondaryContent = function withPrimaryAndSecondaryContent() {
  return /*#__PURE__*/React.createElement(WithPrimaryAndSecondaryContent, null);
};
export var withMultipleSelection = function withMultipleSelection() {
  return /*#__PURE__*/React.createElement(WithMultipleSelection, null);
};