function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import React from 'react';
import { classNames } from '@shopify/css-utilities';
import { Bookend } from '../../../Bookend';
import { Text } from '../../../Text';
import { Heading } from '../../../Heading';
import { RadioControl } from '../../../RadioControl';
import { CheckboxControl } from '../../../Checkbox';
import { useThemeConfiguration } from '../../../Theme';
import { useOptionList } from '../../hooks';
import styles from '../../OptionList.css';
export function Option(_ref) {
  var id = _ref.id,
      label = _ref.label,
      accessibilityLabel = _ref.accessibilityLabel,
      details = _ref.details,
      children = _ref.children;

  var _useOptionList = useOptionList(),
      optionListId = _useOptionList.id,
      selectedItems = _useOptionList.selectedItems,
      allowMultiple = _useOptionList.allowMultiple,
      controlHidden = _useOptionList.controlHidden,
      _onChange = _useOptionList.onChange;

  var Control = allowMultiple ? CheckboxControl : RadioControl;
  var checked = selectedItems.includes(id);

  var _useThemeConfiguratio = useThemeConfiguration(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.optionList,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.spacing,
      spacing = _useThemeConfiguratio3 === void 0 ? 'none' : _useThemeConfiguratio3,
      typographyStyle = _useThemeConfiguratio2.typographyStyle;

  var className = classNames(styles.Option, spacing !== 'none' && styles.isContainer);

  function getNewSelections() {
    if (!allowMultiple) {
      return [id];
    }

    if (checked) {
      return selectedItems.filter(function (selectedItem) {
        return selectedItem !== id;
      });
    }

    return [].concat(_toConsumableArray(selectedItems), [id]);
  }

  return controlHidden ? /*#__PURE__*/React.createElement("div", {
    className: className
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.OptionLabel
  }, children ? /*#__PURE__*/React.createElement(Bookend, {
    trailing: true
  }, children) : /*#__PURE__*/React.createElement(Heading, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: typographyStyle == null,
    style: typographyStyle
  }, label))), details) : /*#__PURE__*/React.createElement("div", {
    className: className
  }, /*#__PURE__*/React.createElement("label", Object.assign({
    htmlFor: "".concat(optionListId, "-").concat(id),
    className: classNames(styles.OptionLabel, styles['OptionLabel-cursorPointer']),
    "aria-label": accessibilityLabel
  }, details && {
    'aria-controls': "".concat(optionListId, "-").concat(id, "-collapsible"),
    'aria-expanded': checked
  }), /*#__PURE__*/React.createElement(Bookend, {
    leading: true
  }, /*#__PURE__*/React.createElement(Control, {
    id: "".concat(optionListId, "-").concat(id),
    name: "".concat(optionListId),
    checked: checked,
    onChange: function onChange() {
      _onChange(getNewSelections());
    }
  }), children ? /*#__PURE__*/React.createElement(Bookend, {
    trailing: true
  }, children) : /*#__PURE__*/React.createElement(Text, {
    emphasized: typographyStyle == null,
    style: typographyStyle
  }, label))), details);
}
export function OptionPrimaryContent(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.PrimaryContent
  }, children);
}
export function OptionSecondaryContent(_ref3) {
  var children = _ref3.children;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.SecondaryContent
  }, children);
}