import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { useOptionList } from '../../hooks';
import { Collapsible } from '../../../Collapsible';
import styles from '../../OptionList.css';
import { useThemeConfiguration } from '../../../Theme';
export function OptionDetails(_ref) {
  var controlledBy = _ref.controlledBy,
      children = _ref.children;

  var _useOptionList = useOptionList(),
      selectedItems = _useOptionList.selectedItems,
      optionListId = _useOptionList.id;

  var _useThemeConfiguratio = useThemeConfiguration(),
      detailsBackground = _useThemeConfiguratio.optionList.detailsBackground;

  var isSelected = selectedItems.includes(controlledBy);

  if (!children) {
    return null;
  }

  return /*#__PURE__*/React.createElement(Collapsible, {
    open: isSelected,
    id: "".concat(optionListId, "-").concat(controlledBy, "-collapsible")
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.Details, detailsBackground && styles[variationName('Details-background', detailsBackground)])
  }, children));
}