import React, { useMemo } from 'react';
import { ProgressTrackerContext } from './context';
import styles from './ProgressTracker.css';
export function ProgressTracker(_ref) {
  var activeStep = _ref.activeStep,
      children = _ref.children;
  var stepIds = React.Children.toArray(children).map(function (child) {
    if ( /*#__PURE__*/React.isValidElement(child)) {
      return child.props.id;
    }
  });
  var contextValue = useMemo(function () {
    return {
      steps: stepIds.reduce(function (steps, step, index) {
        steps[step] = {
          active: activeStep ? activeStep === step : index === 0,
          completed: stepIds.indexOf(activeStep) > stepIds.indexOf(step)
        };
        return steps;
      }, {})
    };
  }, [activeStep, stepIds]);
  return /*#__PURE__*/React.createElement(ProgressTrackerContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("ol", {
    className: styles.ProgressTracker,
    role: "list"
  }, children));
}