import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { useThemeConfiguration } from '../Theme';
import { useId, createIdCreator } from '../../utilities/id';
import styles from './RadioControl.css';
var createId = createIdCreator('Radio');
export function RadioControl(_ref) {
  var explicitId = _ref.id,
      name = _ref.name,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? false : _ref$value,
      _ref$checked = _ref.checked,
      checked = _ref$checked === void 0 ? value : _ref$checked,
      disabled = _ref.disabled,
      onChange = _ref.onChange;
  var id = useId(explicitId, createId);

  var _useThemeConfiguratio = useThemeConfiguration(),
      controlsBackground = _useThemeConfiguratio.controls.background,
      _useThemeConfiguratio2 = _useThemeConfiguratio.radio,
      radioBackground = _useThemeConfiguratio2.background,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.borderColor,
      borderColor = _useThemeConfiguratio3 === void 0 ? 'base' : _useThemeConfiguratio3,
      _useThemeConfiguratio4 = _useThemeConfiguratio2.checkedStyle,
      checkedStyle = _useThemeConfiguratio4 === void 0 ? 'ring' : _useThemeConfiguratio4,
      _useThemeConfiguratio5 = _useThemeConfiguratio2.checkedColor,
      checkedColor = _useThemeConfiguratio5 === void 0 ? 'interactive' : _useThemeConfiguratio5,
      _useThemeConfiguratio6 = _useThemeConfiguratio2.size,
      size = _useThemeConfiguratio6 === void 0 ? 'base' : _useThemeConfiguratio6;

  var background = radioBackground || controlsBackground || 'surfaceTertiary';
  var className = classNames(styles.Input, disabled && styles['Input-isDisabled'], styles[variationName('Input-size', size)], styles[variationName('Input-background', background)], styles[variationName('Input-borderColor', borderColor)], styles[variationName('Input-checkedStyle', checkedStyle)], styles[variationName('Input-checkedColor', checkedColor)]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles.Radio
  }, /*#__PURE__*/React.createElement("input", {
    type: "radio",
    id: id,
    name: name,
    checked: checked,
    disabled: disabled,
    onChange: function (_onChange) {
      function onChange(_x) {
        return _onChange.apply(this, arguments);
      }

      onChange.toString = function () {
        return _onChange.toString();
      };

      return onChange;
    }(function (_ref2) {
      var currentTarget = _ref2.currentTarget;
      onChange === null || onChange === void 0 ? void 0 : onChange(currentTarget.checked);
    }),
    className: className
  }));
}