import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { TextContainer } from '../TextContainer';
import { Redact } from './Redact';
var meta = {
  component: Redact,
  title: 'checkout-web-ui/Redact',
  decorators: [withKnobs, themeWithKnobs()]
};
export default meta;
export var OneLine = function OneLine() {
  return /*#__PURE__*/React.createElement(Redact, null);
};
export var ThreeLines = function ThreeLines() {
  return /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Redact, {
    lines: 3
  }));
};
export var CustomInlineSizes = function CustomInlineSizes() {
  return /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Redact, {
    lines: 3,
    inlineSizes: [0.9, 0.5, 0.2]
  }));
};
export var MultipleBlockSizes = function MultipleBlockSizes() {
  return /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "loose"
  }, /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Redact, {
    lines: 3,
    blockSize: "extraSmall"
  })), /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Redact, {
    lines: 3,
    blockSize: "small"
  })), /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Redact, {
    lines: 3,
    blockSize: "medium"
  })), /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Redact, {
    lines: 3,
    blockSize: "large"
  })), /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(Redact, {
    lines: 3,
    blockSize: "extraLarge"
  })));
};