function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { createIdCreator, useId } from '../../utilities/id';
import { utilityDefaultBorderColor } from '../../utilities/legacy';
import { Heading } from '../Heading';
import { HeadingGroup } from '../HeadingGroup';
import { View } from '../View';
import styles from './ResourceList.css';
var createId = createIdCreator('ResourceList');
export function ResourceList(_ref) {
  var children = _ref.children,
      title = _ref.title,
      titleHidden = _ref.titleHidden,
      spacing = _ref.spacing,
      border = _ref.border,
      borderStyle = _ref.borderStyle,
      borderColor = _ref.borderColor;
  var id = useId(undefined, createId);
  var className = classNames(styles.ResourceList, utilityDefaultBorderColor, spacing && styles[variationName('spacing', spacing)], border && styles[variationName('border', border)], borderStyle && styles[variationName('borderStyle', borderStyle)], borderColor && styles[variationName('borderColor', borderColor)]);
  var titleMarkup = title ? /*#__PURE__*/React.createElement(Heading, {
    id: id
  }, title) : null;
  return /*#__PURE__*/React.createElement(React.Fragment, null, title && titleHidden ? /*#__PURE__*/React.createElement(View, {
    visibility: "hidden"
  }, titleMarkup) : titleMarkup, /*#__PURE__*/React.createElement(HeadingGroup, null, /*#__PURE__*/React.createElement("div", {
    role: "table",
    "aria-labelledby": id,
    className: className
  }, children)));
}
export function ResourceListHeader(_ref2) {
  var children = _ref2.children,
      hidden = _ref2.hidden;
  return /*#__PURE__*/React.createElement("div", {
    role: "row",
    className: classNames(styles.ResourceListHeader, _defineProperty({}, styles['ResourceListHeader-isHidden'], hidden))
  }, children);
}
export function ResourceListHeaderContent(_ref3) {
  var children = _ref3.children,
      primary = _ref3.primary,
      hidden = _ref3.hidden;
  return /*#__PURE__*/React.createElement("div", {
    role: "columnheader",
    className: primary ? styles['ResourceListHeaderContent-isPrimary'] : undefined
  }, hidden ? /*#__PURE__*/React.createElement(View, {
    visibility: "hidden"
  }, children) : children);
}