import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { Text } from '../Text';
import { Thumbnail } from '../Thumbnail';
import { ResourceList, ResourceListHeader, ResourceListHeaderContent } from './ResourceList';
import { ResourceItem, ResourceItemContent } from '.';
var meta = {
  component: ResourceList,
  title: 'checkout-web-ui/ResourceList',
  decorators: [withKnobs, themeWithKnobs()]
};
export default meta;

function Item() {
  return /*#__PURE__*/React.createElement(ResourceItem, null, /*#__PURE__*/React.createElement(ResourceItemContent, null, /*#__PURE__*/React.createElement(Thumbnail, {
    description: "some media source",
    badge: 1
  })), /*#__PURE__*/React.createElement(ResourceItemContent, {
    primary: true
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "T-shirt"), /*#__PURE__*/React.createElement(Text, {
    subdued: true
  }, "L/Blue")), /*#__PURE__*/React.createElement(ResourceItemContent, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "$12.00")));
}

export var multipleItems = function multipleItems() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    title: "Products",
    titleHidden: true
  }, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var oneItem = function oneItem() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    title: "Products",
    titleHidden: true
  }, /*#__PURE__*/React.createElement(Item, null));
};
export var borderFull = function borderFull() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    title: "Products",
    titleHidden: true,
    border: "full"
  }, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var borderInner = function borderInner() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    title: "Products",
    titleHidden: true,
    border: "inner"
  }, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var borderOuter = function borderOuter() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    title: "Products",
    titleHidden: true,
    border: "outer"
  }, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var withHeader = function withHeader() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    title: "Products",
    titleHidden: true
  }, /*#__PURE__*/React.createElement(ResourceListHeader, null, /*#__PURE__*/React.createElement(ResourceListHeaderContent, null, /*#__PURE__*/React.createElement(Text, null, "Image")), /*#__PURE__*/React.createElement(ResourceListHeaderContent, {
    primary: true
  }, /*#__PURE__*/React.createElement(Text, null, "Description")), /*#__PURE__*/React.createElement(ResourceListHeaderContent, null, /*#__PURE__*/React.createElement(Text, null, "Price"))), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var withHiddenHeaderContent = function withHiddenHeaderContent() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    titleHidden: true,
    title: "Products"
  }, /*#__PURE__*/React.createElement(ResourceListHeader, null, /*#__PURE__*/React.createElement(ResourceListHeaderContent, {
    primary: true
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "test")), /*#__PURE__*/React.createElement(ResourceListHeaderContent, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "test"))), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};