import React, { createContext, useContext } from 'react';
import { HeadingGroup } from '../HeadingGroup';
import { View } from '../View';
export var SectionContext = /*#__PURE__*/createContext(undefined);

function useSection() {
  return useContext(SectionContext);
}

export function Section(_ref) {
  var _context$level;

  var accessibilityLabel = _ref.accessibilityLabel,
      background = _ref.background,
      border = _ref.border,
      borderColor = _ref.borderColor,
      borderRadius = _ref.borderRadius,
      borderWidth = _ref.borderWidth,
      padding = _ref.padding,
      children = _ref.children;
  var context = useSection();
  var level = ((_context$level = context === null || context === void 0 ? void 0 : context.level) !== null && _context$level !== void 0 ? _context$level : 0) + 1;
  return /*#__PURE__*/React.createElement(SectionContext.Provider, {
    value: {
      level: level
    }
  }, /*#__PURE__*/React.createElement(View, {
    accessibilityLabel: accessibilityLabel,
    background: background,
    border: border,
    borderColor: borderColor,
    borderRadius: borderRadius,
    borderWidth: borderWidth,
    padding: padding,
    role: "region"
  }, level > 1 ? /*#__PURE__*/React.createElement(HeadingGroup, null, children) : children));
}