function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { BlockStack } from '../BlockStack';
import { InlineStack } from '../InlineStack';
import { Text } from '../Text';
import { Divider } from '../Divider';
import { Stepper } from './Stepper';
var meta = {
  component: Stepper,
  title: 'checkout-web-ui/Stepper',
  decorators: [withKnobs, themeWithKnobs('stepper', 'textFields', 'primaryButton'), function (story) {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        padding: '1em'
      }
    }, story());
  }]
};
export default meta;
var defaultProps = {
  label: 'Quantity'
};
export var defaultState = function defaultState() {
  return /*#__PURE__*/React.createElement(Stepper, defaultProps);
};
export var min = function min() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    min: 3
  }));
};
export var max = function max() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    max: 5
  }));
};
export var minAndMax = function minAndMax() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    min: 1,
    max: 5
  }));
};
export var step = function step() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    step: 0.5
  }));
};
export var minMaxAndStep = function minMaxAndStep() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    step: 2,
    min: 0,
    max: 5
  }));
};
export var error = function error() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    error: "Limit reached"
  }));
};
export var disabled = function disabled() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    disabled: true
  }));
};
export var readonly = function readonly() {
  return /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    value: 10,
    readonly: true
  }));
};

function StepperWithState(props) {
  var _useState = useState(1),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = useState(0),
      _useState4 = _slicedToArray(_useState3, 2),
      value1 = _useState4[0],
      setValue1 = _useState4[1];

  var _useState5 = useState(undefined),
      _useState6 = _slicedToArray(_useState5, 2),
      error = _useState6[0],
      setError = _useState6[1];

  var max = 10;

  var handleChange = function handleChange(val) {
    setValue(Number(val));
  };

  var handleMaxValueChange = function handleMaxValueChange(value) {
    var numVal = Number(value);

    if (max && numVal > max) {
      setError('Value exceeds max');
      return;
    }

    if (numVal < 0) {
      setError('Value less than min');
      return;
    }

    setValue1(numVal);
    setError(undefined);
  };

  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Stepper, Object.assign({}, props, {
    value: value,
    onChange: handleChange
  })), /*#__PURE__*/React.createElement(BlockStack, {
    spacing: "extraTight"
  }, /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Text, null, "onChange value: "), /*#__PURE__*/React.createElement(Text, {
    subdued: true
  }, value))), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(Text, null, "With error when max of 10 exceeded"), /*#__PURE__*/React.createElement(Stepper, Object.assign({}, defaultProps, {
    max: max,
    value: value1,
    onChange: handleMaxValueChange,
    error: error
  })), /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Text, null, "onChange value: "), /*#__PURE__*/React.createElement(Text, {
    subdued: true
  }, value1)));
}

export var withControls = function withControls(props) {
  return /*#__PURE__*/React.createElement(StepperWithState, props);
};
withControls.args = {
  accessibilityDescription: 'Number of sprockets',
  disabled: false,
  error: '',
  label: 'Quantity',
  min: undefined,
  max: undefined,
  readonly: false,
  spinner: true,
  step: undefined
};