function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { View } from '../View';
import { Tabs } from './Tabs'; // eslint-disable-next-line import/no-anonymous-default-export

export default {
  title: 'checkout-web-ui/Tabs',
  component: Tabs,
  decorators: [withKnobs, themeWithKnobs()]
};
export var basicTabs = function basicTabs(args) {
  return /*#__PURE__*/React.createElement(Story, args);
};
basicTabs.args = {
  tabs: [{
    label: 'Tab 1',
    icon: 'truck'
  }, {
    label: 'Tab 2',
    icon: 'map'
  }, 'Tab 3'],
  bordered: true
};
basicTabs.story = {
  name: 'Tabs'
};

function Story(args) {
  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      selected = _useState2[0],
      setSelected = _useState2[1];

  var handleChange = function handleChange(newSelected) {
    setSelected(newSelected);
  };

  return /*#__PURE__*/React.createElement(Tabs, Object.assign({}, args, {
    selected: selected,
    onChange: handleChange,
    ariaLabel: "Tabs example"
  }), /*#__PURE__*/React.createElement(View, {
    padding: "base"
  }, "Content for tab 1"), /*#__PURE__*/React.createElement(View, {
    padding: "base"
  }, "Content for tab 2"), /*#__PURE__*/React.createElement(View, {
    padding: "base"
  }, "Content for tab 3"));
}