import React from 'react';
import { classNames } from '@shopify/css-utilities';
import { Icon } from '../Icon';
import { Truncate } from '../Truncate';
import styles from './Tag.css';
export function Tag(_ref) {
  var children = _ref.children,
      icon = _ref.icon,
      onRemove = _ref.onRemove,
      removeControlAccessibilityLabel = _ref.removeControlAccessibilityLabel;
  var tagClassNames = classNames(styles.Tag);
  var labelClassNames = classNames(styles.Label, Boolean(onRemove) && styles.removable);
  var iconClassNames = classNames(styles.Icon);
  return /*#__PURE__*/React.createElement("div", {
    className: tagClassNames
  }, /*#__PURE__*/React.createElement("span", {
    className: labelClassNames
  }, icon && /*#__PURE__*/React.createElement("span", {
    className: iconClassNames
  }, /*#__PURE__*/React.createElement(Icon, {
    source: icon,
    size: "large"
  })), /*#__PURE__*/React.createElement(Truncate, null, children)), Boolean(onRemove) && /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: styles.Button,
    onClick: onRemove,
    "aria-label": removeControlAccessibilityLabel
  }, /*#__PURE__*/React.createElement(Icon, {
    source: "close",
    size: "base"
  })));
}