function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { InlineStack } from '../InlineStack';
import { Text } from '../Text';
import { AVAILABLE_ICONS } from '../Icon';
import { themeWithKnobs } from '../../storybook-utilities';
import { Tag } from './Tag';
var meta = {
  component: Tag,
  title: 'checkout-web-ui/Tag',
  decorators: [withKnobs, themeWithKnobs('tag')],
  argTypes: {
    icon: {
      control: {
        type: 'select',
        options: [undefined].concat(_toConsumableArray(AVAILABLE_ICONS))
      }
    }
  }
};
export default meta;

var Content = function Content() {
  return /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "Hello, world");
};

export var TagStory = function TagStory(props) {
  return /*#__PURE__*/React.createElement(InlineStack, null, Array(3).fill('Hello, world').map(function (text, i) {
    return /*#__PURE__*/React.createElement(Tag, Object.assign({}, props, {
      key: text
    }), /*#__PURE__*/React.createElement(Text, {
      emphasized: true
    }, text, " ", i + 1, "!"));
  }));
};
TagStory.args = {
  onRemove: 'javascript:;',
  removeControlAccessibilityLabel: 'Remove tag',
  icon: undefined
};
TagStory.story = {
  name: 'Tag'
};
export var RemovableTags = function RemovableTags() {
  return /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Tag, {
    removeControlAccessibilityLabel: "Remove tag",
    onRemove: function onRemove() {}
  }, /*#__PURE__*/React.createElement(Content, null)), /*#__PURE__*/React.createElement(Tag, {
    icon: "discount",
    removeControlAccessibilityLabel: "Remove tag",
    onRemove: function onRemove() {}
  }, /*#__PURE__*/React.createElement(Content, null)));
};