function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { forwardRef, useEffect, useLayoutEffect, useRef, useState, useCallback } from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { View } from '../View';
import { useLabelled, Labelled } from '../Labelled';
import { Icon } from '../Icon';
import { InlineError } from '../InlineError';
import { BlockStack } from '../BlockStack';
import { useThemeConfiguration } from '../Theme';
import typographyStyles from '../../utilities/typography-styles.css';
import { isEmptyString } from '../../utilities/strings';
import { createIdCreator, useId } from '../../utilities/id';
import { errorId } from '../../utilities/errors';
import { autocompleteToHtml } from '../../utilities/autocomplete';
import { useContainingForm } from '../../utilities/forms';
import styles from './TextField.css';
var createId = createIdCreator('TextField');

/**
 * A text field is an input field that merchants can type into.
 */
export var TextField = /*#__PURE__*/forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(TextFieldInternal, Object.assign({}, props, {
    ref: ref
  }));
});
export var TextFieldInternal = /*#__PURE__*/forwardRef(function (props, ref) {
  var _props$onKeyDown;

  var _useThemeConfiguratio = useThemeConfiguration(),
      controlsBackground = _useThemeConfiguratio.controls.background,
      _useThemeConfiguratio2 = _useThemeConfiguratio.textFields,
      labelPosition = _useThemeConfiguratio2.labelPosition,
      textFieldsBackground = _useThemeConfiguratio2.background,
      errorIndentation = _useThemeConfiguratio2.errorIndentation,
      errorTypographyStyle = _useThemeConfiguratio2.errorTypographyStyle;

  var background = textFieldsBackground || controlsBackground || 'surfaceTertiary';
  var accessibilityDescription = props.accessibilityDescription,
      error = props.error,
      explicitId = props.id,
      label = props.label,
      explicitValue = props.value,
      controlledValue = props.controlledValue,
      onInput = props.onInput,
      children = props.children,
      multiline = props.multiline,
      onChange = props.onChange;
  var wrapperRef = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      focus = _useState2[0],
      setFocus = _useState2[1];

  useLayoutEffect(function () {
    if (!(wrapperRef === null || wrapperRef === void 0 ? void 0 : wrapperRef.current)) return;

    var handleFocus = function handleFocus() {
      setFocus(true);
    };

    var handleBlur = function handleBlur() {
      setFocus(false);
    };

    var fields = wrapperRef.current.querySelectorAll('input, textarea, select, button');

    var _iterator = _createForOfIteratorHelper(fields),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var field = _step.value;
        field.addEventListener('focus', handleFocus);
        field.addEventListener('blur', handleBlur);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    return function () {
      var _iterator2 = _createForOfIteratorHelper(fields),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var field = _step2.value;
          field.removeEventListener('focus', handleFocus);
          field.removeEventListener('blur', handleBlur);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    };
  }, [children]);
  var id = useId(explicitId, createId);
  var descriptionId = accessibilityDescription ? "".concat(id, "-description") : undefined;
  var description = descriptionId ? /*#__PURE__*/React.createElement(View, {
    visibility: "hidden",
    id: descriptionId
  }, accessibilityDescription) : null;

  var _usePartiallyControll = usePartiallyControlledState(controlledValue !== null && controlledValue !== void 0 ? controlledValue : explicitValue),
      _usePartiallyControll2 = _slicedToArray(_usePartiallyControll, 2),
      localValue = _usePartiallyControll2[0],
      setLocalValue = _usePartiallyControll2[1];

  var handleInput = useCallback(function (value) {
    onInput === null || onInput === void 0 ? void 0 : onInput(value);
    setLocalValue(value);
  }, [onInput, setLocalValue]);
  var errorMarkup = error && error !== true && /*#__PURE__*/React.createElement("span", {
    className: classNames(errorIndentation && styles[variationName('Error-errorIndentation', errorIndentation)], errorTypographyStyle && typographyStyles[errorTypographyStyle])
  }, /*#__PURE__*/React.createElement(InlineError, {
    controlID: id
  }, error));

  function handleKeyDown(event) {
    if (multiline === false || !onChange) {
      return;
    }

    switch (event.key) {
      case 'Enter':
        onChange(event.currentTarget.value);
    }
  }

  return /*#__PURE__*/React.createElement(BlockStack, {
    spacing: "extraTight"
  }, /*#__PURE__*/React.createElement(Labelled, {
    label: label,
    htmlFor: id,
    empty: isEmptyString(localValue),
    position: labelPosition,
    background: background,
    subdued: props.readonly,
    prefixed: Boolean(props.prefix),
    hasIcon: Boolean(props.icon)
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.Wrapper, props.disabled && styles['Wrapper-disabled'], props.readonly && styles['Wrapper-readonly'], styles[variationName('Wrapper-background', background)]),
    ref: wrapperRef
  }, description, /*#__PURE__*/React.createElement(Field, Object.assign({
    ref: ref
  }, props, {
    id: id,
    focus: focus,
    ariaDescribedBy: descriptionId,
    localValue: localValue,
    onInput: handleInput,
    onKeyDown: (_props$onKeyDown = props.onKeyDown) !== null && _props$onKeyDown !== void 0 ? _props$onKeyDown : handleKeyDown,
    onBlur: function onBlur() {
      var _props$onBlur;

      /**
       * This is a workaround for `Stepper`
       * Not sure of exact root cause, but with Stepper if you focused on the input, typed a new number, blurred (by tabbing or clicking outside) the input would remain visually focused
       * Stepper's spinbuttons get passed in as children and have a lot of state changes that I think cause `useLayoutEffect` to fire
       * and the work in `useLayoutEffect` is constantly adding and removing the blur event listeners
       */
      if (focus) {
        setFocus(false);
      }

      props === null || props === void 0 ? void 0 : (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 ? void 0 : _props$onBlur.call(props);
    }
  })))), errorMarkup);
});
export var Field = /*#__PURE__*/forwardRef(function Field(_ref, ref) {
  var id = _ref.id,
      min = _ref.min,
      max = _ref.max,
      step = _ref.step,
      maxLength = _ref.maxLength,
      name = _ref.name,
      label = _ref.label,
      prefix = _ref.prefix,
      icon = _ref.icon,
      suffix = _ref.suffix,
      explicitValue = _ref.value,
      localValue = _ref.localValue,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'text' : _ref$type,
      role = _ref.role,
      required = _ref.required,
      error = _ref.error,
      focus = _ref.focus,
      autocomplete = _ref.autocomplete,
      autofocus = _ref.autofocus,
      multiline = _ref.multiline,
      disabled = _ref.disabled,
      readonly = _ref.readonly,
      children = _ref.children,
      ariaActiveDescendant = _ref.ariaActiveDescendant,
      ariaAutocomplete = _ref.ariaAutocomplete,
      ariaControls = _ref.ariaControls,
      ariaDescribedBy = _ref.ariaDescribedBy,
      ariaExpanded = _ref.ariaExpanded,
      _onFocus = _ref.onFocus,
      _onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onInput = _ref.onInput,
      onKeyDown = _ref.onKeyDown;
  var innerRef = useRef();
  var refsSetter = useCallback(function (instance) {
    if (typeof ref === 'function') {
      ref(instance);
    } else if (ref) {
      ref.current = instance;
    }

    innerRef.current = instance;
  }, [ref]);
  var form = useContainingForm();
  useEffect(function () {
    if (autofocus) {
      var _innerRef$current;

      (_innerRef$current = innerRef.current) === null || _innerRef$current === void 0 ? void 0 : _innerRef$current.focus();
    }
  }, [autofocus]);

  var _useThemeConfiguratio3 = useThemeConfiguration(),
      controlsBackground = _useThemeConfiguratio3.controls.background,
      _useThemeConfiguratio4 = _useThemeConfiguratio3.textFields,
      _useThemeConfiguratio5 = _useThemeConfiguratio4.labelPosition,
      labelPosition = _useThemeConfiguratio5 === void 0 ? 'inside' : _useThemeConfiguratio5,
      textFieldsBackground = _useThemeConfiguratio4.background,
      _useThemeConfiguratio6 = _useThemeConfiguratio4.border,
      border = _useThemeConfiguratio6 === void 0 ? 'full' : _useThemeConfiguratio6,
      _useThemeConfiguratio7 = _useThemeConfiguratio4.borderColor,
      borderColor = _useThemeConfiguratio7 === void 0 ? 'base' : _useThemeConfiguratio7,
      _useThemeConfiguratio8 = _useThemeConfiguratio4.focusBorder,
      focusBorder = _useThemeConfiguratio8 === void 0 ? 'full' : _useThemeConfiguratio8,
      style = _useThemeConfiguratio4.typographyStyle,
      placeholderStyle = _useThemeConfiguratio3.label.typographyStyle;

  var background = textFieldsBackground || controlsBackground || 'surfaceTertiary';
  var labelled = useLabelled();
  var fieldWrapperClassName = classNames(styles['Field-Wrapper'], Boolean(multiline) && styles.multiline);
  var iconMarkup = icon && /*#__PURE__*/React.createElement("div", {
    className: styles.Icon,
    "aria-hidden": "true",
    onClick: function onClick() {
      var _innerRef$current2;

      return (_innerRef$current2 = innerRef.current) === null || _innerRef$current2 === void 0 ? void 0 : _innerRef$current2.focus();
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.IconInner
  }, /*#__PURE__*/React.createElement(Icon, {
    appearance: "subdued",
    source: icon
  })));
  var prefixMarkup = prefix && (labelled.floating || labelPosition === 'outside') && /*#__PURE__*/React.createElement("div", {
    id: "".concat(id, "-prefix"),
    className: classNames(styles.Prefix, labelPosition === 'inside' && styles['Prefix-inside']),
    "aria-hidden": "true",
    onClick: function onClick() {
      var _innerRef$current3;

      return (_innerRef$current3 = innerRef.current) === null || _innerRef$current3 === void 0 ? void 0 : _innerRef$current3.focus();
    }
  }, prefix);
  var className = classNames(styles.Field, labelled.floating && labelPosition !== 'outside' && styles['Field-floating'], Boolean(prefix) && styles['Field-prefixed'], Boolean(children) && styles['Field-hasActions'], Boolean(multiline) && styles['Field-multiline'], style && typographyStyles[style], placeholderStyle && typographyStyles[variationName('placeholder', placeholderStyle)], type && styles[variationName('type', type)]);
  var backdropClassName = classNames(styles.Backdrop, focus && styles.focus, Boolean(error) && styles.hasError, styles[variationName('Backdrop-background', background)], styles[variationName('Backdrop-border', border)], styles[variationName('Backdrop-borderColor', borderColor)], styles[variationName('Backdrop-focusBorder', focusBorder)], disabled && styles['Backdrop-disabled'], readonly && styles['Backdrop-readOnly']);
  var finalDescribedBy = [ariaDescribedBy, error && errorId(id)].filter(Boolean).join(' ');
  var field = /*#__PURE__*/React.createElement(multiline ? 'textarea' : 'input', {
    id: id,
    min: min,
    max: max,
    step: step,
    maxLength: maxLength,
    name: name,
    placeholder: labelled.floating || labelPosition === 'outside' ? undefined : label,
    className: className,
    required: required,
    type: normalizeType(multiline ? undefined : type),
    disabled: disabled,
    readOnly: readonly,
    inputmode: type === 'number' ? 'decimal' : undefined,
    'aria-activedescendant': ariaActiveDescendant,
    'aria-autocomplete': ariaAutocomplete,
    'aria-controls': ariaControls,
    'aria-describedby': finalDescribedBy,
    'aria-expanded': ariaExpanded,
    'aria-invalid': Boolean(error),
    'aria-required': required,
    'aria-labelledby': "".concat(id, "-label").concat(prefix ? " ".concat(id, "-prefix") : '').concat(suffix ? " ".concat(id, "-suffix") : ''),
    onBlur: function onBlur(_ref2) {
      var value = _ref2.currentTarget.value;
      var currentValue = explicitValue;
      if (value !== currentValue) onChange === null || onChange === void 0 ? void 0 : onChange(value);
      _onBlur === null || _onBlur === void 0 ? void 0 : _onBlur();
      labelled.onBlur();
    },
    onChange: function onChange(_ref3) {
      var value = _ref3.currentTarget.value;
      onInput === null || onInput === void 0 ? void 0 : onInput(value);
    },
    onFocus: function onFocus() {
      _onFocus === null || _onFocus === void 0 ? void 0 : _onFocus();
      labelled.onFocus();
    },
    onKeyDown: onKeyDown,
    ref: refsSetter,
    role: role,
    rows: normalizeMultiline(multiline),
    value: localValue !== null && localValue !== void 0 ? localValue : '',
    autoComplete: autocompleteToHtml(autocomplete),
    autofocus: autofocus,
    form: (form === null || form === void 0 ? void 0 : form.nested) ? form.id : undefined
  });
  var multilineClone = Boolean(multiline) === true && /*#__PURE__*/React.createElement("div", {
    "aria-hidden": "true",
    className: classNames(styles.MultilineClone, className)
  }, localValue, ' '
  /* prevents jump with last return carriage */
  );
  var suffixMarkup = suffix && /*#__PURE__*/React.createElement("div", {
    id: "".concat(id, "-suffix"),
    className: styles.Suffix,
    "aria-hidden": "true",
    onClick: function onClick() {
      var _innerRef$current4;

      return (_innerRef$current4 = innerRef.current) === null || _innerRef$current4 === void 0 ? void 0 : _innerRef$current4.focus();
    }
  }, suffix);
  var actions = children && !disabled && /*#__PURE__*/React.createElement("div", {
    className: styles.Actions
  }, children);
  return /*#__PURE__*/React.createElement(React.Fragment, null, iconMarkup, prefixMarkup, /*#__PURE__*/React.createElement("div", {
    className: fieldWrapperClassName
  }, field, /*#__PURE__*/React.createElement("div", {
    className: backdropClassName
  }), multilineClone), suffixMarkup, actions);
});

function usePartiallyControlledState(value) {
  var _useState3 = useState(value),
      _useState4 = _slicedToArray(_useState3, 2),
      localValue = _useState4[0],
      setLocalValue = _useState4[1];

  var lastExplicitValue = useRef(value);
  var valueToReturn = localValue;

  if (lastExplicitValue.current !== value) {
    lastExplicitValue.current = value;
    setLocalValue(value);
    valueToReturn = value;
  }

  return [valueToReturn, setLocalValue];
} // Takes the `type` we allow for a TextField props, and maps it to the
// valid type for an HTML input. Currently, the only difference is
// that we use the full word `telephone` instead of `tel`.


function normalizeType(type) {
  return type === 'telephone' ? 'tel' : type;
}

function normalizeMultiline(multiline) {
  switch (_typeof(multiline)) {
    case 'undefined':
      return false;

    case 'boolean':
      return multiline ? '1' : false;

    case 'number':
      return multiline;
  }
}