import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { FormLayout } from '../FormLayout';
import { InlineStack } from '../InlineStack';
import { Tooltip } from '../Tooltip';
import { Icon } from '../Icon';
import { TextField } from './TextField';
var meta = {
  component: TextField,
  title: 'checkout-web-ui/TextField',
  decorators: [withKnobs, themeWithKnobs('textFields')]
};
export default meta;
export var defaultState = function defaultState() {
  return /*#__PURE__*/React.createElement(TextField, {
    label: "Name"
  });
};
export var inputTypeNumber = function inputTypeNumber() {
  return /*#__PURE__*/React.createElement(TextField, {
    label: "Quantity",
    type: "number"
  });
};
export var inputTypeEmail = function inputTypeEmail() {
  return /*#__PURE__*/React.createElement(TextField, {
    label: "Email",
    type: "email"
  });
};
export var inputTypeTelephone = function inputTypeTelephone() {
  return /*#__PURE__*/React.createElement(TextField, {
    label: "Phone number",
    type: "telephone"
  });
};
export var prefilledContent = function prefilledContent() {
  return /*#__PURE__*/React.createElement(TextField, {
    label: "Group",
    value: "Shopifolk"
  });
};
export var errorState = function errorState() {
  return /*#__PURE__*/React.createElement(TextField, {
    label: "Name",
    error: "Enter a name"
  });
};
export var multiline = function multiline() {
  return /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(TextField, {
    label: "Review",
    multiline: true
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Review",
    multiline: 2
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Review",
    multiline: 3
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Review",
    multiline: 4
  }));
};
export var withPrefix = function withPrefix() {
  return /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(TextField, {
    label: "Amount",
    prefix: "$"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Amount",
    prefix: "USD"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Amount (prefilled)",
    prefix: "$",
    value: "7"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Amount (prefilled)",
    prefix: "USD",
    multiline: 5,
    value: "77"
  }));
};
export var withSuffix = function withSuffix() {
  return /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(TextField, {
    label: "Amount",
    suffix: "$"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Amount",
    suffix: "CAD"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Amount",
    suffix: "CAD",
    multiline: 5
  }));
};
export var withIcon = function withIcon() {
  return /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(TextField, {
    label: "Phone number",
    icon: "mobile"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Phone number",
    icon: "mobile",
    multiline: 5
  }));
};
export var withTooltip = function withTooltip() {
  return /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(TextField, {
    label: "Address"
  }, /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "center",
    spacing: "tight"
  }, /*#__PURE__*/React.createElement(Tooltip, {
    content: "In case we need to contact you about your order"
  }, /*#__PURE__*/React.createElement(Icon, {
    source: "questionFill",
    size: "large",
    appearance: "subdued",
    accessibilityLabel: "More information"
  })))), /*#__PURE__*/React.createElement(TextField, {
    label: "Notes",
    multiline: 5
  }, /*#__PURE__*/React.createElement(InlineStack, {
    alignment: "center",
    spacing: "tight"
  }, /*#__PURE__*/React.createElement(Tooltip, {
    content: "In case we need to contact you about your order"
  }, /*#__PURE__*/React.createElement(Icon, {
    source: "questionFill",
    size: "large",
    appearance: "subdued",
    accessibilityLabel: "More information"
  })))));
};
export var accessibilityDescription = function accessibilityDescription() {
  return /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(TextField, {
    label: "Email",
    accessibilityDescription: "Contact information - Shop 1"
  }));
};
export var disabled = function disabled() {
  return /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(TextField, {
    label: "Order number",
    disabled: true
  }));
};
export var readonly = function readonly() {
  return /*#__PURE__*/React.createElement(TextField, {
    label: "Order number",
    readonly: true
  });
};