function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { memo, useMemo, useState, useEffect } from 'react';
import { useTheme } from '../../hooks';
import * as legacyStyles from '../../../../utilities/legacy';
import { ThemeDefault } from '../../../../utilities/style';
export var CustomPropertiesFallback = /*#__PURE__*/memo(function CustomPropertiesFallback() {
  var theme = useTheme();

  var _useState = useState(theme.customProperties),
      _useState2 = _slicedToArray(_useState, 2),
      customProperties = _useState2[0],
      setCustomProperties = _useState2[1];

  useEffect(function () {
    return theme.on('preview', function (customProperties) {
      setCustomProperties(function (existing) {
        return _objectSpread(_objectSpread({}, existing), customProperties);
      });
    });
  }, [theme]);
  var css = useMemo(function () {
    return toCss(customProperties);
  }, [customProperties]);
  return /*#__PURE__*/React.createElement("style", {
    dangerouslySetInnerHTML: {
      __html: css
    }
  });
});

function toCss(customProperties) {
  var _customProperties$col, _customProperties$col2, _customProperties$pri, _customProperties$pri2, _customProperties$col3, _customProperties$col4, _customProperties$sec, _customProperties$pri3, _customProperties$col5, _customProperties$col6, _customProperties$col7, _customProperties$col8, _customProperties$col9, _cssFromObject;

  return cssFromObject((_cssFromObject = {}, _defineProperty(_cssFromObject, ".".concat(legacyStyles.button, "::before, .").concat(legacyStyles.button, "::after"), {
    display: 'none'
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.buttonPrimary), {
    color: (_customProperties$col = customProperties.colorPrimaryActionText) !== null && _customProperties$col !== void 0 ? _customProperties$col : ThemeDefault.ColorPrimaryActionText,
    background: (_customProperties$col2 = customProperties.colorPrimaryAction) !== null && _customProperties$col2 !== void 0 ? _customProperties$col2 : ThemeDefault.ColorPrimaryAction,
    padding: (_customProperties$pri = customProperties.primaryButtonBlockPadding) !== null && _customProperties$pri !== void 0 ? _customProperties$pri : ThemeDefault.ButtonPadding,
    'border-radius': (_customProperties$pri2 = customProperties.primaryButtonBorderRadius) !== null && _customProperties$pri2 !== void 0 ? _customProperties$pri2 : ThemeDefault.ButtonBorderRadius
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.buttonSecondary), {
    color: (_customProperties$col3 = customProperties.colorSecondaryAction) !== null && _customProperties$col3 !== void 0 ? _customProperties$col3 : ThemeDefault.ColorSecondaryAction,
    background: 'transparent',
    'border-color': (_customProperties$col4 = customProperties.colorSecondaryAction) !== null && _customProperties$col4 !== void 0 ? _customProperties$col4 : ThemeDefault.ColorSecondaryAction,
    padding: (_customProperties$sec = customProperties.secondaryButtonBlockPadding) !== null && _customProperties$sec !== void 0 ? _customProperties$sec : ThemeDefault.ButtonPadding,
    'border-radius': (_customProperties$pri3 = customProperties.primaryButtonBorderRadius) !== null && _customProperties$pri3 !== void 0 ? _customProperties$pri3 : ThemeDefault.ButtonBorderRadius
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.buttonPrimary, ".").concat(legacyStyles.buttonCritical), {
    color: (_customProperties$col5 = customProperties.colorCriticalText) !== null && _customProperties$col5 !== void 0 ? _customProperties$col5 : ThemeDefault.ColorCriticalText,
    background: (_customProperties$col6 = customProperties.colorCriticalAccent) !== null && _customProperties$col6 !== void 0 ? _customProperties$col6 : ThemeDefault.ColorCriticalAccent
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.buttonSecondary, ".").concat(legacyStyles.buttonCritical), {
    color: (_customProperties$col7 = customProperties.colorCriticalAccent) !== null && _customProperties$col7 !== void 0 ? _customProperties$col7 : ThemeDefault.ColorCriticalAccent,
    background: 'transparent',
    'border-color': (_customProperties$col8 = customProperties.colorCriticalAccent) !== null && _customProperties$col8 !== void 0 ? _customProperties$col8 : ThemeDefault.ColorCriticalAccent
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas), {
    color: customProperties.colorCanvasText,
    'border-color': customProperties.colorCanvasBorder,
    'background-color': customProperties.colorCanvas
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorCanvasBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorCanvasTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorCanvasTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary), {
    color: customProperties.colorSurfacePrimaryText,
    'border-color': customProperties.colorSurfacePrimaryBorder,
    'background-color': customProperties.colorSurfacePrimary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorSurfacePrimaryBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorSurfacePrimaryTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorSurfacePrimaryTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary, " .").concat(legacyStyles.utilityDefaultColorAccent), {
    color: customProperties.colorSurfacePrimaryAccent
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary), {
    color: customProperties.colorSurfaceSecondaryText,
    'border-color': customProperties.colorSurfaceSecondaryBorder,
    'background-color': customProperties.colorSurfaceSecondary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorSurfaceSecondaryBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorSurfaceSecondaryTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorSurfaceSecondaryTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary, " .").concat(legacyStyles.utilityDefaultColorAccent), {
    color: customProperties.colorSurfaceSecondaryAccent
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary), {
    color: customProperties.colorSurfaceTertiaryText,
    'border-color': customProperties.colorSurfaceTertiaryBorder,
    'background-color': customProperties.colorSurfaceTertiary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorSurfaceTertiaryBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorSurfaceTertiaryTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorSurfaceTertiaryTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary, " .").concat(legacyStyles.utilityDefaultColorAccent), {
    color: customProperties.colorSurfaceTertiaryAccent
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCriticalAccent), {
    color: (_customProperties$col9 = customProperties.colorCriticalAccent) !== null && _customProperties$col9 !== void 0 ? _customProperties$col9 : ThemeDefault.ColorCriticalAccent
  }), _cssFromObject));
}

function cssFromObject(cssObject) {
  var selectors = [];

  for (var _i2 = 0, _Object$keys = Object.keys(cssObject); _i2 < _Object$keys.length; _i2++) {
    var selector = _Object$keys[_i2];
    var propertyValues = [];

    for (var _i3 = 0, _Object$keys2 = Object.keys(cssObject[selector]); _i3 < _Object$keys2.length; _i3++) {
      var property = _Object$keys2[_i3];
      var value = cssObject[selector][property];
      if (value) propertyValues.push("".concat(property, ": ").concat(value, " !important;"));
    }

    if (propertyValues.length > 0) selectors.push("".concat(selector, " {\n  ").concat(propertyValues.join('\n  '), "\n}"));
  }

  return selectors.join('\n');
}