import React, { useRef, useMemo } from 'react';
import { ToggleButtonsContext } from './context';
import styles from './ToggleButtonGroup.css';
export function ToggleButtonGroup(_ref) {
  var children = _ref.children,
      selectedItem = _ref.selectedItem,
      onChange = _ref.onChange;
  var onChangeRef = useRef(onChange);
  onChangeRef.current = onChange;
  var contextValue = useMemo(function () {
    return {
      selectedItem: selectedItem,

      get onChange() {
        return onChangeRef.current;
      }

    };
  }, [selectedItem]);
  return /*#__PURE__*/React.createElement(ToggleButtonsContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.ToggleButtonGroup
  }, children));
}