import React from 'react';
import faker from 'faker';
import { mountWithContext } from '../../test-utilities';
import { ToggleButtonsContext } from './context';
import { ToggleButtonGroup } from './index';
var defaultProps = {
  id: faker.random.uuid(),
  selectedItem: faker.random.uuid(),
  onChange: function onChange() {
    return null;
  }
};
describe('<ToggleButtonGroup />', function () {
  it('renders its children', function () {
    function Children() {
      return /*#__PURE__*/React.createElement("div", null, "children");
    }

    var toggleButtonGroup = mountWithContext( /*#__PURE__*/React.createElement(ToggleButtonGroup, defaultProps, /*#__PURE__*/React.createElement(Children, null)));
    expect(toggleButtonGroup).toContainReactComponent(Children);
  });
  it('wraps children with ToggleButtonContext', function () {
    var onChange = function onChange() {
      return null;
    };

    var id = faker.random.uuid();
    var selectedItem = faker.random.uuid();
    var toggleButtonGroup = mountWithContext( /*#__PURE__*/React.createElement(ToggleButtonGroup, Object.assign({}, defaultProps, {
      id: id,
      selectedItem: selectedItem,
      onChange: onChange
    })));
    expect(toggleButtonGroup).toProvideReactContext(ToggleButtonsContext, {
      selectedItem: selectedItem,
      onChange: onChange
    });
  });
});