function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { useResponsive } from '../../utilities/responsive';
import { useResponsiveStyle } from '../../utilities/responsiveValue';
import { pixelOrPercent } from '../../utilities/units';
import styles from './View.css';
var ELEMENT_MAP = new Map([['region', 'section'], ['complementary', 'aside']]);
export function View(_ref) {
  var _ref2;

  var accessibilityLabel = _ref.accessibilityLabel,
      accessibilityVisibility = _ref.accessibilityVisibility,
      backgroundFit = _ref.backgroundFit,
      backgroundImage = _ref.backgroundImage,
      _ref$backgroundPositi = _ref.backgroundPosition,
      backgroundPosition = _ref$backgroundPositi === void 0 ? 'center' : _ref$backgroundPositi,
      _ref$backgroundRepeat = _ref.backgroundRepeat,
      backgroundRepeat = _ref$backgroundRepeat === void 0 ? false : _ref$backgroundRepeat,
      children = _ref.children,
      _ref$display = _ref.display,
      display = _ref$display === void 0 ? 'block' : _ref$display,
      id = _ref.id,
      maxInlineSize = _ref.maxInlineSize,
      role = _ref.role,
      visibility = _ref.visibility,
      props = _objectWithoutProperties(_ref, ["accessibilityLabel", "accessibilityVisibility", "backgroundFit", "backgroundImage", "backgroundPosition", "backgroundRepeat", "children", "display", "id", "maxInlineSize", "role", "visibility"]);

  var responsiveClassNames = useResponsive(props);
  var responsiveStyle = useResponsiveStyle({
    backgroundImage: {
      value: backgroundImage,
      transform: function transform(value) {
        return "url(".concat(JSON.stringify(value), ")");
      }
    },
    maxWidth: {
      value: maxInlineSize,
      transform: function transform(value) {
        return pixelOrPercent(value);
      }
    }
  });
  var Element = (_ref2 = role && ELEMENT_MAP.get(role)) !== null && _ref2 !== void 0 ? _ref2 : 'div';
  return /*#__PURE__*/React.createElement(Element, {
    className: classNames(styles.View, backgroundImage && backgroundFit && styles[variationName('backgroundFit', backgroundFit)], backgroundImage && backgroundPosition && styles[variationName('backgroundPosition', backgroundPosition)], backgroundImage && styles[variationName('backgroundRepeat', "".concat(backgroundRepeat))], display && styles[variationName('display', display)], visibility && styles[variationName('visibility', visibility)], responsiveClassNames && responsiveClassNames.map(function (className) {
      return styles[className];
    })),
    style: responsiveStyle,
    "aria-hidden": accessibilityVisibility === 'hidden' ? true : undefined,
    "aria-label": role && accessibilityLabel,
    id: id
  }, children);
}