import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { Heading } from '../Heading';
import { BlockStack } from '../BlockStack';
import { TextBlock } from '../TextBlock';
import { TextContainer } from '../TextContainer';
import { Divider } from '../Divider';
import { View } from './View';
var meta = {
  component: View,
  title: 'checkout-web-ui/View',
  decorators: [withKnobs, themeWithKnobs()]
};
export default meta;
var defaultProps = {
  border: 'base',
  padding: 'base'
};
export var background = function background() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    background: "surfacePrimary"
  }), "primary", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    background: "surfaceSecondary"
  }), "secondary", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    background: "surfaceTertiary"
  }), "tertiary", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    background: "transparent"
  }), "transparent"))));
};
export var backgroundImage = function backgroundImage() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Background image"), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Background repeat")), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundRepeat: true,
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Background position"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "bottom - center - left - right - top")), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundPosition: "bottom",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundPosition: "center",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundPosition: "left",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundPosition: "right",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundPosition: "top",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Background fit"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "contain - cover")), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundFit: "contain",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: "https://via.placeholder.com/200/eee?text=background",
    backgroundFit: "cover",
    padding: "extraLoose"
  })), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(TextContainer, {
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Responsive background image")), /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    backgroundImage: {
      base: 'https://via.placeholder.com/200/eee?text=base',
      small: 'https://via.placeholder.com/750/eee?text=small',
      medium: 'https://via.placeholder.com/1000/eee?text=medium',
      large: 'https://via.placeholder.com/1200/eee?text=large'
    },
    padding: "extraLoose"
  })));
};
export var maxInlineSize = function maxInlineSize() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    maxInlineSize: 0.5
  }), "50%", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    maxInlineSize: 200
  }), "200px"));
};
export var border = function border() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    border: "base"
  }), "solid", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    border: "dotted"
  }), "dotted", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    border: "none"
  }), "none")));
};
export var borderWidth = function borderWidth() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderWidth: "base"
  }), "base", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderWidth: "medium"
  }), "medium"));
};
export var borderRadius = function borderRadius() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderRadius: "tight"
  }), "tight", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderRadius: "base"
  }), "base", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderRadius: "loose"
  }), "loose", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderRadius: "fullyRounded"
  }), "fully rounded", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderRadius: "none"
  }), "none")))));
};
export var borderColor = function borderColor() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderColor: "base"
  }), "base", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    borderColor: "emphasized"
  }), "emphasized"));
};
export var padding = function padding() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: "extraTight"
  }), "extraTight", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: "tight"
  }), "tight", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: "base"
  }), "base", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: "loose"
  }), "loose", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: "extraLoose"
  }), "extraLoose", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: "none"
  }), "none"))))));
};
export var logical = function logical() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: ['base', 'extraTight'],
    borderRadius: ['base', 'tight'],
    border: ['dotted', 'base'],
    borderWidth: ['base', 'medium']
  }), "2 directions", /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    padding: ['loose', 'extraLoose', 'tight', 'extraTight'],
    borderRadius: ['tight', 'none', 'base', 'tight'],
    border: ['base', 'dotted', 'none', 'base'],
    borderWidth: ['base', 'medium', 'medium', 'base']
  }), "4 directions"));
};
export var responsive = function responsive() {
  return /*#__PURE__*/React.createElement(View, {
    maxInlineSize: {
      base: 200,
      small: 300,
      medium: 400,
      large: 800
    },
    background: {
      base: 'surfacePrimary',
      small: 'surfaceSecondary',
      medium: 'surfaceTertiary',
      large: 'transparent'
    },
    border: {
      base: 'base',
      small: 'none',
      medium: 'dotted',
      large: 'base'
    },
    borderWidth: {
      medium: 'base',
      large: 'medium'
    },
    padding: {
      base: 'extraTight',
      small: 'base',
      medium: 'loose',
      large: 'extraLoose'
    }
  }, /*#__PURE__*/React.createElement(TextBlock, null, "Default:", ' ', /*#__PURE__*/React.createElement("code", null, "extraTight padding / base border / surfacePrimary background"), /*#__PURE__*/React.createElement("br", null), " Media Small:", ' ', /*#__PURE__*/React.createElement("code", null, "base padding / no border / surfaceSecondary background"), /*#__PURE__*/React.createElement("br", null), " Media Medium:", ' ', /*#__PURE__*/React.createElement("code", null, "loose padding / base dotted border / surfaceTertiary background"), /*#__PURE__*/React.createElement("br", null), " Media Large:", ' ', /*#__PURE__*/React.createElement("code", null, "extraLoose padding / medium base border / transparent background")));
};
export var display = function display() {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(View, defaultProps, "These ", /*#__PURE__*/React.createElement(View, {
    display: "inline"
  }, "are"), ' ', /*#__PURE__*/React.createElement(View, {
    display: "inline"
  }, "inline"), " views"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(View, defaultProps, "These ", /*#__PURE__*/React.createElement(View, {
    display: "block"
  }, "are"), " ", /*#__PURE__*/React.createElement(View, {
    display: "block"
  }, "block"), ' ', "views"));
};
export var visibility = function visibility() {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextBlock, null, "There is a visually hidden View inside the box and its content is accessible to screen readers."), /*#__PURE__*/React.createElement(View, defaultProps, /*#__PURE__*/React.createElement(View, {
    visibility: "hidden"
  }, "visually hidden content")));
};
export var accessibilityVisibility = function accessibilityVisibility() {
  return /*#__PURE__*/React.createElement(View, Object.assign({}, defaultProps, {
    accessibilityVisibility: "hidden"
  }), "This content is not accessible to screen readers");
};