"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.both = exports.leading = exports.trailing = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _TextField = require("../TextField");

var _Button = require("../Button");

var _storybookUtilities = require("../../storybook-utilities");

var _Thumbnail = require("../Thumbnail");

var _Bookend = require("./Bookend");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _Bookend.Bookend,
  title: 'checkout-web-ui/Bookend',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('textFields')]
};
var _default = meta;
exports.default = _default;

const trailing = () => /*#__PURE__*/_react.default.createElement(_Bookend.Bookend, {
  trailing: true
}, /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
  label: "Name"
}), /*#__PURE__*/_react.default.createElement(_Button.Button, null, "Hello, world!"));

exports.trailing = trailing;

const leading = () => /*#__PURE__*/_react.default.createElement(_Bookend.Bookend, {
  leading: true
}, /*#__PURE__*/_react.default.createElement(_Thumbnail.Thumbnail, {
  description: "Placeholder image"
}), /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
  label: "Name"
}));

exports.leading = leading;

const both = () => /*#__PURE__*/_react.default.createElement(_Bookend.Bookend, {
  leading: true,
  trailing: true
}, /*#__PURE__*/_react.default.createElement(_Thumbnail.Thumbnail, {
  description: "Placeholder image"
}), /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
  label: "Name"
}), /*#__PURE__*/_react.default.createElement(_Button.Button, null, "Hello, world!"));

exports.both = both;