"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Collapsible = Collapsible;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _transition = require("../../utilities/transition");

var _Collapsible = _interopRequireDefault(require("./Collapsible.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function Collapsible({
  id,
  open,
  minSize = 0,
  fade,
  children
}) {
  const transition = (0, _transition.useTransition)(open, 'slow');
  const div = (0, _react.useRef)(null);
  const lazyCssHeight = new Map([['enter', () => ({
    height: minSize
  })], ['entering', () => {
    var _div$current;

    return {
      height: div === null || div === void 0 ? void 0 : (_div$current = div.current) === null || _div$current === void 0 ? void 0 : _div$current.clientHeight
    };
  }], ['entered', () => ({
    height: 'auto'
  })], ['exit', () => {
    var _div$current2;

    return {
      height: div === null || div === void 0 ? void 0 : (_div$current2 = div.current) === null || _div$current2 === void 0 ? void 0 : _div$current2.clientHeight
    };
  }], ['exiting', () => ({
    height: minSize
  })], ['exited', () => ({
    height: minSize
  })]]);
  const showFade = !open && fade;
  return /*#__PURE__*/_react.default.createElement("div", {
    id: id,
    style: { ...lazyCssHeight.get(transition)()
    },
    className: (0, _cssUtilities.classNames)(_Collapsible.default.Collapsible, showFade && _Collapsible.default.fade),
    "aria-expanded": open,
    hidden: transition === 'exited' && minSize === 0
  }, /*#__PURE__*/_react.default.createElement("div", {
    ref: div
  }, children));
}