"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.accordion = exports.basicCollapsible = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _testUtilities = require("../../test-utilities");

var _storybookUtilities = require("../../storybook-utilities");

var _BlockSpacer = require("../BlockSpacer");

var _Button = require("../Button");

var _Text = require("../Text");

var _View = require("../View");

var _Collapsible = require("./Collapsible");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// eslint-disable-next-line import/no-anonymous-default-export
var _default = {
  title: 'checkout-web-ui/Collapsible',
  component: _Collapsible.Collapsible,
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)()]
};
exports.default = _default;

const basicCollapsible = args => /*#__PURE__*/_react.default.createElement(Story, args);

exports.basicCollapsible = basicCollapsible;
basicCollapsible.args = {
  id: 'basic-collapsible',
  minSize: 0,
  fade: false
};
basicCollapsible.story = {
  name: 'Collapsible'
};

const content = _testUtilities.faker.lorem.paragraphs(3);

function Story({
  id,
  minSize = 0,
  fade
}) {
  const [open, setOpen] = (0, _react.useState)(true);
  const handleToggle = (0, _react.useCallback)(() => setOpen(open => !open), []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onPress: handleToggle,
    "aria-expanded": open,
    "aria-controls": id
  }, "Toggle"), /*#__PURE__*/_react.default.createElement(_BlockSpacer.BlockSpacer, null), /*#__PURE__*/_react.default.createElement(_Collapsible.Collapsible, {
    open: open,
    id: id,
    minSize: minSize,
    fade: fade
  }, /*#__PURE__*/_react.default.createElement(_View.View, {
    border: "base",
    padding: "base"
  }, /*#__PURE__*/_react.default.createElement(_Text.Text, null, content))));
}

const accordion = () => /*#__PURE__*/_react.default.createElement(Accordion, null);

exports.accordion = accordion;

function Accordion() {
  const [openId, setOpenId] = (0, _react.useState)(-1);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onPress: () => {
      setOpenId(0);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 0,
    "aria-controls": "collapsible0"
  }, "Panel 1"), /*#__PURE__*/_react.default.createElement(_Collapsible.Collapsible, {
    open: openId === 0,
    id: "collapsible0"
  }, /*#__PURE__*/_react.default.createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react.default.createElement(_Text.Text, null, content))), /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onPress: () => {
      setOpenId(1);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 1,
    "aria-controls": "collapsible1"
  }, "Panel 2"), /*#__PURE__*/_react.default.createElement(_Collapsible.Collapsible, {
    open: openId === 1,
    id: "collapsible1"
  }, /*#__PURE__*/_react.default.createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react.default.createElement(_Text.Text, null, content))), /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onPress: () => {
      setOpenId(2);
    },
    fill: true,
    kind: "secondary",
    "aria-expanded": openId === 2,
    "aria-controls": "collapsible2"
  }, "Panel 3"), /*#__PURE__*/_react.default.createElement(_Collapsible.Collapsible, {
    open: openId === 2,
    id: "collapsible2"
  }, /*#__PURE__*/_react.default.createElement(_View.View, {
    padding: "base"
  }, /*#__PURE__*/_react.default.createElement(_Text.Text, null, content))));
}