"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Connected = Connected;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _responsive = require("../../utilities/responsive");

var _hook = require("./hook");

var _Connected = _interopRequireDefault(require("./Connected.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Connected groups inputs inline and maintains a consistent height across
 * inputs. It is commonly used for displaying a single-line TextField or Select
 * inline with a Button.
 */
function Connected({
  children,
  spacing = 'base',
  leading,
  trailing,
  stack = false
}) {
  const responsiveClassNames = (0, _responsive.useResponsive)({
    stack
  });
  return /*#__PURE__*/_react.default.createElement(_hook.ConnectedContext.Provider, {
    value: true
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _cssUtilities.classNames)(_Connected.default.Connected, leading && _Connected.default[(0, _cssUtilities.variationName)('leading', leading)], trailing && _Connected.default[(0, _cssUtilities.variationName)('trailing', trailing)], _Connected.default[(0, _cssUtilities.variationName)('spacing', spacing)], responsiveClassNames.map(className => _Connected.default[className]))
  }, children));
}