"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Divider = Divider;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Divider = _interopRequireDefault(require("./Divider.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Divider({
  alignment = 'center',
  width = 'thin',
  direction = 'horizontal',
  blockSpacing,
  children
}) {
  const hasChildren = _react.default.Children.count(children) > 0;
  return /*#__PURE__*/_react.default.createElement("div", {
    role: "separator",
    className: (0, _cssUtilities.classNames)(_Divider.default.Divider, _Divider.default[(0, _cssUtilities.variationName)('direction', direction)], alignment && hasChildren && _Divider.default[(0, _cssUtilities.variationName)('alignment', alignment)], blockSpacing && _Divider.default[(0, _cssUtilities.variationName)('spacing', blockSpacing)], width && _Divider.default[(0, _cssUtilities.variationName)('borderWidth', width)])
  }, hasChildren && /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _cssUtilities.classNames)(_Divider.default.DividerContent, _Divider.default[(0, _cssUtilities.variationName)('contentDirection', direction)], alignment && _Divider.default[(0, _cssUtilities.variationName)('contentAlignment', alignment)])
  }, children));
}