"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withControls = exports.alignment = exports.blockSpacing = exports.width = exports.vertical = exports.defaultState = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _faker = _interopRequireDefault(require("faker"));

var _storybookUtilities = require("../../storybook-utilities");

var _BlockStack = require("../BlockStack");

var _InlineStack = require("../InlineStack");

var _Text = require("../Text");

var _View = require("../View");

var _Divider = require("./Divider");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _Divider.Divider,
  title: 'checkout-web-ui/Divider',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('colors')],
  argTypes: {
    width: {
      control: {
        type: 'select',
        options: [undefined, 'thin', 'medium', 'thick', 'extraThick']
      }
    },
    blockSpacing: {
      control: {
        type: 'select',
        options: [undefined, 'none', 'extraTight', 'tight', 'base', 'loose', 'extraLoose']
      }
    },
    alignment: {
      control: {
        type: 'select',
        options: [undefined, 'start', 'center', 'end']
      }
    }
  }
};
var _default = meta;
exports.default = _default;

function Content() {
  return /*#__PURE__*/_react.default.createElement(_Text.Text, null, "Hello, world!");
}

function ChildContent() {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Text.Text, {
    subdued: true
  }, "Hello, "), /*#__PURE__*/_react.default.createElement(_Text.Text, {
    emphasized: true
  }, "world!"));
}

function LoremIpsum() {
  return /*#__PURE__*/_react.default.createElement(_View.View, {
    border: "dotted",
    display: "block"
  }, /*#__PURE__*/_react.default.createElement(_Text.Text, {
    subdued: true
  }, _faker.default.lorem.words(20)));
}

const defaultState = () => /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, null), /*#__PURE__*/_react.default.createElement(Content, null));

exports.defaultState = defaultState;

const vertical = () => /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical"
}), /*#__PURE__*/_react.default.createElement(Content, null));

exports.vertical = vertical;

const width = () => /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, null), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  width: "medium"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  width: "thick"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  width: "extraThick"
}), /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  width: "medium"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  width: "thick"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  width: "extraThick"
}), /*#__PURE__*/_react.default.createElement(Content, null)));

exports.width = width;

const blockSpacing = () => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "block",
  border: "dotted",
  padding: "loose"
}, /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  blockSpacing: "none"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  blockSpacing: "extraTight"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  blockSpacing: "tight"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  blockSpacing: "base"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  blockSpacing: "loose"
}), /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  blockSpacing: "extraLoose"
}), /*#__PURE__*/_react.default.createElement(Content, null)), /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "block",
  border: "dotted",
  padding: "loose"
}, /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, {
  spacing: "none"
}, /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  blockSpacing: "none"
}), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  blockSpacing: "extraTight"
}), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  blockSpacing: "tight"
}), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  blockSpacing: "base"
}), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  blockSpacing: "loose"
}), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  blockSpacing: "extraLoose"
}), /*#__PURE__*/_react.default.createElement(LoremIpsum, null))));

exports.blockSpacing = blockSpacing;

const alignment = () => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Text.Text, {
  subdued: true
}, "With alignment, width, children"), /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "block",
  padding: "loose",
  border: "dotted"
}, /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, {
  spacing: "extraLoose"
}, /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "horizontal",
  width: "thin",
  alignment: "center"
}, /*#__PURE__*/_react.default.createElement(ChildContent, null)), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "horizontal",
  width: "medium",
  alignment: "center"
}, /*#__PURE__*/_react.default.createElement(ChildContent, null)), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "horizontal",
  width: "thick",
  alignment: "start"
}, /*#__PURE__*/_react.default.createElement(ChildContent, null)), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "horizontal",
  width: "extraThick",
  alignment: "end"
}, /*#__PURE__*/_react.default.createElement(ChildContent, null)))), /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement(_Text.Text, {
  subdued: true
}, "With direction vertical, alignment, width, children"), /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "block",
  padding: "loose",
  border: "dotted"
}, /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, {
  alignment: "center",
  spacing: "extraLoose"
}, /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  width: "extraThick",
  alignment: "start"
}, /*#__PURE__*/_react.default.createElement(Content, null)), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  width: "thick",
  alignment: "center"
}, /*#__PURE__*/_react.default.createElement(Content, null)), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  width: "medium",
  alignment: "end"
}, /*#__PURE__*/_react.default.createElement(Content, null)), /*#__PURE__*/_react.default.createElement(LoremIpsum, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
  direction: "vertical",
  width: "thin",
  alignment: "end"
}, /*#__PURE__*/_react.default.createElement(Content, null)))));

exports.alignment = alignment;

const withControls = props => /*#__PURE__*/_react.default.createElement(_View.View, null, /*#__PURE__*/_react.default.createElement(Content, null), /*#__PURE__*/_react.default.createElement(_Divider.Divider, props), /*#__PURE__*/_react.default.createElement(Content, null));

exports.withControls = withControls;
withControls.args = {
  width: undefined,
  blockSpacing: undefined,
  children: '',
  alignment: undefined
};