"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Heading = Heading;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Theme = require("../Theme");

var _autoHeadings = require("../../utilities/auto-headings");

var _legacy = require("../../utilities/legacy");

var _typographyStyles = _interopRequireDefault(require("../../utilities/typography-styles.css"));

var _Heading = _interopRequireDefault(require("./Heading.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Heading({
  id,
  children,
  role,
  level: explicitLevel
}) {
  var _ref;

  const {
    headingLevel1,
    headingLevel2,
    headingLevel3
  } = (0, _Theme.useThemeConfiguration)();
  const semanticLevel = (0, _autoHeadings.useAutoHeadingLevel)();
  const visualLevel = (_ref = explicitLevel !== null && explicitLevel !== void 0 ? explicitLevel : semanticLevel) !== null && _ref !== void 0 ? _ref : 0;
  const Element = role === 'presentation' || semanticLevel == null ? 'p' : `h${semanticLevel}`;
  const className = (0, _cssUtilities.classNames)(_Heading.default.Heading, visualLevel && _Heading.default[(0, _cssUtilities.variationName)('h', visualLevel)], visualLevel >= 2 && _legacy.utilityDefaultTextColorEmphasized, visualLevel === 1 && headingLevel1.typographyStyle && _typographyStyles.default[headingLevel1.typographyStyle], visualLevel === 2 && headingLevel2.typographyStyle && _typographyStyles.default[headingLevel2.typographyStyle], visualLevel === 3 && headingLevel3.typographyStyle && _typographyStyles.default[headingLevel3.typographyStyle]);
  return /*#__PURE__*/_react.default.createElement(Element, {
    id: id,
    tabIndex: id ? -1 : undefined,
    className: className
  }, children);
}