"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Icon = Icon;
exports.AVAILABLE_ICONS = void 0;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _legacy = require("../../utilities/legacy");

var _icons = require("../../icons");

var _Icon = _interopRequireDefault(require("./Icon.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const BUNDLED_ICONS = {
  arrowLeft: _icons.arrowLeft,
  arrowRight: _icons.arrowRight,
  calendar: _icons.calendar,
  camera: _icons.camera,
  cancelCircle: _icons.cancelCircle,
  caretDown: _icons.caretDown,
  cart: _icons.cart,
  checkmark: _icons.checkmark,
  checkmarkCircle: _icons.checkmarkCircle,
  chevronDown: _icons.chevronDown,
  chevronUp: _icons.chevronUp,
  chevronRight: _icons.chevronRight,
  chevronLeft: _icons.chevronLeft,
  close: _icons.close,
  critical: _icons.critical,
  discount: _icons.discount,
  delivered: _icons.delivered,
  delivery: _icons.delivery,
  disabled: _icons.disabled,
  errorFill: _icons.errorFill,
  geolocation: _icons.geolocation,
  info: _icons.info,
  list: _icons.list,
  locateMe: _icons.locateMe,
  lock: _icons.lock,
  map: _icons.map,
  marker: _icons.marker,
  minus: _icons.minus,
  mobile: _icons.mobile,
  plus: _icons.plus,
  questionFill: _icons.questionFill,
  reorder: _icons.reorder,
  spinner: _icons.spinner,
  spinnerSmall: _icons.spinnerSmall,
  store: _icons.store,
  success: _icons.success,
  truck: _icons.truck,
  warning: _icons.warning,
  warningCircle: _icons.warningCircle,
  warningFill: _icons.warningFill,
  giftFill: _icons.giftFill,
  external: _icons.external
};

function Icon({
  source,
  appearance,
  size,
  accessibilityLabel
}) {
  const className = (0, _cssUtilities.classNames)(_Icon.default.Icon, appearance && _Icon.default[(0, _cssUtilities.variationName)('appearance', appearance)], appearance && appearance === 'accent' && _legacy.utilityDefaultColorAccent, appearance && appearance === 'subdued' && _legacy.utilityDefaultTextColorSubdued, size && _Icon.default[(0, _cssUtilities.variationName)('size', size)]);
  const SourceComponent = BUNDLED_ICONS[source];

  const contentMarkup = /*#__PURE__*/_react.default.createElement(SourceComponent, {
    className: _Icon.default.Svg,
    focusable: "false",
    "aria-hidden": "true",
    role: "presentation"
  });

  return /*#__PURE__*/_react.default.createElement("span", {
    className: className,
    "aria-label": accessibilityLabel
  }, contentMarkup);
}

const AVAILABLE_ICONS = Object.keys(BUNDLED_ICONS);
exports.AVAILABLE_ICONS = AVAILABLE_ICONS;