"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.closed = exports.focusedInput = exports.focusTrap = exports.blockSize = exports.maxInlineSizeFraction = exports.maxInlineSize = exports.iframeWithTitle = exports.iframe = exports.blockingWithHiddenTitle = exports.blocking = exports.longTitle = exports.title = exports.longText = exports.text = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _testUtilities = require("../../test-utilities");

var _storybookUtilities = require("../../storybook-utilities");

var _Text = require("../Text");

var _Button = require("../Button");

var _InlineStack = require("../InlineStack");

var _BlockStack = require("../BlockStack");

var _TextField = require("../TextField");

var _index = require("./index");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const meta = {
  component: _index.Modal,
  title: 'checkout-web-ui/Modal',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('headingLevel1')]
};
var _default = meta;
exports.default = _default;

const Template = args => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, process.env.A11Y_TESTS && /*#__PURE__*/_react.default.createElement(_storybookUtilities.MockPrefersReducedMotion, null), /*#__PURE__*/_react.default.createElement(ModalContainer, Object.assign({}, args, {
  title: args.title || _testUtilities.faker.random.words(2)
})));

const ModalContainer = ({
  title,
  open: openProp,
  children,
  blocking,
  ...rest
}) => {
  const [open, setOpen] = (0, _react.useState)(openProp !== null && openProp !== void 0 ? openProp : true);

  const handleClose = () => setOpen(false);

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onPress: () => setOpen(true)
  }, "Show modal"), /*#__PURE__*/_react.default.createElement(_index.Modal, Object.assign({}, rest, {
    title: title,
    open: open
  }, blocking ? {
    blocking: true
  } : {
    blocking: false,
    onClose: handleClose
  }), typeof children === 'function' ? children({
    onClose: handleClose
  }) : children));
};

const text = Template.bind({});
exports.text = text;
text.args = {
  children: /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};
const longText = Template.bind({});
exports.longText = longText;
longText.args = {
  titleHidden: true,
  children: /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(100))
};
const title = Template.bind({});
exports.title = title;
title.args = {
  children: /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};
const longTitle = Template.bind({});
exports.longTitle = longTitle;
longTitle.args = {
  title: _testUtilities.faker.random.words(8),
  children: /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};

const BlockingContent = ({
  onClose
}) => {
  return /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Text.Text, null, "No generic close button, neither ESC nor backdrop click close the modal. The only way to close it is manually created buttons like the one below."), /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onPress: onClose
  }, "Close Blocking Modal"));
};

const blocking = Template.bind({});
exports.blocking = blocking;
blocking.args = {
  blocking: true,
  children: ({
    onClose
  }) => /*#__PURE__*/_react.default.createElement(BlockingContent, {
    onClose: onClose
  })
};
const blockingWithHiddenTitle = Template.bind({});
exports.blockingWithHiddenTitle = blockingWithHiddenTitle;
blockingWithHiddenTitle.args = {
  blocking: true,
  titleHidden: true,
  children: ({
    onClose
  }) => /*#__PURE__*/_react.default.createElement(BlockingContent, {
    onClose: onClose
  })
};
const iframe = Template.bind({});
exports.iframe = iframe;
iframe.args = {
  source: 'http://www.example.com/',
  titleHidden: true
};
const iframeWithTitle = Template.bind({});
exports.iframeWithTitle = iframeWithTitle;
iframeWithTitle.args = {
  source: 'http://www.example.com/'
};
const maxInlineSize = Template.bind({});
exports.maxInlineSize = maxInlineSize;
maxInlineSize.args = {
  maxInlineSize: 320,
  titleHidden: true,
  children: /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(3))
};
const maxInlineSizeFraction = Template.bind({});
exports.maxInlineSizeFraction = maxInlineSizeFraction;
maxInlineSizeFraction.args = {
  maxInlineSize: 0.7,
  titleHidden: true,
  children: /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(3))
};
const blockSize = Template.bind({});
exports.blockSize = blockSize;
blockSize.args = {
  source: 'http://www.example.com/',
  blockSize: 'fill',
  titleHidden: true
};
const focusTrap = Template.bind({});
exports.focusTrap = focusTrap;
focusTrap.args = {
  children: /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1)), /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(_Button.Button, null, "You"), /*#__PURE__*/_react.default.createElement(_Button.Button, null, "are"), /*#__PURE__*/_react.default.createElement(_Button.Button, null, "trapped")))
};
const focusedInput = Template.bind({});
exports.focusedInput = focusedInput;
focusedInput.args = {
  children: /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, {
    spacing: "base"
  }, /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
    autofocus: true,
    label: "First Name"
  }), /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
    label: "Last Name"
  }), /*#__PURE__*/_react.default.createElement(_Button.Button, null, "Submit"))
};
const closed = Template.bind({});
exports.closed = closed;
closed.args = {
  open: false,
  children: /*#__PURE__*/_react.default.createElement(_Text.Text, null, _testUtilities.faker.lorem.paragraphs(1))
};