"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MoneyLines = MoneyLines;

var _react = _interopRequireDefault(require("react"));

var _View = require("../View");

var _Heading = require("../Heading");

var _id = require("../../utilities/id");

var _MoneyLines = _interopRequireDefault(require("./MoneyLines.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createId = (0, _id.createIdCreator)('MoneyLine-Heading');

function MoneyLines({
  children,
  title,
  titleHidden = true
}) {
  const headingId = createId();

  const titleMarkup = /*#__PURE__*/_react.default.createElement(_Heading.Heading, {
    id: headingId
  }, title);

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, titleHidden ? /*#__PURE__*/_react.default.createElement(_View.View, {
    visibility: "hidden"
  }, titleMarkup) : titleMarkup, /*#__PURE__*/_react.default.createElement("div", {
    className: _MoneyLines.default.MoneyLines,
    role: "table",
    "aria-labelledby": headingId
  }, children));
}