"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MoneySummary = MoneySummary;
exports.MoneySummaryHeader = MoneySummaryHeader;
exports.MoneySummaryContent = MoneySummaryContent;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _InlineStack = require("../../../InlineStack");

var _Text = require("../../../Text");

var _Divider = require("../../../Divider");

var _Theme = require("../../../Theme");

var _MoneySummary = _interopRequireDefault(require("./MoneySummary.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function hasChildren(props) {
  return props.children !== undefined;
}

function MoneySummary(props) {
  const {
    moneyLines: {
      divided,
      dividerSpacing,
      inlineAlignment
    },
    moneySummary: {
      background,
      blockPadding,
      currencyCode = true,
      currencyTypographyStyle,
      inlinePadding,
      labelTypographyStyle,
      valueTypographyStyle
    }
  } = (0, _Theme.useThemeConfiguration)();
  const className = (0, _cssUtilities.classNames)(_MoneySummary.default.MoneySummary, background && _MoneySummary.default[(0, _cssUtilities.variationName)('background', background)], blockPadding && _MoneySummary.default[(0, _cssUtilities.variationName)('blockPadding', blockPadding)], inlineAlignment && _MoneySummary.default[(0, _cssUtilities.variationName)('inlineAlignment', inlineAlignment)], inlinePadding && _MoneySummary.default[(0, _cssUtilities.variationName)('inlinePadding', inlinePadding)]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, divided && /*#__PURE__*/_react.default.createElement(_Divider.Divider, {
    blockSpacing: dividerSpacing
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: className,
    role: "row"
  }, hasChildren(props) ? props.children : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(MoneySummaryHeader, null, /*#__PURE__*/_react.default.createElement(_Text.Text, {
    emphasized: true,
    size: "medium",
    style: labelTypographyStyle
  }, props.label)), /*#__PURE__*/_react.default.createElement(MoneySummaryContent, null, /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, {
    alignment: "baseline",
    spacing: "tight"
  }, currencyCode && /*#__PURE__*/_react.default.createElement(_Text.Text, {
    role: {
      type: 'abbreviation'
    },
    size: "small",
    subdued: true,
    style: currencyTypographyStyle
  }, props.prefix), /*#__PURE__*/_react.default.createElement(_Text.Text, {
    emphasized: true,
    size: "extraLarge",
    style: valueTypographyStyle
  }, props.value))))));
}

function MoneySummaryHeader({
  children
}) {
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _MoneySummary.default.Header,
    role: "rowheader"
  }, children);
}

function MoneySummaryContent({
  children
}) {
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _MoneySummary.default.Content,
    role: "cell"
  }, children);
}