"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptionDetails = OptionDetails;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _hooks = require("../../hooks");

var _Collapsible = require("../../../Collapsible");

var _OptionList = _interopRequireDefault(require("../../OptionList.css"));

var _Theme = require("../../../Theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function OptionDetails({
  controlledBy,
  children
}) {
  const {
    selectedItems,
    id: optionListId
  } = (0, _hooks.useOptionList)();
  const {
    optionList: {
      detailsBackground
    }
  } = (0, _Theme.useThemeConfiguration)();
  const isSelected = selectedItems.includes(controlledBy);

  if (!children) {
    return null;
  }

  return /*#__PURE__*/_react.default.createElement(_Collapsible.Collapsible, {
    open: isSelected,
    id: `${optionListId}-${controlledBy}-collapsible`
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _cssUtilities.classNames)(_OptionList.default.Details, detailsBackground && _OptionList.default[(0, _cssUtilities.variationName)('Details-background', detailsBackground)])
  }, children));
}