"use strict";

var _react = _interopRequireDefault(require("react"));

var _faker = _interopRequireDefault(require("faker"));

var _testUtilities = require("../../../../../test-utilities");

var _OptionList = require("../../../OptionList");

var _ = require("..");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const defaultOptionListProps = {
  id: _faker.default.random.uuid(),
  selectedItems: [],
  onChange: () => null,
  children: /*#__PURE__*/_react.default.createElement("div", null)
};
describe('<OptionDetails />', () => {
  it('renders children if selected', () => {
    const id = _faker.default.random.uuid();

    function Children() {
      return /*#__PURE__*/_react.default.createElement("div", null, "Children");
    }

    const accordion = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react.default.createElement(_OptionList.OptionList, Object.assign({}, defaultOptionListProps, {
      selectedItems: [id]
    }), /*#__PURE__*/_react.default.createElement(_.OptionDetails, {
      controlledBy: id
    }, /*#__PURE__*/_react.default.createElement(Children, null))));
    expect(accordion.find(_.OptionDetails)).toContainReactComponent(Children);
  });
  it('children are hidden if not selected', () => {
    function Children() {
      return /*#__PURE__*/_react.default.createElement("div", null, "Children");
    }

    const accordion = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react.default.createElement(_OptionList.OptionList, Object.assign({}, defaultOptionListProps, {
      selectedItems: ['123']
    }), /*#__PURE__*/_react.default.createElement(_.OptionDetails, {
      controlledBy: "234"
    }, /*#__PURE__*/_react.default.createElement(Children, null))));
    expect(accordion.find('div', {
      hidden: true
    })).toContainReactComponent(Children);
  });
});