"use strict";

var _react = _interopRequireDefault(require("react"));

var _dom = require("@quilted/react-testing/dom");

var _context = require("./context");

var _ProgressTracker = require("./ProgressTracker");

var _ = require(".");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<ProgressTracker />', () => {
  it('renders <ProgressTrackerStep /> children', () => {
    const progressTracker = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_ProgressTracker.ProgressTracker, null, /*#__PURE__*/_react.default.createElement(_.ProgressTrackerStep, {
      id: "step1",
      icon: "checkmark",
      label: "Step 1",
      state: "State 1"
    }), /*#__PURE__*/_react.default.createElement(_.ProgressTrackerStep, {
      id: "step2",
      icon: "checkmark",
      label: "Step 2",
      state: "State 2"
    })));
    expect(progressTracker).toContainReactComponent(_.ProgressTrackerStep);
    expect(progressTracker).toContainReactComponentTimes(_.ProgressTrackerStep, 2);
  });
  it('wraps <ProgressTrackerStep /> children with ProgressTrackerContext', () => {
    const progressTracker = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_ProgressTracker.ProgressTracker, {
      activeStep: "step2"
    }, /*#__PURE__*/_react.default.createElement(_.ProgressTrackerStep, {
      id: "step1",
      icon: "checkmark",
      label: "Step 1",
      state: "State 1"
    }), /*#__PURE__*/_react.default.createElement(_.ProgressTrackerStep, {
      id: "step2",
      icon: "checkmark",
      label: "Step 2",
      state: "State 3"
    }), /*#__PURE__*/_react.default.createElement(_.ProgressTrackerStep, {
      id: "step3",
      icon: "checkmark",
      label: "Step 3",
      state: "State 3"
    })));
    expect(progressTracker).toProvideReactContext(_context.ProgressTrackerContext, {
      steps: {
        step1: {
          active: false,
          completed: true
        },
        step2: {
          active: true,
          completed: false
        },
        step3: {
          active: false,
          completed: false
        }
      }
    });
  });
});