"use strict";

var _react = _interopRequireDefault(require("react"));

var _dom = require("@quilted/react-testing/dom");

var _Redact = require("./Redact");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Redact />', () => {
  describe('lines', () => {
    it('defaults to one line', () => {
      const redacted = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_Redact.Redact, null));
      expect(redacted).toContainReactComponentTimes('div', 1);
    });
    it('renders the exact number of lines', () => {
      const redacted = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_Redact.Redact, {
        lines: 3
      }));
      expect(redacted).toContainReactComponentTimes('div', 3);
    });
  });
  describe('blockSize', () => {
    it('defaults to base blockSize', () => {
      const redacted = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_Redact.Redact, null));
      const classNames = redacted.find('div').prop('className');
      expect(classNames).toContain('blockSizeBase');
    });
    it('renders with specific blockSize', () => {
      const redacted = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_Redact.Redact, {
        blockSize: "large"
      }));
      const classNames = redacted.find('div').prop('className');
      expect(classNames).toContain('blockSizeLarge');
    });
  });
});