"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withHiddenHeaderContent = exports.withHeader = exports.borderOuter = exports.borderInner = exports.borderFull = exports.oneItem = exports.multipleItems = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _Text = require("../Text");

var _Thumbnail = require("../Thumbnail");

var _ResourceList = require("./ResourceList");

var _ = require(".");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _ResourceList.ResourceList,
  title: 'checkout-web-ui/ResourceList',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)()]
};
var _default = meta;
exports.default = _default;

function Item() {
  return /*#__PURE__*/_react.default.createElement(_.ResourceItem, null, /*#__PURE__*/_react.default.createElement(_.ResourceItemContent, null, /*#__PURE__*/_react.default.createElement(_Thumbnail.Thumbnail, {
    description: "some media source",
    badge: 1
  })), /*#__PURE__*/_react.default.createElement(_.ResourceItemContent, {
    primary: true
  }, /*#__PURE__*/_react.default.createElement(_Text.Text, {
    emphasized: true
  }, "T-shirt"), /*#__PURE__*/_react.default.createElement(_Text.Text, {
    subdued: true
  }, "L/Blue")), /*#__PURE__*/_react.default.createElement(_.ResourceItemContent, null, /*#__PURE__*/_react.default.createElement(_Text.Text, {
    emphasized: true
  }, "$12.00")));
}

const multipleItems = () => /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceList, {
  title: "Products",
  titleHidden: true
}, /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null));

exports.multipleItems = multipleItems;

const oneItem = () => /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceList, {
  title: "Products",
  titleHidden: true
}, /*#__PURE__*/_react.default.createElement(Item, null));

exports.oneItem = oneItem;

const borderFull = () => /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceList, {
  title: "Products",
  titleHidden: true,
  border: "full"
}, /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null));

exports.borderFull = borderFull;

const borderInner = () => /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceList, {
  title: "Products",
  titleHidden: true,
  border: "inner"
}, /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null));

exports.borderInner = borderInner;

const borderOuter = () => /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceList, {
  title: "Products",
  titleHidden: true,
  border: "outer"
}, /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null));

exports.borderOuter = borderOuter;

const withHeader = () => /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceList, {
  title: "Products",
  titleHidden: true
}, /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceListHeader, null, /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceListHeaderContent, null, /*#__PURE__*/_react.default.createElement(_Text.Text, null, "Image")), /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceListHeaderContent, {
  primary: true
}, /*#__PURE__*/_react.default.createElement(_Text.Text, null, "Description")), /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceListHeaderContent, null, /*#__PURE__*/_react.default.createElement(_Text.Text, null, "Price"))), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null));

exports.withHeader = withHeader;

const withHiddenHeaderContent = () => /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceList, {
  titleHidden: true,
  title: "Products"
}, /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceListHeader, null, /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceListHeaderContent, {
  primary: true
}, /*#__PURE__*/_react.default.createElement(_Text.Text, {
  emphasized: true
}, "test")), /*#__PURE__*/_react.default.createElement(_ResourceList.ResourceListHeaderContent, null, /*#__PURE__*/_react.default.createElement(_Text.Text, {
  emphasized: true
}, "test"))), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null), /*#__PURE__*/_react.default.createElement(Item, null));

exports.withHiddenHeaderContent = withHiddenHeaderContent;