"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reviewBlockWithHiddenTitle = exports.reviewBlock = exports.withNoWrap = exports.withAriaLabelForLink = exports.withLink = exports.defaultState = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _ReviewItem = require("./ReviewItem");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _ReviewItem.ReviewItem,
  title: 'checkout-web-ui/ReviewItem',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('reviewBlock')],
  argTypes: {
    to: {
      type: {
        name: 'string',
        required: false
      }
    },
    linkLabel: {
      type: {
        name: 'string',
        required: false
      }
    },
    linkAccessibilityLabel: {
      type: {
        name: 'string',
        required: false
      }
    }
  }
};
var _default = meta;
exports.default = _default;

const Template = args => /*#__PURE__*/_react.default.createElement("div", {
  role: "table"
}, /*#__PURE__*/_react.default.createElement(_ReviewItem.ReviewItem, args, "snowdevil@shopify.com"));

const defaultState = Template.bind({});
exports.defaultState = defaultState;
defaultState.args = {
  label: 'Contact',
  to: undefined,
  linkLabel: undefined,
  linkAccessibilityLabel: undefined
};
const withLink = Template.bind({});
exports.withLink = withLink;
withLink.args = { ...defaultState.args,
  to: '/shipping',
  linkLabel: 'Change',
  linkAccessibilityLabel: undefined
};
const withAriaLabelForLink = Template.bind({});
exports.withAriaLabelForLink = withAriaLabelForLink;
withAriaLabelForLink.args = { ...withLink.args,
  linkAccessibilityLabel: 'Change contact information'
};
const withNoWrap = Template.bind({});
exports.withNoWrap = withNoWrap;
withNoWrap.args = { ...withAriaLabelForLink.args,
  noWrap: true
};

const ReviewBlockTemplate = ({
  title,
  titleHidden,
  ...reviewItemArgs
}) => /*#__PURE__*/_react.default.createElement(_ReviewItem.ReviewBlock, {
  title,
  titleHidden
}, /*#__PURE__*/_react.default.createElement(_ReviewItem.ReviewItem, reviewItemArgs, "snowdevil@shopify.com"), /*#__PURE__*/_react.default.createElement(_ReviewItem.ReviewItem, {
  label: "Ship to",
  to: "/information",
  linkLabel: "Change",
  linkAccessibilityLabel: "Change shipping address"
}, "490 Rue de la Gaucheti\xE8re O, Montr\xE9al, QC H2Z 0B3"), /*#__PURE__*/_react.default.createElement(_ReviewItem.ReviewItem, {
  label: "Method",
  to: "/shipping",
  linkLabel: "Change",
  linkAccessibilityLabel: "Change shipping method"
}, "Standard - ", /*#__PURE__*/_react.default.createElement("strong", null, "$14.90")));

const reviewBlock = ReviewBlockTemplate.bind({});
exports.reviewBlock = reviewBlock;
reviewBlock.args = { ...withAriaLabelForLink.args,
  title: 'Review',
  titleHidden: false
};
const reviewBlockWithHiddenTitle = ReviewBlockTemplate.bind({});
exports.reviewBlockWithHiddenTitle = reviewBlockWithHiddenTitle;
reviewBlockWithHiddenTitle.args = { ...withAriaLabelForLink.args,
  title: 'Review your information',
  titleHidden: true
};