"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Section = Section;
exports.SectionContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _HeadingGroup = require("../HeadingGroup");

var _View = require("../View");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const SectionContext = /*#__PURE__*/(0, _react.createContext)(undefined);
exports.SectionContext = SectionContext;

function useSection() {
  return (0, _react.useContext)(SectionContext);
}

function Section({
  accessibilityLabel,
  background,
  border,
  borderColor,
  borderRadius,
  borderWidth,
  padding,
  children
}) {
  var _context$level;

  const context = useSection();
  const level = ((_context$level = context === null || context === void 0 ? void 0 : context.level) !== null && _context$level !== void 0 ? _context$level : 0) + 1;
  return /*#__PURE__*/_react.default.createElement(SectionContext.Provider, {
    value: {
      level
    }
  }, /*#__PURE__*/_react.default.createElement(_View.View, {
    accessibilityLabel: accessibilityLabel,
    background: background,
    border: border,
    borderColor: borderColor,
    borderRadius: borderRadius,
    borderWidth: borderWidth,
    padding: padding,
    role: "region"
  }, level > 1 ? /*#__PURE__*/_react.default.createElement(_HeadingGroup.HeadingGroup, null, children) : children));
}