"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withControls = exports.readonly = exports.disabled = exports.error = exports.minMaxAndStep = exports.step = exports.minAndMax = exports.max = exports.min = exports.defaultState = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _BlockStack = require("../BlockStack");

var _InlineStack = require("../InlineStack");

var _Text = require("../Text");

var _Divider = require("../Divider");

var _Stepper = require("./Stepper");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const meta = {
  component: _Stepper.Stepper,
  title: 'checkout-web-ui/Stepper',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('stepper', 'textFields', 'primaryButton'), story => /*#__PURE__*/_react.default.createElement("div", {
    style: {
      padding: '1em'
    }
  }, story())]
};
var _default = meta;
exports.default = _default;
const defaultProps = {
  label: 'Quantity'
};

const defaultState = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, defaultProps);

exports.defaultState = defaultState;

const min = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  min: 3
}));

exports.min = min;

const max = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  max: 5
}));

exports.max = max;

const minAndMax = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  min: 1,
  max: 5
}));

exports.minAndMax = minAndMax;

const step = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  step: 0.5
}));

exports.step = step;

const minMaxAndStep = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  step: 2,
  min: 0,
  max: 5
}));

exports.minMaxAndStep = minMaxAndStep;

const error = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  error: "Limit reached"
}));

exports.error = error;

const disabled = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  disabled: true
}));

exports.disabled = disabled;

const readonly = () => /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
  value: 10,
  readonly: true
}));

exports.readonly = readonly;

function StepperWithState(props) {
  const [value, setValue] = (0, _react.useState)(1);
  const [value1, setValue1] = (0, _react.useState)(0);
  const [error, setError] = (0, _react.useState)(undefined);
  const max = 10;

  const handleChange = val => {
    setValue(Number(val));
  };

  const handleMaxValueChange = value => {
    const numVal = Number(value);

    if (max && numVal > max) {
      setError('Value exceeds max');
      return;
    }

    if (numVal < 0) {
      setError('Value less than min');
      return;
    }

    setValue1(numVal);
    setError(undefined);
  };

  return /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, props, {
    value: value,
    onChange: handleChange
  })), /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, {
    spacing: "extraTight"
  }, /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(_Text.Text, null, "onChange value: "), /*#__PURE__*/_react.default.createElement(_Text.Text, {
    subdued: true
  }, value))), /*#__PURE__*/_react.default.createElement(_Divider.Divider, null), /*#__PURE__*/_react.default.createElement(_Text.Text, null, "With error when max of 10 exceeded"), /*#__PURE__*/_react.default.createElement(_Stepper.Stepper, Object.assign({}, defaultProps, {
    max: max,
    value: value1,
    onChange: handleMaxValueChange,
    error: error
  })), /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(_Text.Text, null, "onChange value: "), /*#__PURE__*/_react.default.createElement(_Text.Text, {
    subdued: true
  }, value1)));
}

const withControls = props => /*#__PURE__*/_react.default.createElement(StepperWithState, props);

exports.withControls = withControls;
withControls.args = {
  accessibilityDescription: 'Number of sprockets',
  disabled: false,
  error: '',
  label: 'Quantity',
  min: undefined,
  max: undefined,
  readonly: false,
  spinner: true,
  step: undefined
};