"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemovableTags = exports.TagStory = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _InlineStack = require("../InlineStack");

var _Text = require("../Text");

var _Icon = require("../Icon");

var _storybookUtilities = require("../../storybook-utilities");

var _Tag = require("./Tag");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _Tag.Tag,
  title: 'checkout-web-ui/Tag',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('tag')],
  argTypes: {
    icon: {
      control: {
        type: 'select',
        options: [undefined, ..._Icon.AVAILABLE_ICONS]
      }
    }
  }
};
var _default = meta;
exports.default = _default;

const Content = () => /*#__PURE__*/_react.default.createElement(_Text.Text, {
  emphasized: true
}, "Hello, world");

const TagStory = props => /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, Array(3).fill('Hello, world').map((text, i) => /*#__PURE__*/_react.default.createElement(_Tag.Tag, Object.assign({}, props, {
  key: text
}), /*#__PURE__*/_react.default.createElement(_Text.Text, {
  emphasized: true
}, text, " ", i + 1, "!"))));

exports.TagStory = TagStory;
TagStory.args = {
  onRemove: 'javascript:;',
  removeControlAccessibilityLabel: 'Remove tag',
  icon: undefined
};
TagStory.story = {
  name: 'Tag'
};

const RemovableTags = () => /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(_Tag.Tag, {
  removeControlAccessibilityLabel: "Remove tag",
  onRemove: () => {}
}, /*#__PURE__*/_react.default.createElement(Content, null)), /*#__PURE__*/_react.default.createElement(_Tag.Tag, {
  icon: "discount",
  removeControlAccessibilityLabel: "Remove tag",
  onRemove: () => {}
}, /*#__PURE__*/_react.default.createElement(Content, null)));

exports.RemovableTags = RemovableTags;