"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.nested = exports.allAlignments = exports.allSpacings = exports.defaultState = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _TextBlock = require("../TextBlock");

var _Heading = require("../Heading");

var _HeadingGroup = require("../HeadingGroup");

var _InlineStack = require("../InlineStack");

var _TextContainer = require("./TextContainer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _TextContainer.TextContainer,
  title: 'checkout-web-ui/TextContainer',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('headingLevel2', 'headingLevel3')]
};
var _default = meta;
exports.default = _default;

function ExampleText() {
  return /*#__PURE__*/_react.default.createElement(_TextBlock.TextBlock, null, "Lorem ipsum dolor sit amet consectetur adipisicing elit. Beatae enim veniam natus facilis. Nemo nisi assumenda alias dolore saepe quia! Sed perspiciatis veritatis nesciunt vitae nobis distinctio quod illo neque?");
}

const defaultState = () => /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, null, /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null));

exports.defaultState = defaultState;

const allSpacings = () => /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "none"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, null, "Tight"), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null)), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "tight"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, null, "Tight"), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null)), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, null, /*#__PURE__*/_react.default.createElement(_Heading.Heading, null, "Default"), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null)), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "loose"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, null, "Loose"), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null)));

exports.allSpacings = allSpacings;

const allAlignments = () => /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, null, /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null)), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  alignment: "center"
}, /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null)), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  alignment: "trailing"
}, /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null)));

exports.allAlignments = allAlignments;

const nested = () => /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  alignment: "trailing"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, null, "Default"), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(_HeadingGroup.HeadingGroup, null, /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "tight"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, null, "Nested with tight spacing"), /*#__PURE__*/_react.default.createElement(ExampleText, null), /*#__PURE__*/_react.default.createElement(ExampleText, null))));

exports.nested = nested;