"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CustomPropertiesFallback = void 0;

var _react = _interopRequireWildcard(require("react"));

var _hooks = require("../../hooks");

var legacyStyles = _interopRequireWildcard(require("../../../../utilities/legacy"));

var _style = require("../../../../utilities/style");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const CustomPropertiesFallback = /*#__PURE__*/(0, _react.memo)(function CustomPropertiesFallback() {
  const theme = (0, _hooks.useTheme)();
  const [customProperties, setCustomProperties] = (0, _react.useState)(theme.customProperties);
  (0, _react.useEffect)(() => {
    return theme.on('preview', customProperties => {
      setCustomProperties(existing => ({ ...existing,
        ...customProperties
      }));
    });
  }, [theme]);
  const css = (0, _react.useMemo)(() => toCss(customProperties), [customProperties]);
  return /*#__PURE__*/_react.default.createElement("style", {
    dangerouslySetInnerHTML: {
      __html: css
    }
  });
});
exports.CustomPropertiesFallback = CustomPropertiesFallback;

function toCss(customProperties) {
  var _customProperties$col, _customProperties$col2, _customProperties$pri, _customProperties$pri2, _customProperties$col3, _customProperties$col4, _customProperties$sec, _customProperties$pri3, _customProperties$col5, _customProperties$col6, _customProperties$col7, _customProperties$col8, _customProperties$col9;

  return cssFromObject({
    [`.${legacyStyles.button}::before, .${legacyStyles.button}::after`]: {
      display: 'none'
    },
    [`.${legacyStyles.buttonPrimary}`]: {
      color: (_customProperties$col = customProperties.colorPrimaryActionText) !== null && _customProperties$col !== void 0 ? _customProperties$col : _style.ThemeDefault.ColorPrimaryActionText,
      background: (_customProperties$col2 = customProperties.colorPrimaryAction) !== null && _customProperties$col2 !== void 0 ? _customProperties$col2 : _style.ThemeDefault.ColorPrimaryAction,
      padding: (_customProperties$pri = customProperties.primaryButtonBlockPadding) !== null && _customProperties$pri !== void 0 ? _customProperties$pri : _style.ThemeDefault.ButtonPadding,
      'border-radius': (_customProperties$pri2 = customProperties.primaryButtonBorderRadius) !== null && _customProperties$pri2 !== void 0 ? _customProperties$pri2 : _style.ThemeDefault.ButtonBorderRadius
    },
    [`.${legacyStyles.buttonSecondary}`]: {
      color: (_customProperties$col3 = customProperties.colorSecondaryAction) !== null && _customProperties$col3 !== void 0 ? _customProperties$col3 : _style.ThemeDefault.ColorSecondaryAction,
      background: 'transparent',
      'border-color': (_customProperties$col4 = customProperties.colorSecondaryAction) !== null && _customProperties$col4 !== void 0 ? _customProperties$col4 : _style.ThemeDefault.ColorSecondaryAction,
      padding: (_customProperties$sec = customProperties.secondaryButtonBlockPadding) !== null && _customProperties$sec !== void 0 ? _customProperties$sec : _style.ThemeDefault.ButtonPadding,
      'border-radius': (_customProperties$pri3 = customProperties.primaryButtonBorderRadius) !== null && _customProperties$pri3 !== void 0 ? _customProperties$pri3 : _style.ThemeDefault.ButtonBorderRadius
    },
    [`.${legacyStyles.buttonPrimary}.${legacyStyles.buttonCritical}`]: {
      color: (_customProperties$col5 = customProperties.colorCriticalText) !== null && _customProperties$col5 !== void 0 ? _customProperties$col5 : _style.ThemeDefault.ColorCriticalText,
      background: (_customProperties$col6 = customProperties.colorCriticalAccent) !== null && _customProperties$col6 !== void 0 ? _customProperties$col6 : _style.ThemeDefault.ColorCriticalAccent
    },
    [`.${legacyStyles.buttonSecondary}.${legacyStyles.buttonCritical}`]: {
      color: (_customProperties$col7 = customProperties.colorCriticalAccent) !== null && _customProperties$col7 !== void 0 ? _customProperties$col7 : _style.ThemeDefault.ColorCriticalAccent,
      background: 'transparent',
      'border-color': (_customProperties$col8 = customProperties.colorCriticalAccent) !== null && _customProperties$col8 !== void 0 ? _customProperties$col8 : _style.ThemeDefault.ColorCriticalAccent
    },
    [`.${legacyStyles.colorCanvas}`]: {
      color: customProperties.colorCanvasText,
      'border-color': customProperties.colorCanvasBorder,
      'background-color': customProperties.colorCanvas
    },
    [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultBorderColor}`]: {
      'border-color': customProperties.colorCanvasBorder
    },
    [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
      color: customProperties.colorCanvasTextSubdued
    },
    [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
      color: customProperties.colorCanvasTextEmphasized
    },
    [`.${legacyStyles.colorSurfacePrimary}`]: {
      color: customProperties.colorSurfacePrimaryText,
      'border-color': customProperties.colorSurfacePrimaryBorder,
      'background-color': customProperties.colorSurfacePrimary
    },
    [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultBorderColor}`]: {
      'border-color': customProperties.colorSurfacePrimaryBorder
    },
    [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
      color: customProperties.colorSurfacePrimaryTextSubdued
    },
    [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
      color: customProperties.colorSurfacePrimaryTextEmphasized
    },
    [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultColorAccent}`]: {
      color: customProperties.colorSurfacePrimaryAccent
    },
    [`.${legacyStyles.colorSurfaceSecondary}`]: {
      color: customProperties.colorSurfaceSecondaryText,
      'border-color': customProperties.colorSurfaceSecondaryBorder,
      'background-color': customProperties.colorSurfaceSecondary
    },
    [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultBorderColor}`]: {
      'border-color': customProperties.colorSurfaceSecondaryBorder
    },
    [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
      color: customProperties.colorSurfaceSecondaryTextSubdued
    },
    [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
      color: customProperties.colorSurfaceSecondaryTextEmphasized
    },
    [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultColorAccent}`]: {
      color: customProperties.colorSurfaceSecondaryAccent
    },
    [`.${legacyStyles.colorSurfaceTertiary}`]: {
      color: customProperties.colorSurfaceTertiaryText,
      'border-color': customProperties.colorSurfaceTertiaryBorder,
      'background-color': customProperties.colorSurfaceTertiary
    },
    [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultBorderColor}`]: {
      'border-color': customProperties.colorSurfaceTertiaryBorder
    },
    [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
      color: customProperties.colorSurfaceTertiaryTextSubdued
    },
    [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
      color: customProperties.colorSurfaceTertiaryTextEmphasized
    },
    [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultColorAccent}`]: {
      color: customProperties.colorSurfaceTertiaryAccent
    },
    [`.${legacyStyles.colorCriticalAccent}`]: {
      color: (_customProperties$col9 = customProperties.colorCriticalAccent) !== null && _customProperties$col9 !== void 0 ? _customProperties$col9 : _style.ThemeDefault.ColorCriticalAccent
    }
  });
}

function cssFromObject(cssObject) {
  const selectors = [];

  for (const selector of Object.keys(cssObject)) {
    const propertyValues = [];

    for (const property of Object.keys(cssObject[selector])) {
      const value = cssObject[selector][property];
      if (value) propertyValues.push(`${property}: ${value} !important;`);
    }

    if (propertyValues.length > 0) selectors.push(`${selector} {\n  ${propertyValues.join('\n  ')}\n}`);
  }

  return selectors.join('\n');
}