"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebFonts = WebFonts;
exports.MaybeWebFonts = MaybeWebFonts;

var _react = _interopRequireWildcard(require("react"));

var _hooks = require("../../hooks");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function WebFonts({
  children
}) {
  const {
    typographyPrimary,
    typographySecondary
  } = (0, _hooks.useThemeConfiguration)();
  (0, _react.useEffect)(() => {
    const fonts = [typographyPrimary, typographySecondary].map(typography => [{
      fonts: typography.fonts,
      source: typography.sourceBase,
      weight: typography.weightBase
    }, {
      fonts: typography.fonts,
      source: typography.sourceBold,
      weight: typography.weightBold
    }]).reduce((fonts, typography) => fonts.concat(typography), []).filter(font => font.fonts !== undefined && font.source !== undefined).map(({
      fonts,
      source,
      weight
    }) => new FontFace(fonts, source, {
      weight
    }));

    async function loadFonts() {
      await Promise.all(fonts).then(loadedFonts => {
        loadedFonts.forEach(function (font) {
          document.fonts.add(font);
        });
      });
    }

    loadFonts();
  }, [typographyPrimary, typographySecondary]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, children);
}

function MaybeWebFonts({
  children,
  condition
}) {
  return condition ? /*#__PURE__*/_react.default.createElement(WebFonts, null, children) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, children);
}