"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Thumbnail = Thumbnail;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Theme = require("../Theme");

var _Icon = require("../Icon");

var _Thumbnail = _interopRequireDefault(require("./Thumbnail.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Thumbnail({
  badge,
  description,
  source,
  sources,
  size = 'base'
}) {
  const {
    thumbnail: {
      aspectRatio,
      border = 'full',
      badgeBackground = 'subdued'
    }
  } = (0, _Theme.useThemeConfiguration)();
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _cssUtilities.classNames)(_Thumbnail.default.Thumbnail, _Thumbnail.default[(0, _cssUtilities.variationName)('size', size)], border && _Thumbnail.default[(0, _cssUtilities.variationName)('border', border)], aspectRatio && aspectRatio < 1 && _Thumbnail.default.aspectRatioLandscape, aspectRatio && aspectRatio > 1 && _Thumbnail.default.aspectRatioPortrait)
  }, badge != null && /*#__PURE__*/_react.default.createElement("span", {
    className: (0, _cssUtilities.classNames)(_Thumbnail.default.Badge, _Thumbnail.default[(0, _cssUtilities.variationName)('Badge-background', badgeBackground)]),
    "aria-hidden": true
  }, badge), source ? /*#__PURE__*/_react.default.createElement("img", {
    className: _Thumbnail.default.Image,
    srcSet: toSrcSet(sources),
    src: source,
    alt: description
  }) : /*#__PURE__*/_react.default.createElement("span", {
    className: (0, _cssUtilities.classNames)(_Thumbnail.default.Placeholder)
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: _Thumbnail.default.Icon
  }, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    source: "camera"
  }))));
}

function toSrcSet(sources) {
  if (!sources) {
    return '';
  }

  return sources.map(({
    source,
    resolution
  }) => {
    if (resolution) {
      return `${source} ${resolution}x`;
    }

    return source;
  }).join(', ');
}