"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.accessibilityVisibility = exports.visibility = exports.display = exports.responsive = exports.logical = exports.padding = exports.borderColor = exports.borderRadius = exports.borderWidth = exports.border = exports.maxInlineSize = exports.backgroundImage = exports.background = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _Heading = require("../Heading");

var _BlockStack = require("../BlockStack");

var _TextBlock = require("../TextBlock");

var _TextContainer = require("../TextContainer");

var _Divider = require("../Divider");

var _View = require("./View");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _View.View,
  title: 'checkout-web-ui/View',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)()]
};
var _default = meta;
exports.default = _default;
const defaultProps = {
  border: 'base',
  padding: 'base'
};

const background = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  background: "surfacePrimary"
}), "primary", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  background: "surfaceSecondary"
}), "secondary", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  background: "surfaceTertiary"
}), "tertiary", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  background: "transparent"
}), "transparent"))));

exports.background = background;

const backgroundImage = () => /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Heading.Heading, {
  level: 3
}, "Background image"), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_Divider.Divider, null), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "none"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, {
  level: 3
}, "Background repeat")), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundRepeat: true,
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_Divider.Divider, null), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "none"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, {
  level: 3
}, "Background position"), /*#__PURE__*/_react.default.createElement(_TextBlock.TextBlock, {
  subdued: true
}, "bottom - center - left - right - top")), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundPosition: "bottom",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundPosition: "center",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundPosition: "left",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundPosition: "right",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundPosition: "top",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_Divider.Divider, null), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "none"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, {
  level: 3
}, "Background fit"), /*#__PURE__*/_react.default.createElement(_TextBlock.TextBlock, {
  subdued: true
}, "contain - cover")), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundFit: "contain",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: "https://via.placeholder.com/200/eee?text=background",
  backgroundFit: "cover",
  padding: "extraLoose"
})), /*#__PURE__*/_react.default.createElement(_Divider.Divider, null), /*#__PURE__*/_react.default.createElement(_TextContainer.TextContainer, {
  spacing: "none"
}, /*#__PURE__*/_react.default.createElement(_Heading.Heading, {
  level: 3
}, "Responsive background image")), /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  backgroundImage: {
    base: 'https://via.placeholder.com/200/eee?text=base',
    small: 'https://via.placeholder.com/750/eee?text=small',
    medium: 'https://via.placeholder.com/1000/eee?text=medium',
    large: 'https://via.placeholder.com/1200/eee?text=large'
  },
  padding: "extraLoose"
})));

exports.backgroundImage = backgroundImage;

const maxInlineSize = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  maxInlineSize: 0.5
}), "50%", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  maxInlineSize: 200
}), "200px"));

exports.maxInlineSize = maxInlineSize;

const border = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  border: "base"
}), "solid", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  border: "dotted"
}), "dotted", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  border: "none"
}), "none")));

exports.border = border;

const borderWidth = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderWidth: "base"
}), "base", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderWidth: "medium"
}), "medium"));

exports.borderWidth = borderWidth;

const borderRadius = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderRadius: "tight"
}), "tight", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderRadius: "base"
}), "base", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderRadius: "loose"
}), "loose", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderRadius: "fullyRounded"
}), "fully rounded", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderRadius: "none"
}), "none")))));

exports.borderRadius = borderRadius;

const borderColor = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderColor: "base"
}), "base", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  borderColor: "emphasized"
}), "emphasized"));

exports.borderColor = borderColor;

const padding = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: "extraTight"
}), "extraTight", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: "tight"
}), "tight", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: "base"
}), "base", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: "loose"
}), "loose", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: "extraLoose"
}), "extraLoose", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: "none"
}), "none"))))));

exports.padding = padding;

const logical = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: ['base', 'extraTight'],
  borderRadius: ['base', 'tight'],
  border: ['dotted', 'base'],
  borderWidth: ['base', 'medium']
}), "2 directions", /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  padding: ['loose', 'extraLoose', 'tight', 'extraTight'],
  borderRadius: ['tight', 'none', 'base', 'tight'],
  border: ['base', 'dotted', 'none', 'base'],
  borderWidth: ['base', 'medium', 'medium', 'base']
}), "4 directions"));

exports.logical = logical;

const responsive = () => /*#__PURE__*/_react.default.createElement(_View.View, {
  maxInlineSize: {
    base: 200,
    small: 300,
    medium: 400,
    large: 800
  },
  background: {
    base: 'surfacePrimary',
    small: 'surfaceSecondary',
    medium: 'surfaceTertiary',
    large: 'transparent'
  },
  border: {
    base: 'base',
    small: 'none',
    medium: 'dotted',
    large: 'base'
  },
  borderWidth: {
    medium: 'base',
    large: 'medium'
  },
  padding: {
    base: 'extraTight',
    small: 'base',
    medium: 'loose',
    large: 'extraLoose'
  }
}, /*#__PURE__*/_react.default.createElement(_TextBlock.TextBlock, null, "Default:", ' ', /*#__PURE__*/_react.default.createElement("code", null, "extraTight padding / base border / surfacePrimary background"), /*#__PURE__*/_react.default.createElement("br", null), " Media Small:", ' ', /*#__PURE__*/_react.default.createElement("code", null, "base padding / no border / surfaceSecondary background"), /*#__PURE__*/_react.default.createElement("br", null), " Media Medium:", ' ', /*#__PURE__*/_react.default.createElement("code", null, "loose padding / base dotted border / surfaceTertiary background"), /*#__PURE__*/_react.default.createElement("br", null), " Media Large:", ' ', /*#__PURE__*/_react.default.createElement("code", null, "extraLoose padding / medium base border / transparent background")));

exports.responsive = responsive;

const display = () => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_View.View, defaultProps, "These ", /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "inline"
}, "are"), ' ', /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "inline"
}, "inline"), " views"), /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement(_View.View, defaultProps, "These ", /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "block"
}, "are"), " ", /*#__PURE__*/_react.default.createElement(_View.View, {
  display: "block"
}, "block"), ' ', "views"));

exports.display = display;

const visibility = () => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_TextBlock.TextBlock, null, "There is a visually hidden View inside the box and its content is accessible to screen readers."), /*#__PURE__*/_react.default.createElement(_View.View, defaultProps, /*#__PURE__*/_react.default.createElement(_View.View, {
  visibility: "hidden"
}, "visually hidden content")));

exports.visibility = visibility;

const accessibilityVisibility = () => /*#__PURE__*/_react.default.createElement(_View.View, Object.assign({}, defaultProps, {
  accessibilityVisibility: "hidden"
}), "This content is not accessible to screen readers");

exports.accessibilityVisibility = accessibilityVisibility;