"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.appContext = appContext;

var _react = _interopRequireDefault(require("react"));

require("../style.css");

var _components = require("../components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const translate = key => {
  var _translationMap$get;

  const translationMap = new Map([['january', () => 'January'], ['close', () => 'Close'], ['expand', () => 'Expand notice'], ['processing', () => 'Processing…'], ['submit', () => 'Submit'], ['dismissNotification', () => 'Dismiss notification'], ['january', () => 'January'], ['february', () => 'February'], ['march', () => 'March'], ['april', () => 'April'], ['may', () => 'May'], ['june', () => 'June'], ['july', () => 'July'], ['august', () => 'August'], ['september', () => 'September'], ['october', () => 'October'], ['november', () => 'November'], ['december', () => 'December'], ['monday', () => 'Monday'], ['tuesday', () => 'Tuesday'], ['wednesday', () => 'Wednesday'], ['thursday', () => 'Thursday'], ['friday', () => 'Friday'], ['saturday', () => 'Saturday'], ['sunday', () => 'Sunday'], ['mondayAbbreviation', () => 'Mo'], ['tuesdayAbbreviation', () => 'Tu'], ['wednesdayAbbreviation', () => 'We'], ['thursdayAbbreviation', () => 'Th'], ['fridayAbbreviation', () => 'Fr'], ['saturdayAbbreviation', () => 'Sa'], ['sundayAbbreviation', () => 'Su']]);
  const translation = (_translationMap$get = translationMap.get(key)) === null || _translationMap$get === void 0 ? void 0 : _translationMap$get();
  return translation == null ? key : translation;
};

function appContext(storyFn) {
  return /*#__PURE__*/_react.default.createElement(_components.AppContext, {
    translate: translate
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      '--x-default-color': 'var(--x-color-canvas)',
      '--x-default-color-subdued': 'var(--x-color-canvas-subdued)',
      '--x-default-color-text-subdued': 'var(--x-color-canvas-text-subdued)',
      '--x-default-color-text-emphasized': 'var(--x-color-canvas-text-emphasized)',
      '--x-default-color-border': 'var(--x-color-canvas-border)',
      background: 'var(--x-color-canvas)',
      color: 'var(--x-default-color-text)',
      fontSize: 'var(--x-typography-size-default)',
      fontFamily: 'var(--x-typography-primary-fonts)',
      fontWeight: 'var(--x-typography-primary-weight-base)',
      lineHeight: 'var(--x-global-typography-line-size-default)',
      textTransform: 'var(--x-global-typography-letter-case)'
    }
  }, storyFn(), /*#__PURE__*/_react.default.createElement(_components.PortalHost, null)));
}