"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useGeolocation = exports.useLinkComponent = exports.useTranslate = exports.useAppContext = exports.AppContext = exports.AppContextContext = void 0;
const react_1 = __importStar(require("react"));
const HeadingGroup_1 = require("../HeadingGroup");
exports.AppContextContext = react_1.createContext(null);
function AppContext({ children, linkComponent, geolocation, translate, }) {
    const context = react_1.useMemo(() => ({ translate, linkComponent, geolocation }), [
        translate,
        linkComponent,
        geolocation,
    ]);
    return (<exports.AppContextContext.Provider value={context}>
      <HeadingGroup_1.HeadingGroup>{children}</HeadingGroup_1.HeadingGroup>
    </exports.AppContextContext.Provider>);
}
exports.AppContext = AppContext;
function useAppContext() {
    const context = react_1.useContext(exports.AppContextContext);
    if (context == null) {
        throw new Error('No app context available');
    }
    return context;
}
exports.useAppContext = useAppContext;
function useTranslate() {
    return useAppContext().translate;
}
exports.useTranslate = useTranslate;
function useLinkComponent() {
    return useAppContext().linkComponent;
}
exports.useLinkComponent = useLinkComponent;
function useGeolocation() {
    return useAppContext().geolocation;
}
exports.useGeolocation = useGeolocation;
