"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.spacing = exports.alignment = exports.background = exports.border = exports.withoutTitle = exports.title = void 0;
const react_1 = __importDefault(require("react"));
const Text_1 = require("../Text");
const storybook_utilities_1 = require("../../storybook-utilities");
const BlockStack_1 = require("../BlockStack");
const CalloutBanner_1 = require("./CalloutBanner");
const meta = {
    component: CalloutBanner_1.CalloutBanner,
    title: 'checkout-web-ui/CalloutBanner',
    decorators: [storybook_utilities_1.themeWithKnobs('headingLevel3')],
};
exports.default = meta;
exports.title = () => (<CalloutBanner_1.CalloutBanner title="Special offer today only">
    <Text_1.Text>Add the Dinghy Skeleton Cruiser to your order and save 15%</Text_1.Text>
  </CalloutBanner_1.CalloutBanner>);
exports.withoutTitle = () => (<CalloutBanner_1.CalloutBanner>
    <Text_1.Text>
      Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer
      ends in <Text_1.Text emphasized>04:48</Text_1.Text>
    </Text_1.Text>
  </CalloutBanner_1.CalloutBanner>);
exports.border = () => (<CalloutBanner_1.CalloutBanner border="none">
    <Text_1.Text>
      Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer
      ends in <Text_1.Text emphasized>04:48</Text_1.Text>
    </Text_1.Text>
  </CalloutBanner_1.CalloutBanner>);
exports.background = () => (<CalloutBanner_1.CalloutBanner background="transparent">
    <Text_1.Text>
      Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer
      ends in <Text_1.Text emphasized>04:48</Text_1.Text>
    </Text_1.Text>
  </CalloutBanner_1.CalloutBanner>);
exports.alignment = () => (<BlockStack_1.BlockStack>
    <CalloutBanner_1.CalloutBanner alignment="leading">
      <Text_1.Text>
        Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer
        ends in <Text_1.Text emphasized>04:48</Text_1.Text>
      </Text_1.Text>
    </CalloutBanner_1.CalloutBanner>
    <CalloutBanner_1.CalloutBanner>
      <Text_1.Text>
        Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer
        ends in <Text_1.Text emphasized>04:48</Text_1.Text>
      </Text_1.Text>
    </CalloutBanner_1.CalloutBanner>
    <CalloutBanner_1.CalloutBanner alignment="trailing">
      <Text_1.Text>
        Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer
        ends in <Text_1.Text emphasized>04:48</Text_1.Text>
      </Text_1.Text>
    </CalloutBanner_1.CalloutBanner>
  </BlockStack_1.BlockStack>);
exports.spacing = () => (<CalloutBanner_1.CalloutBanner title="Special offer today only" spacing="none">
    <Text_1.Text>
      Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer
      ends in <Text_1.Text emphasized>04:48</Text_1.Text>
    </Text_1.Text>
  </CalloutBanner_1.CalloutBanner>);
