"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.disabledAndChecked = exports.withError = exports.withAccessibilityLabel = exports.defaultState = void 0;
const react_1 = __importDefault(require("react"));
const addon_knobs_1 = require("@storybook/addon-knobs");
const storybook_utilities_1 = require("../../storybook-utilities");
const Text_1 = require("../Text");
const BlockStack_1 = require("../BlockStack");
const Checkbox_1 = require("./Checkbox");
const meta = {
    component: Checkbox_1.Checkbox,
    title: 'checkout-web-ui/Checkbox',
    decorators: [addon_knobs_1.withKnobs, storybook_utilities_1.themeWithKnobs('checkbox')],
};
exports.default = meta;
const defaultProps = {
    children: 'Save this information for next time',
};
exports.defaultState = () => (<BlockStack_1.BlockStack>
    <Checkbox_1.Checkbox id="checkbox1" name="checkboxchoices">
      Save this information for next time
    </Checkbox_1.Checkbox>
    <div style={{ width: '200px' }}>
      <Checkbox_1.Checkbox id="checkbox2" name="checkboxchoices">
        Multi-line label Lorem ipsum dolor sit amet consectetur adipisicing
        elit. Facere, dolores aut harum accusantium nihil excepturi nemo iusto
        dolore impedit officia est consectetur sint neque voluptatibus? Amet ut
        excepturi culpa? Mollitia?
      </Checkbox_1.Checkbox>
    </div>
    <Checkbox_1.Checkbox id="checkbox3" name="checkboxchoices">
      <Text_1.Text emphasized>Lorem ipsum dolor sit amet</Text_1.Text>
      <Text_1.Text>consectetur adipisicing elit</Text_1.Text>
    </Checkbox_1.Checkbox>
  </BlockStack_1.BlockStack>);
exports.withAccessibilityLabel = () => (<Checkbox_1.Checkbox {...defaultProps} accessibilityLabel="This is a description for screen readers"/>);
exports.withError = () => (<Checkbox_1.Checkbox {...defaultProps} error="This is an error"/>);
exports.disabledAndChecked = () => (<BlockStack_1.BlockStack>
    <Checkbox_1.Checkbox {...defaultProps} disabled/>
    <Checkbox_1.Checkbox {...defaultProps} checked disabled/>
  </BlockStack_1.BlockStack>);
