import { PropsWithChildren } from 'react';
export interface Props {
    /** Assign a unique ID to the collapsible. For accessibility, pass this ID as the value of the triggering component’s aria-controls prop. */
    id: string;
    /** Toggle whether the collapsible is expanded or not. */
    open: boolean;
    /** A minimum size when the collapsible is closed. Used for peeking content. */
    minSize?: number;
    /** A fade when collapsing and when content is peeking in the closed state. */
    fade?: boolean;
}
export declare function Collapsible({ id, open, minSize, fade, children, }: PropsWithChildren<Props>): JSX.Element;
