"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Collapsible = void 0;
const react_1 = __importStar(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const transition_1 = require("../../utilities/transition");
const Collapsible_css_1 = __importDefault(require("./Collapsible.css"));
function Collapsible({ id, open, minSize = 0, fade, children, }) {
    const transition = transition_1.useTransition(open, 'slow');
    const div = react_1.useRef(null);
    const lazyCssHeight = new Map([
        ['enter', () => ({ height: minSize })],
        ['entering', () => { var _a; return ({ height: (_a = div === null || div === void 0 ? void 0 : div.current) === null || _a === void 0 ? void 0 : _a.clientHeight }); }],
        ['entered', () => ({ height: 'auto' })],
        ['exit', () => { var _a; return ({ height: (_a = div === null || div === void 0 ? void 0 : div.current) === null || _a === void 0 ? void 0 : _a.clientHeight }); }],
        ['exiting', () => ({ height: minSize })],
        ['exited', () => ({ height: minSize })],
    ]);
    const showFade = !open && fade;
    return (<div id={id} style={Object.assign({}, lazyCssHeight.get(transition)())} className={css_utilities_1.classNames(Collapsible_css_1.default.Collapsible, showFade && Collapsible_css_1.default.fade)} aria-expanded={open} hidden={transition === 'exited' && minSize === 0}>
      <div ref={div}>{children}</div>
    </div>);
}
exports.Collapsible = Collapsible;
