import { PropsWithChildren } from 'react';
import { Responsive } from '@shopify/checkout-ui-extensions';
declare type Spacing = 'extraTight' | 'tight' | 'base' | 'loose' | 'extraLoose';
declare type Size = 'auto';
export interface Props {
    /** Sets the sizing of the leading child */
    leading?: Size;
    /** Sets the sizing of the trailing child */
    trailing?: Size;
    /**
     * Adjust spacing between children
     * @defaultValue `base`
     */
    spacing?: Spacing;
    /** Whether or not to stack the children vertically */
    stack?: boolean | Responsive<boolean>;
}
/**
 * Connected groups inputs inline and maintains a consistent height across
 * inputs. It is commonly used for displaying a single-line TextField or Select
 * inline with a Button.
 */
export declare function Connected({ children, spacing, leading, trailing, stack, }: PropsWithChildren<Props>): JSX.Element;
export {};
