"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.responsive = exports.stack = exports.both = exports.leading = exports.trailing = void 0;
const react_1 = __importDefault(require("react"));
const addon_knobs_1 = require("@storybook/addon-knobs");
const BlockStack_1 = require("../BlockStack");
const TextField_1 = require("../TextField");
const Button_1 = require("../Button");
const storybook_utilities_1 = require("../../storybook-utilities");
const Connected_1 = require("./Connected");
const meta = {
    component: Connected_1.Connected,
    title: 'checkout-web-ui/Connected',
    decorators: [addon_knobs_1.withKnobs, storybook_utilities_1.themeWithKnobs('textFields')],
};
exports.default = meta;
exports.trailing = () => (<BlockStack_1.BlockStack>
    <Connected_1.Connected trailing="auto">
      <TextField_1.TextField label="Name"/>
      <Button_1.Button>Hello, world!</Button_1.Button>
    </Connected_1.Connected>
    <Connected_1.Connected trailing="auto">
      <TextField_1.TextField label="First name"/>
      <TextField_1.TextField label="Last name"/>
      <Button_1.Button>Hello, world!</Button_1.Button>
    </Connected_1.Connected>
  </BlockStack_1.BlockStack>);
exports.leading = () => (<Connected_1.Connected leading="auto">
    <Button_1.Button>Hello, world!</Button_1.Button>
    <TextField_1.TextField label="Name"/>
  </Connected_1.Connected>);
exports.both = () => (<Connected_1.Connected leading="auto" trailing="auto">
    <TextField_1.TextField label="Name"/>
    <Button_1.Button>Hello, world!</Button_1.Button>
  </Connected_1.Connected>);
exports.stack = () => (<Connected_1.Connected stack>
    <TextField_1.TextField label="Name"/>
    <Button_1.Button>Hello, world!</Button_1.Button>
  </Connected_1.Connected>);
exports.responsive = () => (<Connected_1.Connected stack={{ base: true, medium: false }} spacing="extraLoose">
    <TextField_1.TextField label="Name"/>
    <Button_1.Button>Hello, world!</Button_1.Button>
  </Connected_1.Connected>);
