"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Divider = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const Divider_css_1 = __importDefault(require("./Divider.css"));
function Divider({ alignment = 'center', width = 'thin', direction = 'horizontal', blockSpacing, children, }) {
    const hasChildren = react_1.default.Children.count(children) > 0;
    return (<div role="separator" className={css_utilities_1.classNames(Divider_css_1.default.Divider, Divider_css_1.default[css_utilities_1.variationName('direction', direction)], alignment &&
        hasChildren &&
        Divider_css_1.default[css_utilities_1.variationName('alignment', alignment)], blockSpacing && Divider_css_1.default[css_utilities_1.variationName('spacing', blockSpacing)], width && Divider_css_1.default[css_utilities_1.variationName('borderWidth', width)])}>
      {hasChildren && (<div className={css_utilities_1.classNames(Divider_css_1.default.DividerContent, Divider_css_1.default[css_utilities_1.variationName('contentDirection', direction)], alignment && Divider_css_1.default[css_utilities_1.variationName('contentAlignment', alignment)])}>
          {children}
        </div>)}
    </div>);
}
exports.Divider = Divider;
