"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dom_1 = require("@quilted/react-testing/dom");
const faker_1 = __importDefault(require("faker"));
const Text_1 = require("../Text");
const Divider_1 = require("./Divider");
describe('<Divider />', () => {
    it('renders a single line by default', () => {
        const divider = dom_1.mount(<Divider_1.Divider />);
        expect(divider).toContainReactComponent('div');
    });
    it('renders children', () => {
        const text = faker_1.default.lorem.words(2);
        const divider = dom_1.mount(<Divider_1.Divider>
        <Text_1.Text>{text}</Text_1.Text>
      </Divider_1.Divider>);
        expect(divider).toContainReactComponent(Text_1.Text, {
            children: text,
        });
    });
});
