"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlagIcon = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const FlagIcon_css_1 = __importDefault(require("./FlagIcon.css"));
const images_1 = require("./images");
function FlagIcon({ accessibilityLabel, countryCode, size }) {
    const className = css_utilities_1.classNames(FlagIcon_css_1.default.FlagIcon, size && FlagIcon_css_1.default[css_utilities_1.variationName('size', size)]);
    return (<img alt={accessibilityLabel} className={className} src={images_1.FLAG_ICON_BY_COUNTRY_CODE[countryCode]}/>);
}
exports.FlagIcon = FlagIcon;
