"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dom_1 = require("@quilted/react-testing/dom");
const Text_1 = require("../Text");
const FormattedText_1 = require("./FormattedText");
describe('<FormattedText />', () => {
    describe('content', () => {
        it('renders a string when passed a string as content', () => {
            const content = 'Snowdevil';
            const formatted = dom_1.mount(<FormattedText_1.FormattedText>{content}</FormattedText_1.FormattedText>);
            expect(formatted).toContainReactText(content);
        });
        it('renders a React component when passed a component as content', () => {
            const content = <Text_1.Text>Text</Text_1.Text>;
            const formatted = dom_1.mount(<FormattedText_1.FormattedText>{content}</FormattedText_1.FormattedText>);
            expect(formatted).toContainReactComponent(Text_1.Text);
        });
        it('replaces new line characters by <br>s', () => {
            const content = '490 Rue De La Gauchetiere O,\nMontreal,\nQC\nH2Z 0B3';
            const formatted = dom_1.mount(<FormattedText_1.FormattedText>{content}</FormattedText_1.FormattedText>);
            expect(formatted).toContainReactHtml('490 Rue De La Gauchetiere O,<br>Montreal,<br>QC<br>H2Z 0B3');
        });
    });
});
