import { PropsWithChildren } from 'react';
declare type ViewportSize = 'small' | 'medium' | 'large';
declare type AboveViewportSize = Exclude<ViewportSize, 'large'>;
declare type BelowViewportSize = Exclude<ViewportSize, 'small'>;
export declare type Props = {
    /**
     * Hides the content above this viewport size
     */
    above: AboveViewportSize;
    /**
     * Hides the content below this viewport size
     */
    below?: BelowViewportSize;
} | {
    /**
     * Hides the content above this viewport size
     */
    above?: AboveViewportSize;
    /**
     * Hides the content below this viewport size
     */
    below: BelowViewportSize;
};
/**
 * Hidden is used to hide content from users based on their viewport size.
 */
export declare function Hidden({ above, below, children }: PropsWithChildren<Props>): JSX.Element;
export {};
