"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AVAILABLE_ICONS = exports.Icon = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const legacy_1 = require("../../utilities/legacy");
const icons_1 = require("../../icons");
const Icon_css_1 = __importDefault(require("./Icon.css"));
const BUNDLED_ICONS = {
    arrowLeft: icons_1.arrowLeft,
    arrowRight: icons_1.arrowRight,
    calendar: icons_1.calendar,
    camera: icons_1.camera,
    cancelCircle: icons_1.cancelCircle,
    caretDown: icons_1.caretDown,
    cart: icons_1.cart,
    checkmark: icons_1.checkmark,
    checkmarkCircle: icons_1.checkmarkCircle,
    chevronDown: icons_1.chevronDown,
    chevronUp: icons_1.chevronUp,
    chevronRight: icons_1.chevronRight,
    chevronLeft: icons_1.chevronLeft,
    close: icons_1.close,
    critical: icons_1.critical,
    discount: icons_1.discount,
    delivered: icons_1.delivered,
    delivery: icons_1.delivery,
    disabled: icons_1.disabled,
    errorFill: icons_1.errorFill,
    geolocation: icons_1.geolocation,
    info: icons_1.info,
    list: icons_1.list,
    locateMe: icons_1.locateMe,
    lock: icons_1.lock,
    map: icons_1.map,
    marker: icons_1.marker,
    minus: icons_1.minus,
    mobile: icons_1.mobile,
    plus: icons_1.plus,
    questionFill: icons_1.questionFill,
    reorder: icons_1.reorder,
    spinner: icons_1.spinner,
    spinnerSmall: icons_1.spinnerSmall,
    store: icons_1.store,
    success: icons_1.success,
    truck: icons_1.truck,
    warning: icons_1.warning,
    warningCircle: icons_1.warningCircle,
    warningFill: icons_1.warningFill,
    giftFill: icons_1.giftFill,
    external: icons_1.external,
};
function Icon({ source, appearance, size, accessibilityLabel, }) {
    const className = css_utilities_1.classNames(Icon_css_1.default.Icon, appearance && Icon_css_1.default[css_utilities_1.variationName('appearance', appearance)], appearance && appearance === 'accent' && legacy_1.utilityDefaultColorAccent, appearance && appearance === 'subdued' && legacy_1.utilityDefaultTextColorSubdued, size && Icon_css_1.default[css_utilities_1.variationName('size', size)]);
    const SourceComponent = BUNDLED_ICONS[source];
    const contentMarkup = (<SourceComponent className={Icon_css_1.default.Svg} focusable="false" aria-hidden="true" role="presentation"/>);
    return (<span className={className} aria-label={accessibilityLabel}>
      {contentMarkup}
    </span>);
}
exports.Icon = Icon;
exports.AVAILABLE_ICONS = Object.keys(BUNDLED_ICONS);
