/// <reference types="react" />
import { Story } from '@storybook/preact/types-6-0';
import { ImageProps } from '@shopify/checkout-ui-extensions';
import { Image } from './Image';
declare const meta: {
    component: typeof Image;
    title: string;
    argTypes: {
        source: {
            name: string;
            type: {
                name: string;
                required: boolean;
            };
            defaultValue: string;
            control: {
                type: string;
            };
        };
        description: {
            name: string;
            type: {
                name: string;
                required: boolean;
            };
            defaultValue: string;
            control: {
                type: string;
            };
        };
        loading: {
            name: string;
            control: {
                type: string;
                options: string[];
                required: boolean;
            };
        };
        fit: {
            name: string;
            control: {
                type: string;
                options: string[];
                required: boolean;
            };
        };
    };
};
export default meta;
export declare const basicImage: Story<ImageProps>;
export declare const lazyLoading: Story<ImageProps>;
export declare const cover: Story<ImageProps>;
export declare const contain: Story<ImageProps>;
export declare const responsive: Story<ImageProps>;
export declare const aspectRatio: {
    (args: ImageProps): JSX.Element;
    args: {
        source: string;
        aspectRatio: number;
    };
};
