import { PropsWithChildren } from 'react';
import { LinkProps } from '@shopify/checkout-ui-extensions';
import { ThemeTypographyStyle } from '../Theme';
export interface Props extends LinkProps {
    /**
     * Specify the color of the link.
     * `monochrome` will take the color of its parent.
     */
    appearance?: 'monochrome';
    /**
     * Changes the text based on the Theme styles
     */
    style?: ThemeTypographyStyle;
}
/**
 * Link is used to navigate the buyer to another page or section within the same page.
 */
export declare function Link({ children, to, language, onPress, appearance, accessibilityLabel, ...rest }: PropsWithChildren<Props>): JSX.Element;
