"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Link = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const Button_1 = require("../Button");
const Theme_1 = require("../Theme");
const typography_styles_css_1 = __importDefault(require("../../utilities/typography-styles.css"));
const components_1 = require("./components");
const Link_css_1 = __importDefault(require("./Link.css"));
/**
 * Link is used to navigate the buyer to another page or section within the same page.
 */
function Link(_a) {
    var { children, to, language, onPress, appearance, accessibilityLabel } = _a, rest = __rest(_a, ["children", "to", "language", "onPress", "appearance", "accessibilityLabel"]);
    const { link: { colorHovered, typographyStyle }, } = Theme_1.useThemeConfiguration();
    if (!to) {
        return (<Button_1.Button onPress={onPress} kind="plain" appearance={appearance} {...rest}>
        {children}
      </Button_1.Button>);
    }
    return (<components_1.UnstyledLink className={css_utilities_1.classNames(Link_css_1.default.Link, appearance && appearance === 'monochrome'
        ? Link_css_1.default.appearanceMonochrome
        : Link_css_1.default.appearanceDefault, colorHovered && Link_css_1.default[css_utilities_1.variationName('colorHovered', colorHovered)], typographyStyle && typography_styles_css_1.default[typographyStyle])} to={to} onPress={onPress} language={language} accessibilityLabel={accessibilityLabel} {...rest}>
      {children}
    </components_1.UnstyledLink>);
}
exports.Link = Link;
