import { PropsWithChildren } from 'react';
import { LinkProps } from '@shopify/checkout-ui-extensions';
export interface Props extends Omit<LinkProps, 'to'> {
    /** CSS class that is applied to the link */
    className?: string;
    /** Destination to navigate to. */
    to: string;
    ariaBusy?: boolean;
    ariaLive?: 'assertive' | 'polite' | 'off';
    ariaLabel?: string;
}
export declare function UnstyledLink({ children, className: classNameProp, to, external, id, language, ariaBusy, ariaLive, ariaLabel, onPress, }: PropsWithChildren<Props>): JSX.Element;
