import { PropsWithChildren } from 'react';
export declare type Props = PropsWithChildren<{
    /**
     * Whether the modal is closable or not. This will prevent closing
     * the modal by pressing `ESC` and hide the "close" button. This
     * can be used in flows where the user feedback is mandatory.
     */
    maxInlineSize?: number | 'fill';
    blockSize?: 'fill';
    open: boolean;
    title: string;
    titleHidden?: boolean;
    source?: string;
    /**
     * Do not animate modal on mount. Changing `open` props still triggers animation.
     */
    noMountTransition?: boolean;
}> & (BlockingProps | NonBlockingProps);
interface BlockingProps {
    blocking: true;
}
interface NonBlockingProps {
    blocking?: false;
    onClose: () => void;
}
export declare function Modal({ maxInlineSize, blockSize, open, title, titleHidden, source, noMountTransition, children, ...rest }: Props): JSX.Element | null;
export {};
