"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const test_utilities_1 = require("../../test-utilities");
const Heading_1 = require("../Heading");
const View_1 = require("../View");
const components_1 = require("./components");
const MoneyLines_1 = require("./MoneyLines");
describe('<MoneyLines />', () => {
    it('renders the children', () => {
        const moneyLines = test_utilities_1.mountWithContext(<MoneyLines_1.MoneyLines title="title">
        <components_1.MoneyLine />
        <components_1.MoneySummary />
      </MoneyLines_1.MoneyLines>);
        expect(moneyLines).toContainReactComponent(components_1.MoneyLine);
        expect(moneyLines).toContainReactComponent(components_1.MoneySummary);
    });
    it('renders the title', () => {
        const title = test_utilities_1.faker.random.word();
        const moneyLines = test_utilities_1.mountWithContext(<MoneyLines_1.MoneyLines title={title}/>);
        expect(moneyLines).toContainReactComponent(Heading_1.Heading, {
            children: title,
        });
    });
    it('renders a visually hidden title', () => {
        const title = test_utilities_1.faker.random.word();
        const moneyLines = test_utilities_1.mountWithContext(<MoneyLines_1.MoneyLines title={title} titleHidden/>);
        expect(moneyLines.find(View_1.View)).toContainReactComponent(Heading_1.Heading, {
            children: title,
        });
    });
});
