"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OptionDetails = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const hooks_1 = require("../../hooks");
const Collapsible_1 = require("../../../Collapsible");
const OptionList_css_1 = __importDefault(require("../../OptionList.css"));
const Theme_1 = require("../../../Theme");
function OptionDetails({ controlledBy, children }) {
    const { selectedItems, id: optionListId } = hooks_1.useOptionList();
    const { optionList: { detailsBackground }, } = Theme_1.useThemeConfiguration();
    const isSelected = selectedItems.includes(controlledBy);
    if (!children) {
        return null;
    }
    return (<Collapsible_1.Collapsible open={isSelected} id={`${optionListId}-${controlledBy}-collapsible`}>
      <div className={css_utilities_1.classNames(OptionList_css_1.default.Details, detailsBackground &&
        OptionList_css_1.default[css_utilities_1.variationName('Details-background', detailsBackground)])}>
        {children}
      </div>
    </Collapsible_1.Collapsible>);
}
exports.OptionDetails = OptionDetails;
