import { ReactNode } from 'react';
import { Props as PopperProps } from '../Popper';
export interface Props {
    children: ReactNode;
    /**
     * Element used to activate the popover
     */
    activator: HTMLElement | null;
    /**
     * Show or hide the popover
     */
    open: boolean;
    /**
     * Position the popover relative to the activator
     * @defaultValue 'inlineEnd'
     */
    placement?: PopperProps['placement'];
    /**
     * Defines the style of the backdrop under the popover
     */
    backdrop?: 'translucent' | 'none';
    /**
     * Callback to run when the Popover is closed
     */
    onClose: () => void;
}
export declare function Popover({ children, activator, open, placement, backdrop, onClose, }: Props): JSX.Element | null;
