"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Popper = void 0;
const react_1 = __importStar(require("react"));
const Portal_1 = require("../Portal");
const units_1 = require("../../utilities/units");
const hooks_1 = require("./hooks");
const context_1 = require("./context");
const offsets_1 = require("./utilities/offsets");
const Popper_css_1 = __importDefault(require("./Popper.css"));
function Popper({ children, offset, placement = 'blockStart', preventOverflow, activator, sameInlineSize, minInlineSize, }) {
    const referenceRect = hooks_1.useEffectRect(activator);
    const [popperRect, popperRef] = hooks_1.useRect();
    const { clipping, offsets, spacing } = react_1.useMemo(() => offsets_1.computeOffsets(placement, popperRect, referenceRect, {
        offset,
        preventOverflow,
        sameInlineSize,
    }), [
        offset,
        placement,
        popperRect,
        preventOverflow,
        referenceRect,
        sameInlineSize,
    ]);
    const contextValue = react_1.useMemo(() => ({
        clipping,
        offsets,
        placement,
        popperRect,
        referenceRect,
        spacing,
    }), [clipping, offsets, placement, popperRect, referenceRect, spacing]);
    const { x, y } = offsets_1.roundOffsets({
        x: offsets.x + spacing + (window.scrollX || window.pageXOffset),
        y: offsets.y + (window.scrollY || window.pageYOffset),
    });
    const transform = (window.devicePixelRatio || 1) < 2
        ? `translate(${x}px, ${y}px)`
        : `translate3d(${x}px, ${y}px, 0)`;
    return (<context_1.PopperContext.Provider value={contextValue}>
      <Portal_1.Portal>
        <div className={Popper_css_1.default.Popper} style={Object.assign({}, (referenceRect && Object.assign(Object.assign({ transform, MozTransform: transform, webkitTransform: transform }, (sameInlineSize && { width: referenceRect.width })), (minInlineSize && { minWidth: units_1.rem(minInlineSize) }))))} ref={popperRef}>
          {children}
        </div>
      </Portal_1.Portal>
    </context_1.PopperContext.Provider>);
}
exports.Popper = Popper;
