"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dom_1 = require("@quilted/react-testing/dom");
const context_1 = require("./context");
const ProgressTracker_1 = require("./ProgressTracker");
const _1 = require(".");
describe('<ProgressTracker />', () => {
    it('renders <ProgressTrackerStep /> children', () => {
        const progressTracker = dom_1.mount(<ProgressTracker_1.ProgressTracker>
        <_1.ProgressTrackerStep id="step1" icon="checkmark" label="Step 1" state="State 1"/>
        <_1.ProgressTrackerStep id="step2" icon="checkmark" label="Step 2" state="State 2"/>
      </ProgressTracker_1.ProgressTracker>);
        expect(progressTracker).toContainReactComponent(_1.ProgressTrackerStep);
        expect(progressTracker).toContainReactComponentTimes(_1.ProgressTrackerStep, 2);
    });
    it('wraps <ProgressTrackerStep /> children with ProgressTrackerContext', () => {
        const progressTracker = dom_1.mount(<ProgressTracker_1.ProgressTracker activeStep="step2">
        <_1.ProgressTrackerStep id="step1" icon="checkmark" label="Step 1" state="State 1"/>
        <_1.ProgressTrackerStep id="step2" icon="checkmark" label="Step 2" state="State 3"/>
        <_1.ProgressTrackerStep id="step3" icon="checkmark" label="Step 3" state="State 3"/>
      </ProgressTracker_1.ProgressTracker>);
        expect(progressTracker).toProvideReactContext(context_1.ProgressTrackerContext, {
            steps: {
                step1: { active: false, completed: true },
                step2: { active: true, completed: false },
                step3: { active: false, completed: false },
            },
        });
    });
});
