"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dom_1 = require("@quilted/react-testing/dom");
const Redact_1 = require("./Redact");
describe('<Redact />', () => {
    describe('lines', () => {
        it('defaults to one line', () => {
            const redacted = dom_1.mount(<Redact_1.Redact />);
            expect(redacted).toContainReactComponentTimes('div', 1);
        });
        it('renders the exact number of lines', () => {
            const redacted = dom_1.mount(<Redact_1.Redact lines={3}/>);
            expect(redacted).toContainReactComponentTimes('div', 3);
        });
    });
    describe('blockSize', () => {
        it('defaults to base blockSize', () => {
            const redacted = dom_1.mount(<Redact_1.Redact />);
            const classNames = redacted.find('div').prop('className');
            expect(classNames).toContain('blockSizeBase');
        });
        it('renders with specific blockSize', () => {
            const redacted = dom_1.mount(<Redact_1.Redact blockSize="large"/>);
            const classNames = redacted.find('div').prop('className');
            expect(classNames).toContain('blockSizeLarge');
        });
    });
});
