"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withHiddenHeaderContent = exports.withHeader = exports.borderOuter = exports.borderInner = exports.borderFull = exports.oneItem = exports.multipleItems = void 0;
const react_1 = __importDefault(require("react"));
const addon_knobs_1 = require("@storybook/addon-knobs");
const storybook_utilities_1 = require("../../storybook-utilities");
const Text_1 = require("../Text");
const Thumbnail_1 = require("../Thumbnail");
const ResourceList_1 = require("./ResourceList");
const _1 = require(".");
const meta = {
    component: ResourceList_1.ResourceList,
    title: 'checkout-web-ui/ResourceList',
    decorators: [addon_knobs_1.withKnobs, storybook_utilities_1.themeWithKnobs()],
};
exports.default = meta;
function Item() {
    return (<_1.ResourceItem>
      <_1.ResourceItemContent>
        <Thumbnail_1.Thumbnail description="some media source" badge={1}/>
      </_1.ResourceItemContent>
      <_1.ResourceItemContent primary>
        <Text_1.Text emphasized>T-shirt</Text_1.Text>
        <Text_1.Text subdued>L/Blue</Text_1.Text>
      </_1.ResourceItemContent>
      <_1.ResourceItemContent>
        <Text_1.Text emphasized>$12.00</Text_1.Text>
      </_1.ResourceItemContent>
    </_1.ResourceItem>);
}
exports.multipleItems = () => (<ResourceList_1.ResourceList title="Products" titleHidden>
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.oneItem = () => (<ResourceList_1.ResourceList title="Products" titleHidden>
    <Item />
  </ResourceList_1.ResourceList>);
exports.borderFull = () => (<ResourceList_1.ResourceList title="Products" titleHidden border="full">
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.borderInner = () => (<ResourceList_1.ResourceList title="Products" titleHidden border="inner">
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.borderOuter = () => (<ResourceList_1.ResourceList title="Products" titleHidden border="outer">
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.withHeader = () => (<ResourceList_1.ResourceList title="Products" titleHidden>
    <ResourceList_1.ResourceListHeader>
      <ResourceList_1.ResourceListHeaderContent>
        <Text_1.Text>Image</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
      <ResourceList_1.ResourceListHeaderContent primary>
        <Text_1.Text>Description</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
      <ResourceList_1.ResourceListHeaderContent>
        <Text_1.Text>Price</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
    </ResourceList_1.ResourceListHeader>
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.withHiddenHeaderContent = () => (<ResourceList_1.ResourceList titleHidden title="Products">
    <ResourceList_1.ResourceListHeader>
      <ResourceList_1.ResourceListHeaderContent primary>
        <Text_1.Text emphasized>test</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
      <ResourceList_1.ResourceListHeaderContent>
        <Text_1.Text emphasized>test</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
    </ResourceList_1.ResourceListHeader>
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
