import React from 'react';
import { ThemeBackground, ThemeResourceItemDivider, ThemeSpacing } from '../../../Theme';
declare type Alignment = 'leading' | 'center' | 'trailing';
export interface ResourceItemContentProps {
    /** Position children along the cross axis */
    alignment?: Alignment;
    children?: React.ReactNode;
    primary?: boolean;
    hidden?: boolean;
}
export declare function ResourceItemContent({ alignment, children, primary, hidden, }: ResourceItemContentProps): JSX.Element;
export interface Props {
    children?: React.ReactNode;
    background?: ThemeBackground;
    divider?: ThemeResourceItemDivider;
    inlinePadding?: ThemeSpacing;
    blockPadding?: ThemeSpacing;
    spacing?: ThemeSpacing;
}
export declare function ResourceItem({ children, background, divider, inlinePadding, blockPadding, spacing, }: Props): JSX.Element;
export {};
