"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourceItem = exports.ResourceItemContent = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const legacy_1 = require("../../../../utilities/legacy");
const View_1 = require("../../../View");
const ResourceItem_css_1 = __importDefault(require("./ResourceItem.css"));
function ResourceItemContent({ alignment = 'center', children, primary, hidden, }) {
    const className = css_utilities_1.classNames(ResourceItem_css_1.default.ResourceItemContent, alignment &&
        ResourceItem_css_1.default[css_utilities_1.variationName('ResourceItemContent-alignment', alignment)], primary && ResourceItem_css_1.default['ResourceItemContent-isPrimary'], hidden && ResourceItem_css_1.default['ResourceItemContent-isHidden']);
    return (<div role="cell" className={className}>
      {hidden ? <View_1.View visibility="hidden">{children}</View_1.View> : children}
    </div>);
}
exports.ResourceItemContent = ResourceItemContent;
function ResourceItem({ children, background, divider, inlinePadding, blockPadding, spacing = 'base', }) {
    const className = css_utilities_1.classNames(ResourceItem_css_1.default.ResourceItem, legacy_1.utilityDefaultBorderColor, background && ResourceItem_css_1.default[css_utilities_1.variationName('background', background)], inlinePadding && ResourceItem_css_1.default[css_utilities_1.variationName('inlinePadding', inlinePadding)], blockPadding && ResourceItem_css_1.default[css_utilities_1.variationName('blockPadding', blockPadding)], divider && ResourceItem_css_1.default[css_utilities_1.variationName('divider', divider)], spacing && ResourceItem_css_1.default[css_utilities_1.variationName('spacing', spacing)]);
    return (<div role="row" className={className}>
      {children}
    </div>);
}
exports.ResourceItem = ResourceItem;
