"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dom_1 = require("@quilted/react-testing/dom");
const faker_1 = __importDefault(require("faker"));
const ResourceItem_1 = require("./ResourceItem");
describe('<ResourceItem />', () => {
    it('renders <ResourceItemContent />', () => {
        const resourceItem = dom_1.mount(<ResourceItem_1.ResourceItem>
        <ResourceItem_1.ResourceItemContent>
          <img src={faker_1.default.image.imageUrl()} alt={faker_1.default.random.words()}/>
        </ResourceItem_1.ResourceItemContent>
      </ResourceItem_1.ResourceItem>);
        expect(resourceItem).toContainReactComponent(ResourceItem_1.ResourceItemContent);
    });
    it('renders a primary <ResourceItemContent />', () => {
        const resourceItem = dom_1.mount(<ResourceItem_1.ResourceItem>
        <ResourceItem_1.ResourceItemContent primary>
          {faker_1.default.random.words()}
        </ResourceItem_1.ResourceItemContent>
      </ResourceItem_1.ResourceItem>);
        expect(resourceItem).toContainReactComponent(ResourceItem_1.ResourceItemContent);
    });
});
