"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Section = exports.SectionContext = void 0;
const react_1 = __importStar(require("react"));
const HeadingGroup_1 = require("../HeadingGroup");
const View_1 = require("../View");
exports.SectionContext = react_1.createContext(undefined);
function useSection() {
    return react_1.useContext(exports.SectionContext);
}
function Section({ accessibilityLabel, background, border, borderColor, borderRadius, borderWidth, padding, children, }) {
    var _a;
    const context = useSection();
    const level = ((_a = context === null || context === void 0 ? void 0 : context.level) !== null && _a !== void 0 ? _a : 0) + 1;
    return (<exports.SectionContext.Provider value={{ level }}>
      <View_1.View accessibilityLabel={accessibilityLabel} background={background} border={border} borderColor={borderColor} borderRadius={borderRadius} borderWidth={borderWidth} padding={padding} role="region">
        {level > 1 ? <HeadingGroup_1.HeadingGroup>{children}</HeadingGroup_1.HeadingGroup> : children}
      </View_1.View>
    </exports.SectionContext.Provider>);
}
exports.Section = Section;
