"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tag = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const Icon_1 = require("../Icon");
const Truncate_1 = require("../Truncate");
const Tag_css_1 = __importDefault(require("./Tag.css"));
function Tag({ children, icon, onRemove, removeControlAccessibilityLabel, }) {
    const tagClassNames = css_utilities_1.classNames(Tag_css_1.default.Tag);
    const labelClassNames = css_utilities_1.classNames(Tag_css_1.default.Label, Boolean(onRemove) && Tag_css_1.default.removable);
    const iconClassNames = css_utilities_1.classNames(Tag_css_1.default.Icon);
    return (<div className={tagClassNames}>
      <span className={labelClassNames}>
        {icon && (<span className={iconClassNames}>
            <Icon_1.Icon source={icon} size="large"/>
          </span>)}
        <Truncate_1.Truncate>{children}</Truncate_1.Truncate>
      </span>
      {Boolean(onRemove) && (<button type="button" className={Tag_css_1.default.Button} onClick={onRemove} aria-label={removeControlAccessibilityLabel}>
          <Icon_1.Icon source="close" size="base"/>
        </button>)}
    </div>);
}
exports.Tag = Tag;
