"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RemovableTags = exports.TagStory = void 0;
const react_1 = __importDefault(require("react"));
const addon_knobs_1 = require("@storybook/addon-knobs");
const InlineStack_1 = require("../InlineStack");
const Text_1 = require("../Text");
const Icon_1 = require("../Icon");
const storybook_utilities_1 = require("../../storybook-utilities");
const Tag_1 = require("./Tag");
const meta = {
    component: Tag_1.Tag,
    title: 'checkout-web-ui/Tag',
    decorators: [addon_knobs_1.withKnobs, storybook_utilities_1.themeWithKnobs('tag')],
    argTypes: {
        icon: {
            control: {
                type: 'select',
                options: [undefined, ...Icon_1.AVAILABLE_ICONS],
            },
        },
    },
};
exports.default = meta;
const Content = () => <Text_1.Text emphasized>Hello, world</Text_1.Text>;
exports.TagStory = (props) => (<InlineStack_1.InlineStack>
    {Array(3)
    .fill('Hello, world')
    .map((text, i) => (<Tag_1.Tag {...props} key={text}>
          <Text_1.Text emphasized>
            {text} {i + 1}!
          </Text_1.Text>
        </Tag_1.Tag>))}
  </InlineStack_1.InlineStack>);
exports.TagStory.args = {
    onRemove: 'javascript:;',
    removeControlAccessibilityLabel: 'Remove tag',
    icon: undefined,
};
exports.TagStory.story = {
    name: 'Tag',
};
exports.RemovableTags = () => (<InlineStack_1.InlineStack>
    <Tag_1.Tag removeControlAccessibilityLabel="Remove tag" onRemove={() => { }}>
      <Content />
    </Tag_1.Tag>
    <Tag_1.Tag icon="discount" removeControlAccessibilityLabel="Remove tag" onRemove={() => { }}>
      <Content />
    </Tag_1.Tag>
  </InlineStack_1.InlineStack>);
