import React, { PropsWithChildren } from 'react';
import { TextFieldProps } from '@shopify/checkout-ui-extensions';
export interface Props extends PropsWithChildren<TextFieldProps> {
    autofocus?: boolean;
    maxLength?: number;
}
/**
 * A text field is an input field that merchants can type into.
 */
export declare const TextField: React.ForwardRefExoticComponent<Props & React.RefAttributes<unknown>>;
export interface InternalProps extends Omit<Props, 'error'> {
    min?: number;
    max?: number;
    step?: number;
    maxLength?: number;
    ariaActiveDescendant?: string;
    ariaAutocomplete?: string;
    ariaControls?: string;
    ariaDescribedBy?: string;
    ariaExpanded?: boolean;
    role?: string;
    error?: string | boolean;
    onKeyDown?(event: React.KeyboardEvent<HTMLInputElement>): void;
}
export declare const TextFieldInternal: React.ForwardRefExoticComponent<InternalProps & React.RefAttributes<unknown>>;
interface FieldProps extends Omit<InternalProps, 'id'> {
    id: string;
    localValue?: string;
    focus: boolean;
}
export declare const Field: React.ForwardRefExoticComponent<FieldProps & React.RefAttributes<unknown>>;
export {};
