"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomPropertiesFallback = void 0;
const react_1 = __importStar(require("react"));
const hooks_1 = require("../../hooks");
const legacyStyles = __importStar(require("../../../../utilities/legacy"));
const style_1 = require("../../../../utilities/style");
exports.CustomPropertiesFallback = react_1.memo(function CustomPropertiesFallback() {
    const theme = hooks_1.useTheme();
    const [customProperties, setCustomProperties] = react_1.useState(theme.customProperties);
    react_1.useEffect(() => {
        return theme.on('preview', (customProperties) => {
            setCustomProperties((existing) => (Object.assign(Object.assign({}, existing), customProperties)));
        });
    }, [theme]);
    const css = react_1.useMemo(() => toCss(customProperties), [customProperties]);
    return <style dangerouslySetInnerHTML={{ __html: css }}/>;
});
function toCss(customProperties) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return cssFromObject({
        [`.${legacyStyles.button}::before, .${legacyStyles.button}::after`]: {
            display: 'none',
        },
        [`.${legacyStyles.buttonPrimary}`]: {
            color: (_a = customProperties.colorPrimaryActionText) !== null && _a !== void 0 ? _a : style_1.ThemeDefault.ColorPrimaryActionText,
            background: (_b = customProperties.colorPrimaryAction) !== null && _b !== void 0 ? _b : style_1.ThemeDefault.ColorPrimaryAction,
            padding: (_c = customProperties.primaryButtonBlockPadding) !== null && _c !== void 0 ? _c : style_1.ThemeDefault.ButtonPadding,
            'border-radius': (_d = customProperties.primaryButtonBorderRadius) !== null && _d !== void 0 ? _d : style_1.ThemeDefault.ButtonBorderRadius,
        },
        [`.${legacyStyles.buttonSecondary}`]: {
            color: (_e = customProperties.colorSecondaryAction) !== null && _e !== void 0 ? _e : style_1.ThemeDefault.ColorSecondaryAction,
            background: 'transparent',
            'border-color': (_f = customProperties.colorSecondaryAction) !== null && _f !== void 0 ? _f : style_1.ThemeDefault.ColorSecondaryAction,
            padding: (_g = customProperties.secondaryButtonBlockPadding) !== null && _g !== void 0 ? _g : style_1.ThemeDefault.ButtonPadding,
            'border-radius': (_h = customProperties.primaryButtonBorderRadius) !== null && _h !== void 0 ? _h : style_1.ThemeDefault.ButtonBorderRadius,
        },
        [`.${legacyStyles.buttonPrimary}.${legacyStyles.buttonCritical}`]: {
            color: (_j = customProperties.colorCriticalText) !== null && _j !== void 0 ? _j : style_1.ThemeDefault.ColorCriticalText,
            background: (_k = customProperties.colorCriticalAccent) !== null && _k !== void 0 ? _k : style_1.ThemeDefault.ColorCriticalAccent,
        },
        [`.${legacyStyles.buttonSecondary}.${legacyStyles.buttonCritical}`]: {
            color: (_l = customProperties.colorCriticalAccent) !== null && _l !== void 0 ? _l : style_1.ThemeDefault.ColorCriticalAccent,
            background: 'transparent',
            'border-color': (_m = customProperties.colorCriticalAccent) !== null && _m !== void 0 ? _m : style_1.ThemeDefault.ColorCriticalAccent,
        },
        [`.${legacyStyles.colorCanvas}`]: {
            color: customProperties.colorCanvasText,
            'border-color': customProperties.colorCanvasBorder,
            'background-color': customProperties.colorCanvas,
        },
        [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorCanvasBorder,
        },
        [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorCanvasTextSubdued,
        },
        [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorCanvasTextEmphasized,
        },
        [`.${legacyStyles.colorSurfacePrimary}`]: {
            color: customProperties.colorSurfacePrimaryText,
            'border-color': customProperties.colorSurfacePrimaryBorder,
            'background-color': customProperties.colorSurfacePrimary,
        },
        [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorSurfacePrimaryBorder,
        },
        [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorSurfacePrimaryTextSubdued,
        },
        [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorSurfacePrimaryTextEmphasized,
        },
        [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultColorAccent}`]: {
            color: customProperties.colorSurfacePrimaryAccent,
        },
        [`.${legacyStyles.colorSurfaceSecondary}`]: {
            color: customProperties.colorSurfaceSecondaryText,
            'border-color': customProperties.colorSurfaceSecondaryBorder,
            'background-color': customProperties.colorSurfaceSecondary,
        },
        [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorSurfaceSecondaryBorder,
        },
        [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorSurfaceSecondaryTextSubdued,
        },
        [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorSurfaceSecondaryTextEmphasized,
        },
        [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultColorAccent}`]: {
            color: customProperties.colorSurfaceSecondaryAccent,
        },
        [`.${legacyStyles.colorSurfaceTertiary}`]: {
            color: customProperties.colorSurfaceTertiaryText,
            'border-color': customProperties.colorSurfaceTertiaryBorder,
            'background-color': customProperties.colorSurfaceTertiary,
        },
        [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorSurfaceTertiaryBorder,
        },
        [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorSurfaceTertiaryTextSubdued,
        },
        [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorSurfaceTertiaryTextEmphasized,
        },
        [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultColorAccent}`]: {
            color: customProperties.colorSurfaceTertiaryAccent,
        },
        [`.${legacyStyles.colorCriticalAccent}`]: {
            color: (_o = customProperties.colorCriticalAccent) !== null && _o !== void 0 ? _o : style_1.ThemeDefault.ColorCriticalAccent,
        },
    });
}
function cssFromObject(cssObject) {
    const selectors = [];
    for (const selector of Object.keys(cssObject)) {
        const propertyValues = [];
        for (const property of Object.keys(cssObject[selector])) {
            const value = cssObject[selector][property];
            if (value)
                propertyValues.push(`${property}: ${value} !important;`);
        }
        if (propertyValues.length > 0)
            selectors.push(`${selector} {\n  ${propertyValues.join('\n  ')}\n}`);
    }
    return selectors.join('\n');
}
