"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MaybeWebFonts = exports.WebFonts = void 0;
const react_1 = __importStar(require("react"));
const hooks_1 = require("../../hooks");
function WebFonts({ children }) {
    const { typographyPrimary, typographySecondary } = hooks_1.useThemeConfiguration();
    react_1.useEffect(() => {
        const fonts = [typographyPrimary, typographySecondary]
            .map((typography) => [
            {
                fonts: typography.fonts,
                source: typography.sourceBase,
                weight: typography.weightBase,
            },
            {
                fonts: typography.fonts,
                source: typography.sourceBold,
                weight: typography.weightBold,
            },
        ])
            .reduce((fonts, typography) => fonts.concat(typography), [])
            .filter((font) => font.fonts !== undefined && font.source !== undefined)
            .map(({ fonts, source, weight }) => new FontFace(fonts, source, {
            weight,
        }));
        async function loadFonts() {
            await Promise.all(fonts).then((loadedFonts) => {
                loadedFonts.forEach(function (font) {
                    document.fonts.add(font);
                });
            });
        }
        loadFonts();
    }, [typographyPrimary, typographySecondary]);
    return <>{children}</>;
}
exports.WebFonts = WebFonts;
function MaybeWebFonts({ children, condition, }) {
    return condition ? <WebFonts>{children}</WebFonts> : <>{children}</>;
}
exports.MaybeWebFonts = MaybeWebFonts;
