/// <reference types="react" />
import { Hsl } from '../../utilities/hsluv';
import { ThemeConfiguration, ThemeOptions, CustomPropertyMap, RoleColorOverrides, ThemeConstructor, TypographyScaleOverrides, DurationScaleOverrides, ColorGroup } from './types';
interface EventMap {
    change: (configuration: ThemeConfiguration) => void;
    preview: (customProperties: Partial<CustomPropertyMap>) => void;
}
export declare const ThemeContext: import("react").Context<UiTheme | undefined>;
export declare function createTheme({ global, durationScale, buyerJourney, typographyScale, typographyPrimary, typographySecondary, headingLevel1, headingLevel2, headingLevel3, link, controls, label, textFields, stepper, select, checkbox, radio, optionList, reviewBlock, lineItems, stockProblemsLineItems, throttleLineItems, moneyLines, moneySummary, primaryButton, secondaryButton, formLayout, tag, tooltip, popover, banner, thumbnail, typographyStyle1, typographyStyle2, typographyStyle3, typographyStyle4, typographyStyle5, typographyStyle6, typographyStyle7, typographyStyle8, typographyStyle9, colors, }?: Partial<ThemeConstructor>, { legacy }?: Partial<ThemeOptions>): UiTheme;
export declare class UiTheme {
    configuration: ThemeConfiguration;
    options: ThemeOptions;
    customProperties: Partial<CustomPropertyMap>;
    private readonly listeners;
    constructor(configuration: ThemeConstructor, options?: ThemeOptions);
    preview(overrides: Partial<RoleColorOverrides>, typographyScale: Partial<TypographyScaleOverrides>, durationScale: Partial<DurationScaleOverrides>): void;
    set<Key extends keyof ThemeConfiguration>(key: Key, value: ThemeConfiguration[Key]): void;
    on<Event extends keyof EventMap>(event: Event, listener: EventMap[Event]): () => void;
}
export declare function colorSubdued(colorGroup?: ColorGroup): Hsl | undefined;
export declare function colorDisabled(colorGroup?: ColorGroup): Hsl | undefined;
export declare function colorText(colorGroup?: ColorGroup, legacy?: boolean): Hsl | undefined;
export declare function colorTextEmphasized(colorGroup?: ColorGroup, legacy?: boolean): Hsl | undefined;
export declare function colorTextSubdued(colorGroup?: ColorGroup, legacy?: boolean): Hsl | undefined;
export declare function colorBorderEmphasized(colorGroup?: ColorGroup, legacy?: boolean): Hsl | undefined;
export {};
