export declare type Year = number;
export declare enum Month {
    January = 0,
    February = 1,
    March = 2,
    April = 3,
    May = 4,
    June = 5,
    July = 6,
    August = 7,
    September = 8,
    October = 9,
    November = 10,
    December = 11
}
export declare enum Weekday {
    Sunday = 0,
    Monday = 1,
    Tuesday = 2,
    Wednesday = 3,
    Thursday = 4,
    Friday = 5,
    Saturday = 6
}
export declare type Week = (Date | undefined)[];
export declare const WEEK_LENGTH = 7;
export declare const WEEK_START_DAYS: Map<string, Weekday>;
export declare const ORDERED_WEEKDAYS: Map<number, number[]>;
export declare const DEFAULT_WEEK_START_DAY = Weekday.Sunday;
export declare const DEFAULT_ORDERED_WEEKDAYS: number[];
export declare function getWeekStartDay(countryCode?: string): Weekday;
export declare function getOrderedWeekdays(weekStartsOn: number): number[];
export declare function getWeeksForMonth(month: number, year: number, weekStartsOn?: Weekday): Week[];
export declare function isSameDate(day1: Date, day2: Date): boolean;
export declare function isToday(date: Date): boolean;
export declare function getNextDisplayMonth(month: number): number;
export declare function getNextDisplayYear(month: number, year: number): number;
export declare function getPreviousDisplayMonth(month: number): number;
export declare function getPreviousDisplayYear(month: number, year: number): number;
