"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPreviousDisplayYear = exports.getPreviousDisplayMonth = exports.getNextDisplayYear = exports.getNextDisplayMonth = exports.isToday = exports.isSameDate = exports.getWeeksForMonth = exports.getOrderedWeekdays = exports.getWeekStartDay = exports.DEFAULT_ORDERED_WEEKDAYS = exports.DEFAULT_WEEK_START_DAY = exports.ORDERED_WEEKDAYS = exports.WEEK_START_DAYS = exports.WEEK_LENGTH = exports.Weekday = exports.Month = void 0;
var Month;
(function (Month) {
    Month[Month["January"] = 0] = "January";
    Month[Month["February"] = 1] = "February";
    Month[Month["March"] = 2] = "March";
    Month[Month["April"] = 3] = "April";
    Month[Month["May"] = 4] = "May";
    Month[Month["June"] = 5] = "June";
    Month[Month["July"] = 6] = "July";
    Month[Month["August"] = 7] = "August";
    Month[Month["September"] = 8] = "September";
    Month[Month["October"] = 9] = "October";
    Month[Month["November"] = 10] = "November";
    Month[Month["December"] = 11] = "December";
})(Month = exports.Month || (exports.Month = {}));
var Weekday;
(function (Weekday) {
    Weekday[Weekday["Sunday"] = 0] = "Sunday";
    Weekday[Weekday["Monday"] = 1] = "Monday";
    Weekday[Weekday["Tuesday"] = 2] = "Tuesday";
    Weekday[Weekday["Wednesday"] = 3] = "Wednesday";
    Weekday[Weekday["Thursday"] = 4] = "Thursday";
    Weekday[Weekday["Friday"] = 5] = "Friday";
    Weekday[Weekday["Saturday"] = 6] = "Saturday";
})(Weekday = exports.Weekday || (exports.Weekday = {}));
exports.WEEK_LENGTH = 7;
exports.WEEK_START_DAYS = new Map([
    // Saturday
    ['AE', Weekday.Saturday],
    ['AF', Weekday.Saturday],
    ['BH', Weekday.Saturday],
    ['DZ', Weekday.Saturday],
    ['EG', Weekday.Saturday],
    ['IQ', Weekday.Saturday],
    ['IR', Weekday.Saturday],
    ['JO', Weekday.Saturday],
    ['KW', Weekday.Saturday],
    ['LY', Weekday.Saturday],
    ['OM', Weekday.Saturday],
    ['QA', Weekday.Saturday],
    ['SA', Weekday.Saturday],
    ['SY', Weekday.Saturday],
    ['YE', Weekday.Saturday],
    // Sunday
    ['AR', Weekday.Sunday],
    ['BO', Weekday.Sunday],
    ['BR', Weekday.Sunday],
    ['BZ', Weekday.Sunday],
    ['CA', Weekday.Sunday],
    ['CL', Weekday.Sunday],
    ['CO', Weekday.Sunday],
    ['CR', Weekday.Sunday],
    ['DO', Weekday.Sunday],
    ['EC', Weekday.Sunday],
    ['GT', Weekday.Sunday],
    ['HK', Weekday.Sunday],
    ['HN', Weekday.Sunday],
    ['IL', Weekday.Sunday],
    ['JM', Weekday.Sunday],
    ['JP', Weekday.Sunday],
    ['KE', Weekday.Sunday],
    ['KR', Weekday.Sunday],
    ['MO', Weekday.Sunday],
    ['MX', Weekday.Sunday],
    ['NI', Weekday.Sunday],
    ['PA', Weekday.Sunday],
    ['PE', Weekday.Sunday],
    ['PH', Weekday.Sunday],
    ['SG', Weekday.Sunday],
    ['SV', Weekday.Sunday],
    ['TW', Weekday.Sunday],
    ['US', Weekday.Sunday],
    ['VE', Weekday.Sunday],
    ['ZA', Weekday.Sunday],
    ['ZW', Weekday.Sunday],
    // Monday
    ['AD', Weekday.Monday],
    ['AL', Weekday.Monday],
    ['AM', Weekday.Monday],
    ['AU', Weekday.Monday],
    ['AZ', Weekday.Monday],
    ['BE', Weekday.Monday],
    ['BG', Weekday.Monday],
    ['BN', Weekday.Monday],
    ['BY', Weekday.Monday],
    ['CH', Weekday.Monday],
    ['CN', Weekday.Monday],
    ['CZ', Weekday.Monday],
    ['DE', Weekday.Monday],
    ['DK', Weekday.Monday],
    ['EE', Weekday.Monday],
    ['ES', Weekday.Monday],
    ['FI', Weekday.Monday],
    ['FR', Weekday.Monday],
    ['GB', Weekday.Monday],
    ['GE', Weekday.Monday],
    ['GF', Weekday.Monday],
    ['GR', Weekday.Monday],
    ['HR', Weekday.Monday],
    ['HU', Weekday.Monday],
    ['ID', Weekday.Monday],
    ['IE', Weekday.Monday],
    ['IN', Weekday.Monday],
    ['IS', Weekday.Monday],
    ['IT', Weekday.Monday],
    ['KG', Weekday.Monday],
    ['KZ', Weekday.Monday],
    ['LB', Weekday.Monday],
    ['LT', Weekday.Monday],
    ['LU', Weekday.Monday],
    ['LV', Weekday.Monday],
    ['MA', Weekday.Monday],
    ['MC', Weekday.Monday],
    ['MK', Weekday.Monday],
    ['MN', Weekday.Monday],
    ['MY', Weekday.Monday],
    ['NL', Weekday.Monday],
    ['NO', Weekday.Monday],
    ['NZ', Weekday.Monday],
    ['PK', Weekday.Monday],
    ['PL', Weekday.Monday],
    ['PT', Weekday.Monday],
    ['PY', Weekday.Monday],
    ['RO', Weekday.Monday],
    ['RS', Weekday.Monday],
    ['RU', Weekday.Monday],
    ['SE', Weekday.Monday],
    ['SK', Weekday.Monday],
    ['TH', Weekday.Monday],
    ['TN', Weekday.Monday],
    ['TR', Weekday.Monday],
    ['UA', Weekday.Monday],
    ['UY', Weekday.Monday],
    ['UZ', Weekday.Monday],
    ['VN', Weekday.Monday],
    ['XK', Weekday.Monday],
]);
exports.ORDERED_WEEKDAYS = new Map([
    [0, [0, 1, 2, 3, 4, 5, 6]],
    [1, [1, 2, 3, 4, 5, 6, 0]],
    [6, [6, 0, 1, 2, 3, 4, 5]],
]);
exports.DEFAULT_WEEK_START_DAY = Weekday.Sunday;
exports.DEFAULT_ORDERED_WEEKDAYS = [0, 1, 2, 3, 4, 5, 6];
function getWeekStartDay(countryCode) {
    if (!countryCode) {
        return exports.DEFAULT_WEEK_START_DAY;
    }
    return (exports.WEEK_START_DAYS.get(countryCode.toUpperCase()) || exports.DEFAULT_WEEK_START_DAY);
}
exports.getWeekStartDay = getWeekStartDay;
function getOrderedWeekdays(weekStartsOn) {
    var _a;
    return (_a = exports.ORDERED_WEEKDAYS.get(weekStartsOn)) !== null && _a !== void 0 ? _a : exports.DEFAULT_ORDERED_WEEKDAYS;
}
exports.getOrderedWeekdays = getOrderedWeekdays;
function getWeeksForMonth(month, year, weekStartsOn = exports.DEFAULT_WEEK_START_DAY) {
    const firstOfMonth = new Date(year, month, 1);
    const firstDayOfWeek = firstOfMonth.getDay();
    const weeks = [[]];
    let currentWeek = weeks[0];
    let currentDate = firstOfMonth;
    const orderedWeekday = getOrderedWeekdays(weekStartsOn);
    for (let i = 0; i < orderedWeekday.indexOf(firstDayOfWeek); i++) {
        currentWeek.push(undefined);
    }
    while (currentDate.getMonth() === month) {
        if (currentWeek.length === exports.WEEK_LENGTH) {
            currentWeek = [];
            weeks.push(currentWeek);
        }
        currentWeek.push(currentDate);
        currentDate = new Date(year, month, currentDate.getDate() + 1);
    }
    while (currentWeek.length < 7) {
        currentWeek.push(undefined);
    }
    return weeks;
}
exports.getWeeksForMonth = getWeeksForMonth;
function isSameDate(day1, day2) {
    return (day1.getDate() === day2.getDate() &&
        day1.getMonth() === day2.getMonth() &&
        day1.getFullYear() === day2.getFullYear());
}
exports.isSameDate = isSameDate;
function isToday(date) {
    const today = new Date();
    return isSameDate(today, date);
}
exports.isToday = isToday;
function getNextDisplayMonth(month) {
    if (month === 11) {
        return 0;
    }
    return month + 1;
}
exports.getNextDisplayMonth = getNextDisplayMonth;
function getNextDisplayYear(month, year) {
    if (month === 11) {
        return year + 1;
    }
    return year;
}
exports.getNextDisplayYear = getNextDisplayYear;
function getPreviousDisplayMonth(month) {
    if (month === 0) {
        return 11;
    }
    return month - 1;
}
exports.getPreviousDisplayMonth = getPreviousDisplayMonth;
function getPreviousDisplayYear(month, year) {
    if (month === 0) {
        return year - 1;
    }
    return year;
}
exports.getPreviousDisplayYear = getPreviousDisplayYear;
