import { CSSProperties } from 'react';
import { Breakpoint, Responsive } from '@shopify/checkout-ui-extensions';
export declare function useResponsiveValue<T = any>(values: Partial<Record<Breakpoint, T>>): T | undefined;
declare type UseResponsiveStyleOptions = {
    [Property in keyof CSSProperties]?: {
        value?: CSSProperties[Property] | Responsive<CSSProperties[Property]>;
        /**
         * An optional function to transform the value for the current breakpoint.
         */
        transform?: (value: Exclude<CSSProperties[Property], undefined>) => CSSProperties[Property];
    };
};
/**
 * Returns a style object matching the passed one, where each property value
 * is the one that applies to the current viewport size.
 *
 * @param options
 */
export declare function useResponsiveStyle<T = UseResponsiveStyleOptions, U = {
    [key in keyof T]: string;
}>(options: T): U | {};
export declare function maybeResponsiveToArray<T>(maybeResponsive: T | Responsive<T>): [Breakpoint, T][];
export declare function isResponsiveValue(obj: any): boolean;
export {};
